USE [Estate]
GO
/****** Object:  Table [dbo].[Activity_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Activity_List](
	[pk_Activity] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Place] [nvarchar](50) NULL,
	[Target] [nvarchar](100) NULL,
	[Budget] [decimal](18, 3) NULL,
	[Result] [nvarchar](20) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Activity_List] PRIMARY KEY CLUSTERED 
(
	[pk_Activity] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Address_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Address_List](
	[pk_Address] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[NickName] [nvarchar](50) NULL,
	[FullName] [nvarchar](50) NULL,
	[FirstName] [nvarchar](50) NULL,
	[MiddleName] [nvarchar](50) NULL,
	[LastName] [nvarchar](50) NULL,
	[Phone1] [nvarchar](50) NULL,
	[Phone2] [nvarchar](50) NULL,
	[Email1] [nvarchar](100) NULL,
	[Email2] [nvarchar](100) NULL,
	[Fax] [nvarchar](50) NULL,
	[Line] [nvarchar](50) NULL,
	[Wechat] [nvarchar](50) NULL,
	[QQ] [nvarchar](50) NULL,
	[Facebook] [nvarchar](50) NULL,
	[Twitter] [nvarchar](50) NULL,
	[Linkedin] [nvarchar](50) NULL,
	[ZipCode] [nvarchar](50) NULL,
	[Place] [nvarchar](50) NULL,
	[Address1] [nvarchar](500) NULL,
	[Address2] [nvarchar](500) NULL,
	[Sex] [int] NULL,
	[Birthday] [datetime] NULL,
	[Note] [nvarchar](1000) NULL,
	[Feedback] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[IsFolder] [bit] NULL,
	[IsStar] [bit] NULL,
	[ParentID] [int] NULL,
	[Tags] [nvarchar](200) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Address_List] PRIMARY KEY CLUSTERED 
(
	[pk_Address] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Area_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Area_List](
	[pk_Area] [int] IDENTITY(1,1) NOT NULL,
	[ID] [int] NULL,
	[ParentID] [int] NULL,
	[Name] [nvarchar](50) NULL,
 CONSTRAINT [PK_Area_List] PRIMARY KEY CLUSTERED 
(
	[pk_Area] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Attendance_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Attendance_List](
	[pk_Attendance] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Description] [nvarchar](500) NULL,
	[Note] [nvarchar](500) NULL,
	[IPAddress] [nvarchar](50) NULL,
	[Browser] [nvarchar](50) NULL,
	[SessionID] [nvarchar](50) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Attendance_List] PRIMARY KEY CLUSTERED 
(
	[pk_Attendance] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Building_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Building_List](
	[pk_Building] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Unit] [nvarchar](50) NULL,
	[Owners] [nvarchar](10) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Building_List] PRIMARY KEY CLUSTERED 
(
	[pk_Building] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Calendar_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Calendar_List](
	[pk_Calendar] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[IsRemind] [bit] NULL,
	[AdvancedTime] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Calendar_List] PRIMARY KEY CLUSTERED 
(
	[pk_Calendar] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Car_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Car_List](
	[pk_Car] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[fk_Set] [int] NULL,
	[NumberID] [varchar](20) NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](1000) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
	[IsCheck] [bit] NULL,
	[CheckUser] [int] NULL,
	[CheckDate] [datetime] NULL,
	[CheckDepartment] [int] NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[Driver] [nvarchar](10) NULL,
	[Passengers] [nvarchar](100) NULL,
	[Destination] [nvarchar](100) NULL,
	[Mileage] [varchar](20) NULL,
	[IsBack] [bit] NULL,
	[BackDate] [datetime] NULL,
 CONSTRAINT [PK_Car_List] PRIMARY KEY CLUSTERED 
(
	[pk_Car] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Car_Set]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Car_Set](
	[pk_Set] [int] IDENTITY(1,1) NOT NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](1000) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[BuyDate] [datetime] NULL,
	[IsUse] [bit] NULL,
	[Mileage] [varchar](20) NULL,
	[LastMaintenance] [datetime] NULL,
 CONSTRAINT [PK_Car_Set] PRIMARY KEY CLUSTERED 
(
	[pk_Set] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Community_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Community_List](
	[pk_Community] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Address] [nvarchar](200) NULL,
	[Area] [nvarchar](20) NULL,
	[Developers] [nvarchar](50) NULL,
	[EstateCompany] [nvarchar](50) NULL,
	[GreeningRate] [nvarchar](10) NULL,
	[Buildings] [nvarchar](10) NULL,
	[Owners] [nvarchar](10) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Community_List] PRIMARY KEY CLUSTERED 
(
	[pk_Community] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Complain_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Complain_List](
	[pk_Complain] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](50) NULL,
	[Description] [nvarchar](500) NULL,
	[Note] [nvarchar](500) NULL,
	[Name] [nvarchar](20) NULL,
	[Contact] [nvarchar](20) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Complain_List] PRIMARY KEY CLUSTERED 
(
	[pk_Complain] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Customer_Follow]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Customer_Follow](
	[pk_Follow] [int] IDENTITY(1,1) NOT NULL,
	[fk_Customer] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[FollowDate] [datetime] NULL,
	[NextFollow] [datetime] NULL,
	[Remark] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Customer_Follow] PRIMARY KEY CLUSTERED 
(
	[pk_Follow] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Customer_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Customer_List](
	[pk_Customer] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[CustomerType] [nvarchar](50) NULL,
	[CustomerLevel] [nvarchar](10) NULL,
	[CustomerProperty] [nvarchar](50) NULL,
	[CustomerState] [nvarchar](50) NULL,
	[CustomerSource] [nvarchar](50) NULL,
	[Industry] [nvarchar](50) NULL,
	[Nature] [nvarchar](50) NULL,
	[EmployeNum] [nvarchar](50) NULL,
	[License] [nvarchar](100) NULL,
	[Tags] [nvarchar](200) NULL,
	[Contact] [nvarchar](50) NULL,
	[Website] [nvarchar](100) NULL,
	[Email] [nvarchar](100) NULL,
	[TEL] [nvarchar](50) NULL,
	[Mobile] [nvarchar](50) NULL,
	[Fax] [nvarchar](50) NULL,
	[Wechat] [nvarchar](50) NULL,
	[QQ] [nvarchar](50) NULL,
	[Wangwang] [nvarchar](50) NULL,
	[Weibo] [nvarchar](50) NULL,
	[ZipCode] [nvarchar](50) NULL,
	[Country] [nvarchar](50) NULL,
	[Province] [nvarchar](50) NULL,
	[City] [nvarchar](50) NULL,
	[County] [nvarchar](50) NULL,
	[Address] [nvarchar](500) NULL,
	[Remark] [nvarchar](500) NULL,
	[Description] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[IsStar] [bit] NULL,
	[IsAlert] [bit] NULL,
	[AlertDate] [datetime] NULL,
	[AlertInfo] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Customer_List] PRIMARY KEY CLUSTERED 
(
	[pk_Customer] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Device_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Device_List](
	[pk_Device] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Brand] [nvarchar](50) NULL,
	[Price] [decimal](18, 3) NULL,
	[Qty] [int] NULL,
	[BuyDate] [datetime] NULL,
	[UseTime] [int] NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Device_List] PRIMARY KEY CLUSTERED 
(
	[pk_Device] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Document_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Document_List](
	[pk_Document] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[Feedback] [nvarchar](max) NULL,
	[DocumentType] [int] NULL,
	[FileName] [nvarchar](100) NULL,
	[FilePath] [nvarchar](200) NULL,
	[FileType] [nvarchar](10) NULL,
	[FileSize] [int] NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[IsFolder] [bit] NULL,
	[ParentID] [int] NULL,
	[Tags] [nvarchar](200) NULL,
	[Downloads] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Document_List] PRIMARY KEY CLUSTERED 
(
	[pk_Document] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Epidemic_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Epidemic_List](
	[pk_Epidemic] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[FullName] [nvarchar](50) NULL,
	[CellPhone] [nvarchar](50) NULL,
	[IDNumber] [nvarchar](50) NULL,
	[CarNumber] [nvarchar](50) NULL,
	[Address] [nvarchar](200) NULL,
	[Sex] [int] NULL,
	[Age] [int] NULL,
	[BodyTemp] [decimal](18, 3) NULL,
	[IsMask] [bit] NULL,
	[MaskRemark] [nvarchar](100) NULL,
	[WhyOut] [nvarchar](200) NULL,
	[OutAddress] [nvarchar](200) NULL,
	[Tracker] [nvarchar](500) NULL,
	[TouchInfo] [nvarchar](500) NULL,
	[WhyIn] [nvarchar](200) NULL,
	[SourceInfo] [nvarchar](500) NULL,
	[IsHealth] [bit] NULL,
	[IsEpidemicArea] [bit] NULL,
	[Remark] [nvarchar](500) NULL,
	[IPAddress] [nvarchar](50) NULL,
	[Token] [nvarchar](50) NULL,
	[Handle] [nvarchar](50) NULL,
	[HandleTime] [datetime] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Epidemic_List] PRIMARY KEY CLUSTERED 
(
	[pk_Epidemic] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Fee_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Fee_List](
	[pk_Fee] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[fk_Owner] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Description] [nvarchar](500) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[Amount1] [decimal](18, 3) NULL,
	[Amount2] [decimal](18, 3) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Fee_List] PRIMARY KEY CLUSTERED 
(
	[pk_Fee] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Fee_Meter]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Fee_Meter](
	[pk_Meter] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_Building] [int] NULL,
	[fk_House] [int] NULL,
	[fk_Owner] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](50) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[Degree1] [decimal](18, 3) NULL,
	[Degree2] [decimal](18, 3) NULL,
	[CheckDate1] [datetime] NULL,
	[CheckDate2] [datetime] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Fee_Meter] PRIMARY KEY CLUSTERED 
(
	[pk_Meter] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Finance_Account]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Finance_Account](
	[pk_Account] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[AccountName] [nvarchar](100) NULL,
	[Owner] [nvarchar](50) NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](500) NULL,
	[Note] [nvarchar](500) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Finance_Account] PRIMARY KEY CLUSTERED 
(
	[pk_Account] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Finance_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Finance_List](
	[pk_Finance] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[fk_Account] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](1000) NULL,
	[Note] [nvarchar](1000) NULL,
	[HandleName] [nvarchar](50) NULL,
	[HandleDate] [datetime] NULL,
	[Amount] [decimal](18, 4) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Finance_List] PRIMARY KEY CLUSTERED 
(
	[pk_Finance] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Forum_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Forum_List](
	[pk_Forum] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[IsStar] [bit] NULL,
	[IsTop] [bit] NULL,
	[IsVote] [bit] NULL,
	[ParentID] [int] NULL,
	[SortID] [int] NULL,
	[IsReply] [bit] NULL,
	[LastReplyUser] [int] NULL,
	[LastReply] [datetime] NULL,
	[Replies] [int] NULL,
	[Clicks] [int] NULL,
	[Likes] [int] NULL,
	[Tags] [nvarchar](200) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Forum_List] PRIMARY KEY CLUSTERED 
(
	[pk_Forum] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Forum_Vote]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Forum_Vote](
	[pk_Vote] [int] IDENTITY(1,1) NOT NULL,
	[fk_Forum] [int] NULL,
	[Title] [nvarchar](200) NULL,
	[SortID] [int] NULL,
	[Visual] [varchar](10) NULL,
	[UserList] [nvarchar](max) NULL,
	[Votes] [int] NULL,
 CONSTRAINT [PK_Forum_Vote] PRIMARY KEY CLUSTERED 
(
	[pk_Vote] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[House_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[House_List](
	[pk_House] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_Building] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Owner] [nvarchar](20) NULL,
	[Contact] [nvarchar](50) NULL,
	[Floor] [nvarchar](10) NULL,
	[Rooms] [nvarchar](20) NULL,
	[Area1] [decimal](18, 3) NULL,
	[Area2] [decimal](18, 3) NULL,
	[Fee] [decimal](18, 3) NULL,
	[StartDate] [datetime] NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_House_List] PRIMARY KEY CLUSTERED 
(
	[pk_House] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Mail_Account]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Mail_Account](
	[pk_Account] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[AccountName] [nvarchar](100) NULL,
	[DisplayName] [nvarchar](50) NULL,
	[PopHost] [varchar](100) NULL,
	[Port] [int] NULL,
	[UseSSL] [bit] NULL,
	[SmtpHost] [varchar](100) NULL,
	[SmtpPort] [int] NULL,
	[LoginName] [varchar](100) NULL,
	[Password] [varchar](100) NULL,
	[SmtpPwd] [varchar](100) NULL,
	[SmtpUser] [varchar](100) NULL,
	[SmtpUseSSL] [bit] NULL,
	[Signature] [nvarchar](1000) NULL,
	[Note] [nvarchar](500) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Mail_Account] PRIMARY KEY CLUSTERED 
(
	[pk_Account] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Mail_Attachment]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Mail_Attachment](
	[pk_Attachment] [int] IDENTITY(1,1) NOT NULL,
	[FileName] [nvarchar](100) NULL,
	[FilePath] [nvarchar](200) NULL,
	[FileType] [nvarchar](10) NULL,
	[FileSize] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
 CONSTRAINT [PK_Mail_Attachment] PRIMARY KEY CLUSTERED 
(
	[pk_Attachment] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Mail_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Mail_List](
	[pk_Mail] [int] IDENTITY(1,1) NOT NULL,
	[fk_Account] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[ParentID] [int] NULL,
	[MailType] [int] NULL,
	[MailFrom] [nvarchar](100) NULL,
	[MailTo] [nvarchar](2000) NULL,
	[MailCc] [nvarchar](2000) NULL,
	[MailBcc] [nvarchar](2000) NULL,
	[Subject] [nvarchar](200) NULL,
	[Body] [nvarchar](max) NULL,
	[IsBodyHtml] [bit] NULL,
	[IsInternal] [bit] NULL,
	[IsSent] [bit] NULL,
	[SentDate] [datetime] NULL,
	[IsStar] [bit] NULL,
	[IsAttachment] [bit] NULL,
	[AttachmentList] [nvarchar](500) NULL,
	[IsForward] [bit] NULL,
	[IsRead] [bit] NULL,
	[ReadDate] [datetime] NULL,
	[Priority] [int] NULL,
	[IsReply] [bit] NULL,
	[ReplyDate] [datetime] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Mail_List] PRIMARY KEY CLUSTERED 
(
	[pk_Mail] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Memo_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Memo_List](
	[pk_Memo] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[IsStar] [bit] NULL,
	[Tags] [nvarchar](200) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Memo_List] PRIMARY KEY CLUSTERED 
(
	[pk_Memo] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Note_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Note_List](
	[pk_Note] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[Feedback] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[IsFolder] [bit] NULL,
	[IsStar] [bit] NULL,
	[ParentID] [int] NULL,
	[Tags] [nvarchar](200) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Note_List] PRIMARY KEY CLUSTERED 
(
	[pk_Note] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Notice_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Notice_List](
	[pk_Notice] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[IsTop] [bit] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Notice_List] PRIMARY KEY CLUSTERED 
(
	[pk_Notice] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Notice_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Notice_Receiver](
	[pk_Receiver] [int] IDENTITY(1,1) NOT NULL,
	[fk_Notice] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[IsRead] [bit] NULL,
	[ReadDate] [datetime] NULL,
 CONSTRAINT [PK_Notice_Receiver] PRIMARY KEY CLUSTERED 
(
	[pk_Receiver] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Owner_Car]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Owner_Car](
	[pk_Car] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[fk_Owner] [int] NULL,
	[fk_Parking] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[PlateNumber] [nvarchar](50) NULL,
	[Color] [nvarchar](50) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Owner_Car] PRIMARY KEY CLUSTERED 
(
	[pk_Car] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Owner_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Owner_List](
	[pk_Owner] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[ParentID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Contact] [nvarchar](50) NULL,
	[Sex] [int] NULL,
	[Birthday] [datetime] NULL,
	[IDNumber] [nvarchar](50) NULL,
	[SocialMedia] [nvarchar](50) NULL,
	[Job] [nvarchar](50) NULL,
	[Address] [nvarchar](50) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[IsLogin] [bit] NULL,
	[Password] [nvarchar](50) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Owner_List] PRIMARY KEY CLUSTERED 
(
	[pk_Owner] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Parking_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Parking_List](
	[pk_Parking] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_Building] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Owner] [nvarchar](20) NULL,
	[Contact] [nvarchar](50) NULL,
	[Floor] [nvarchar](10) NULL,
	[Area] [decimal](18, 3) NULL,
	[Rent] [decimal](18, 3) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Parking_List] PRIMARY KEY CLUSTERED 
(
	[pk_Parking] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Plan_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Plan_List](
	[pk_Plan] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[Feedback] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Plan_List] PRIMARY KEY CLUSTERED 
(
	[pk_Plan] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Process_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Process_List](
	[pk_Process] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](1000) NULL,
	[Note] [nvarchar](1000) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
	[IsCheck] [bit] NULL,
	[CheckUser] [int] NULL,
	[CheckDate] [datetime] NULL,
	[CheckDepartment] [int] NULL,
	[AtUser] [nvarchar](500) NULL,
	[Tags] [nvarchar](200) NULL,
	[ParentID] [int] NULL,
 CONSTRAINT [PK_Process_List] PRIMARY KEY CLUSTERED 
(
	[pk_Process] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Repair_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Repair_List](
	[pk_Repair] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](50) NULL,
	[Description] [nvarchar](500) NULL,
	[Note] [nvarchar](500) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Repair_List] PRIMARY KEY CLUSTERED 
(
	[pk_Repair] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Role_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Role_List](
	[pk_Role] [int] IDENTITY(1,1) NOT NULL,
	[fk_RoleName] [int] NULL,
	[fk_Menu] [int] NULL,
	[IsUse] [bit] NULL,
	[IsAdmin] [bit] NULL,
	[PowerList] [nvarchar](500) NULL,
	[fk_Company] [int] NULL,
 CONSTRAINT [PK_Role_List] PRIMARY KEY CLUSTERED 
(
	[pk_Role] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Role_Name]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Role_Name](
	[pk_Name] [int] IDENTITY(1,1) NOT NULL,
	[RoleName_CHS] [nvarchar](50) NULL,
	[RoleName_CHT] [nvarchar](50) NULL,
	[RoleName_EN] [nvarchar](50) NULL,
	[PowerValue] [int] NULL,
	[fk_Company] [int] NULL,
 CONSTRAINT [PK_Role_Name] PRIMARY KEY CLUSTERED 
(
	[pk_Name] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Role_Power]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Role_Power](
	[pk_Power] [int] IDENTITY(1,1) NOT NULL,
	[ValueName_CHS] [nvarchar](50) NULL,
	[ValueName_CHT] [nvarchar](50) NULL,
	[ValueName_EN] [nvarchar](50) NULL,
	[ValueKey] [int] NULL,
	[SortID] [int] NULL,
 CONSTRAINT [PK_Role_Power] PRIMARY KEY CLUSTERED 
(
	[pk_Power] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Shop_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Shop_List](
	[pk_Shop] [int] IDENTITY(1,1) NOT NULL,
	[fk_Community] [int] NULL,
	[fk_Building] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Owner] [nvarchar](20) NULL,
	[Contact] [nvarchar](50) NULL,
	[Floor] [nvarchar](10) NULL,
	[Area1] [decimal](18, 3) NULL,
	[Area2] [decimal](18, 3) NULL,
	[Fee] [decimal](18, 3) NULL,
	[Rent] [decimal](18, 3) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Description] [nvarchar](500) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Shop_List] PRIMARY KEY CLUSTERED 
(
	[pk_Shop] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_City]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_City](
	[pk_City] [int] IDENTITY(1,1) NOT NULL,
	[fk_Province] [int] NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[Visible] [bit] NULL,
 CONSTRAINT [PK_Sys_City] PRIMARY KEY CLUSTERED 
(
	[pk_City] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_Country]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_Country](
	[pk_Country] [int] IDENTITY(1,1) NOT NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[Visible] [bit] NULL,
 CONSTRAINT [PK_Sys_Country] PRIMARY KEY CLUSTERED 
(
	[pk_Country] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_Currency]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_Currency](
	[pk_Currency] [int] IDENTITY(1,1) NOT NULL,
	[C_ID] [int] NULL,
	[C_Sign] [nvarchar](5) NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[Visible] [bit] NULL,
 CONSTRAINT [PK_Sys_Currency] PRIMARY KEY CLUSTERED 
(
	[pk_Currency] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_Express]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_Express](
	[pk_Express] [int] IDENTITY(1,1) NOT NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[Website] [nvarchar](100) NULL,
	[Url] [nvarchar](200) NULL,
	[Freight] [money] NULL,
	[Visible] [bit] NULL,
 CONSTRAINT [PK_Sys_Express] PRIMARY KEY CLUSTERED 
(
	[pk_Express] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_Menu]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_Menu](
	[pk_Menu] [int] IDENTITY(1,1) NOT NULL,
	[ParentID] [int] NULL,
	[Name_CHS] [nvarchar](50) NULL,
	[Name_CHT] [nvarchar](50) NULL,
	[Name_EN] [nvarchar](50) NULL,
	[Url] [nvarchar](200) NULL,
	[Icon] [nvarchar](50) NULL,
	[SortID] [int] NULL,
	[LevelID] [int] NULL,
	[TypeID] [int] NULL,
	[Visible] [bit] NULL,
	[Tag_CHS] [nvarchar](200) NULL,
	[Tag_CHT] [nvarchar](200) NULL,
	[Tag_EN] [nvarchar](200) NULL,
 CONSTRAINT [PK_Sys_Menu] PRIMARY KEY CLUSTERED 
(
	[pk_Menu] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_Province]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_Province](
	[pk_Province] [int] IDENTITY(1,1) NOT NULL,
	[fk_Country] [int] NULL,
	[FullName] [nvarchar](100) NULL,
	[ShortName] [nvarchar](10) NULL,
	[Visible] [bit] NULL,
 CONSTRAINT [PK_Sys_Province] PRIMARY KEY CLUSTERED 
(
	[pk_Province] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_StatusID]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_StatusID](
	[pk_StatusID] [int] IDENTITY(1,1) NOT NULL,
	[StatusName_CHS] [nvarchar](20) NULL,
	[StatusName_CHT] [nvarchar](20) NULL,
	[StatusName_EN] [nvarchar](20) NULL,
	[ID] [int] NULL,
	[Visual] [varchar](10) NULL,
	[TableName] [varchar](20) NULL,
	[Description_CHS] [nvarchar](1000) NULL,
	[Description_CHT] [nvarchar](1000) NULL,
	[Description_EN] [nvarchar](1000) NULL,
 CONSTRAINT [PK_Sys_StatusID] PRIMARY KEY CLUSTERED 
(
	[pk_StatusID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Sys_TypeID]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Sys_TypeID](
	[pk_TypeID] [int] IDENTITY(1,1) NOT NULL,
	[TypeName_CHS] [nvarchar](20) NULL,
	[TypeName_CHT] [nvarchar](20) NULL,
	[TypeName_EN] [nvarchar](20) NULL,
	[ID] [int] NULL,
	[Visual] [varchar](10) NULL,
	[TableName] [varchar](20) NULL,
	[Description_CHS] [nvarchar](1000) NULL,
	[Description_CHT] [nvarchar](1000) NULL,
	[Description_EN] [nvarchar](1000) NULL,
 CONSTRAINT [PK_Sys_TypeID] PRIMARY KEY CLUSTERED 
(
	[pk_TypeID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Task_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Task_List](
	[pk_Task] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[Note] [nvarchar](1000) NULL,
	[Feedback] [nvarchar](max) NULL,
	[ImagePath] [nvarchar](200) NULL,
	[FilePath] [nvarchar](200) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Url] [nvarchar](200) NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[IsComplete] [bit] NULL,
	[CompleteDate] [datetime] NULL,
	[IsCancel] [bit] NULL,
	[CancelDate] [datetime] NULL,
	[IsTop] [bit] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Task_List] PRIMARY KEY CLUSTERED 
(
	[pk_Task] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Task_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Task_Receiver](
	[pk_Receiver] [int] IDENTITY(1,1) NOT NULL,
	[fk_Task] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[IsRead] [bit] NULL,
	[ReadDate] [datetime] NULL,
	[IsReceive] [bit] NULL,
	[ReceiveDate] [datetime] NULL,
	[StatusID] [int] NULL,
 CONSTRAINT [PK_Task_Receiver] PRIMARY KEY CLUSTERED 
(
	[pk_Receiver] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[User_Department]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[User_Department](
	[pk_Department] [int] IDENTITY(1,1) NOT NULL,
	[DepartmentName] [nvarchar](50) NULL,
	[Phone1] [nvarchar](50) NULL,
	[Phone2] [nvarchar](50) NULL,
	[Fax] [nvarchar](50) NULL,
	[Email] [nvarchar](100) NULL,
	[Address] [nvarchar](500) NULL,
	[ParentID] [int] NULL,
	[LevelID] [int] NULL,
	[SortID] [int] NULL,
	[TypeID] [int] NULL,
	[Province] [int] NULL,
	[City] [int] NULL,
	[County] [int] NULL,
	[Zone] [int] NULL,
	[Manager] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
	[Monday] [nvarchar](50) NULL,
	[Tuesday] [nvarchar](50) NULL,
	[Wednesday] [nvarchar](50) NULL,
	[Thursday] [nvarchar](50) NULL,
	[Friday] [nvarchar](50) NULL,
	[Saturday] [nvarchar](50) NULL,
	[Sunday] [nvarchar](50) NULL,
 CONSTRAINT [PK_User_Branch] PRIMARY KEY CLUSTERED 
(
	[pk_Department] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[User_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[User_List](
	[pk_User] [int] IDENTITY(1,1) NOT NULL,
	[UserName] [nvarchar](100) NULL,
	[Password] [nvarchar](100) NULL,
	[TypeID] [int] NULL,
	[fk_Department] [int] NULL,
	[RoleValue] [int] NULL,
	[RoleList] [nvarchar](200) NULL,
	[Position] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Skin] [nvarchar](50) NULL,
	[Language] [varchar](10) NULL,
	[IsLock] [bit] NULL,
	[LastLoginIP] [nvarchar](50) NULL,
	[LastLoginTime] [datetime] NULL,
	[NickName] [nvarchar](50) NULL,
	[FullName] [nvarchar](50) NULL,
	[FirstName] [nvarchar](50) NULL,
	[MiddleName] [nvarchar](50) NULL,
	[LastName] [nvarchar](50) NULL,
	[Phone1] [nvarchar](50) NULL,
	[Phone2] [nvarchar](50) NULL,
	[Email1] [nvarchar](100) NULL,
	[Email2] [nvarchar](100) NULL,
	[Fax] [nvarchar](50) NULL,
	[Line] [nvarchar](50) NULL,
	[Wechat] [nvarchar](50) NULL,
	[QQ] [nvarchar](50) NULL,
	[Facebook] [nvarchar](50) NULL,
	[Twitter] [nvarchar](50) NULL,
	[Linkedin] [nvarchar](50) NULL,
	[ZipCode] [nvarchar](50) NULL,
	[Place] [nvarchar](50) NULL,
	[Address1] [nvarchar](500) NULL,
	[Address2] [nvarchar](500) NULL,
	[Province] [int] NULL,
	[City] [int] NULL,
	[County] [int] NULL,
	[Zone] [int] NULL,
	[Sex] [int] NULL,
	[Height] [int] NULL,
	[Weight] [int] NULL,
	[Birthday] [datetime] NULL,
	[Education] [nvarchar](50) NULL,
	[School] [nvarchar](50) NULL,
	[ImagePath1] [nvarchar](200) NULL,
	[ImagePath2] [nvarchar](200) NULL,
	[IDCardPath] [nvarchar](200) NULL,
	[ResumePath] [nvarchar](200) NULL,
	[Wages] [decimal](18, 3) NULL,
	[BankAccount] [nvarchar](100) NULL,
	[IDNumber] [nvarchar](50) NULL,
	[Source] [nvarchar](100) NULL,
	[Note] [nvarchar](500) NULL,
	[Remark] [nvarchar](500) NULL,
	[EntryTime] [datetime] NULL,
	[IsQuit] [bit] NULL,
	[QuitTime] [datetime] NULL,
	[ShowHistory] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_User_List] PRIMARY KEY CLUSTERED 
(
	[pk_User] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[User_Log]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[User_Log](
	[pk_Log] [int] IDENTITY(1,1) NOT NULL,
	[IPAddress] [nvarchar](50) NULL,
	[Url] [nvarchar](200) NULL,
	[fk_User] [int] NULL,
	[Browser] [nvarchar](50) NULL,
	[TypeID] [int] NULL,
	[LogTime] [datetime] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[SessionID] [nvarchar](50) NULL,
	[fk_Company] [int] NULL,
 CONSTRAINT [PK_User_Log] PRIMARY KEY CLUSTERED 
(
	[pk_Log] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[User_Online]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[User_Online](
	[pk_Online] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[SessionID] [nvarchar](50) NULL,
	[IPAddress] [nvarchar](50) NULL,
	[Browser] [nvarchar](50) NULL,
	[TypeID] [int] NULL,
	[LoginTime] [datetime] NULL,
	[fk_Company] [int] NULL,
 CONSTRAINT [PK_User_Online] PRIMARY KEY CLUSTERED 
(
	[pk_Online] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[User_Position]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[User_Position](
	[pk_Position] [int] IDENTITY(1,1) NOT NULL,
	[Title] [nvarchar](100) NULL,
	[ParentID] [int] NULL,
	[LevelID] [int] NULL,
	[SortID] [int] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_User_Position] PRIMARY KEY CLUSTERED 
(
	[pk_Position] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Attachment]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Attachment](
	[pk_Attachment] [int] IDENTITY(1,1) NOT NULL,
	[fk_Workflow] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](500) NULL,
	[FileName] [nvarchar](100) NULL,
	[FilePath] [nvarchar](200) NULL,
	[FileType] [nvarchar](10) NULL,
	[FileSize] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Attachment] PRIMARY KEY CLUSTERED 
(
	[pk_Attachment] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_List](
	[pk_Workflow] [int] IDENTITY(1,1) NOT NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[fk_Template] [int] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[CurrentStepID] [int] NULL,
	[NextStepID] [int] NULL,
	[Number] [nvarchar](50) NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](max) NULL,
	[fk_Company] [int] NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[NotifyUser] [nvarchar](1000) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_List] PRIMARY KEY CLUSTERED 
(
	[pk_Workflow] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Log]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Log](
	[pk_Log] [int] IDENTITY(1,1) NOT NULL,
	[fk_Workflow] [int] NULL,
	[fk_Step] [int] NULL,
	[OldDescription] [nvarchar](max) NULL,
	[Description] [nvarchar](max) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Log] PRIMARY KEY CLUSTERED 
(
	[pk_Log] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Receiver](
	[pk_Receiver] [int] IDENTITY(1,1) NOT NULL,
	[fk_Workflow] [int] NULL,
	[fk_Template] [int] NULL,
	[fk_Step] [int] NULL,
	[fk_Signature] [int] NULL,
	[fk_User] [int] NULL,
	[fk_Department] [int] NULL,
	[IsCheck] [bit] NULL,
	[CheckDate] [datetime] NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Note] [nvarchar](1000) NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Receiver] PRIMARY KEY CLUSTERED 
(
	[pk_Receiver] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Signature]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Signature](
	[pk_Signature] [int] IDENTITY(1,1) NOT NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[TypeID] [int] NULL,
	[StatusID] [int] NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](500) NULL,
	[Password] [nvarchar](50) NULL,
	[FileName] [nvarchar](100) NULL,
	[FilePath] [nvarchar](200) NULL,
	[FileType] [nvarchar](10) NULL,
	[FileSize] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Signature] PRIMARY KEY CLUSTERED 
(
	[pk_Signature] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Step]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Step](
	[pk_Step] [int] IDENTITY(1,1) NOT NULL,
	[fk_Template] [int] NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Title] [nvarchar](100) NULL,
	[Description] [nvarchar](500) NULL,
	[SortID] [int] NULL,
	[IsCounterSign] [bit] NULL,
	[fk_Company] [int] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Step] PRIMARY KEY CLUSTERED 
(
	[pk_Step] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Workflow_Template]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Workflow_Template](
	[pk_Template] [int] IDENTITY(1,1) NOT NULL,
	[TemplateName] [nvarchar](100) NULL,
	[UserList] [nvarchar](1000) NULL,
	[DepartmentList] [nvarchar](1000) NULL,
	[RoleList] [nvarchar](1000) NULL,
	[Description] [nvarchar](max) NULL,
	[ParentID] [int] NULL,
	[SortID] [int] NULL,
	[Visible] [bit] NULL,
	[fk_Company] [int] NULL,
	[IsStepFree] [bit] NULL,
	[CreateUser] [int] NULL,
	[CreateDate] [datetime] NULL,
	[ModifyUser] [int] NULL,
	[ModifyDate] [datetime] NULL,
 CONSTRAINT [PK_Workflow_Template] PRIMARY KEY CLUSTERED 
(
	[pk_Template] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  View [dbo].[View_User_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_User_List]
AS
SELECT     dbo.User_List.pk_User, dbo.User_List.UserName, dbo.User_List.Password, dbo.User_List.TypeID, dbo.User_List.fk_Department, 
                      dbo.User_List.RoleValue, dbo.User_List.RoleList, dbo.User_List.Position, dbo.User_List.Number, dbo.User_List.Skin, dbo.User_List.Language, 
                      dbo.User_List.IsLock, dbo.User_List.LastLoginIP, dbo.User_List.LastLoginTime, dbo.User_List.NickName, dbo.User_List.FullName, 
                      dbo.User_List.FirstName, dbo.User_List.MiddleName, dbo.User_List.LastName, dbo.User_List.Phone1, dbo.User_List.Phone2, dbo.User_List.Email1, 
                      dbo.User_List.Email2, dbo.User_List.Fax, dbo.User_List.Line, dbo.User_List.Wechat, dbo.User_List.QQ, dbo.User_List.Facebook, 
                      dbo.User_List.Twitter, dbo.User_List.Linkedin, dbo.User_List.ZipCode, dbo.User_List.Place, dbo.User_List.Address1, dbo.User_List.Address2, 
                      dbo.User_List.Province, dbo.User_List.City, dbo.User_List.County, dbo.User_List.Zone, dbo.User_List.Sex, dbo.User_List.Height, 
                      dbo.User_List.Weight, dbo.User_List.Birthday, dbo.User_List.Education, dbo.User_List.School, dbo.User_List.ImagePath1, dbo.User_List.ImagePath2, 
                      dbo.User_List.IDCardPath, dbo.User_List.ResumePath, dbo.User_List.Wages, dbo.User_List.BankAccount, dbo.User_List.IDNumber, 
                      dbo.User_List.Source, dbo.User_List.Note, dbo.User_List.Remark, dbo.User_List.EntryTime, dbo.User_List.IsQuit, dbo.User_List.QuitTime, 
                      dbo.User_List.fk_Company, dbo.User_List.CreateUser, dbo.User_List.CreateDate, dbo.User_List.ModifyUser, dbo.User_List.ModifyDate, 
                      dbo.User_Department.DepartmentName, dbo.Role_Name.RoleName_CHS
FROM         dbo.User_List LEFT OUTER JOIN
                      dbo.Role_Name ON dbo.User_List.RoleValue = dbo.Role_Name.pk_Name LEFT OUTER JOIN
                      dbo.User_Department ON dbo.User_List.fk_Department = dbo.User_Department.pk_Department
GO
/****** Object:  View [dbo].[View_Notice_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Notice_List]
AS
SELECT     dbo.Notice_List.pk_Notice, dbo.Notice_List.fk_User, dbo.Notice_List.fk_Department, dbo.Notice_List.TypeID, dbo.Notice_List.StatusID, 
                      dbo.Notice_List.Title, dbo.Notice_List.Description, dbo.Notice_List.Note, dbo.Notice_List.ImagePath, dbo.Notice_List.FilePath, 
                      dbo.Notice_List.UserList, dbo.Notice_List.DepartmentList, dbo.Notice_List.RoleList, dbo.Notice_List.Url, dbo.Notice_List.StartDate, 
                      dbo.Notice_List.EndDate, dbo.Notice_List.IsTop, dbo.Notice_List.fk_Company, dbo.Notice_List.CreateUser, dbo.Notice_List.CreateDate, 
                      dbo.Notice_List.ModifyUser, dbo.Notice_List.ModifyDate, dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName
FROM         dbo.Notice_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Notice_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Note_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Note_List]
AS
SELECT     dbo.Note_List.pk_Note, dbo.Note_List.fk_User, dbo.Note_List.fk_Department, dbo.Note_List.TypeID, dbo.Note_List.StatusID, dbo.Note_List.Title, 
                      dbo.Note_List.Description, dbo.Note_List.Note, dbo.Note_List.Feedback, dbo.Note_List.ImagePath, dbo.Note_List.FilePath, dbo.Note_List.UserList, 
                      dbo.Note_List.DepartmentList, dbo.Note_List.RoleList, dbo.Note_List.Url, dbo.Note_List.IsFolder, dbo.Note_List.IsStar, dbo.Note_List.ParentID, 
                      dbo.Note_List.Tags, dbo.Note_List.fk_Company, dbo.Note_List.CreateUser, dbo.Note_List.CreateDate, dbo.Note_List.ModifyUser, 
                      dbo.Note_List.ModifyDate, dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName, '|' + dbo.Note_List.UserList + '|' AS UserList2, 
                      Note_List_1.Title AS ParentName
FROM         dbo.Note_List LEFT OUTER JOIN
                      dbo.Note_List AS Note_List_1 ON dbo.Note_List.ParentID = Note_List_1.pk_Note LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Note_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Document_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Document_List]
AS
SELECT     dbo.Document_List.pk_Document, dbo.Document_List.fk_User, dbo.Document_List.fk_Department, dbo.Document_List.TypeID, 
                      dbo.Document_List.StatusID, dbo.Document_List.Title, dbo.Document_List.Description, dbo.Document_List.Note, dbo.Document_List.Feedback, 
                      dbo.Document_List.DocumentType, dbo.Document_List.FileName, dbo.Document_List.FilePath, dbo.Document_List.FileType, 
                      dbo.Document_List.FileSize, dbo.Document_List.UserList, dbo.Document_List.DepartmentList, dbo.Document_List.RoleList, dbo.Document_List.Url, 
                      dbo.Document_List.IsFolder, dbo.Document_List.ParentID, dbo.Document_List.Tags, dbo.Document_List.Downloads, dbo.Document_List.fk_Company, 
                      dbo.Document_List.CreateUser, dbo.Document_List.CreateDate, dbo.Document_List.ModifyUser, dbo.Document_List.ModifyDate, 
                      dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName, '|' + dbo.Document_List.UserList + '|' AS UserList2
FROM         dbo.Document_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Document_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Address_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Address_List]
AS
SELECT     dbo.Address_List.pk_Address, dbo.Address_List.fk_User, dbo.Address_List.fk_Department, dbo.Address_List.TypeID, dbo.Address_List.StatusID, dbo.Address_List.NickName, 
                      dbo.Address_List.FullName AS Contact, dbo.Address_List.FirstName, dbo.Address_List.MiddleName, dbo.Address_List.LastName, dbo.Address_List.Phone1, dbo.Address_List.Phone2, 
                      dbo.Address_List.Email1, dbo.Address_List.Email2, dbo.Address_List.Fax, dbo.Address_List.Line, dbo.Address_List.Wechat, dbo.Address_List.QQ, dbo.Address_List.Facebook, 
                      dbo.Address_List.Twitter, dbo.Address_List.Linkedin, dbo.Address_List.ZipCode, dbo.Address_List.Place, dbo.Address_List.Address1, dbo.Address_List.Address2, dbo.Address_List.Sex, 
                      dbo.Address_List.Birthday, dbo.Address_List.Note, dbo.Address_List.Feedback, dbo.Address_List.ImagePath, dbo.Address_List.FilePath, dbo.Address_List.UserList, 
                      dbo.Address_List.DepartmentList, dbo.Address_List.RoleList, dbo.Address_List.Url, dbo.Address_List.IsFolder, dbo.Address_List.IsStar, dbo.Address_List.ParentID, dbo.Address_List.Tags, 
                      dbo.Address_List.fk_Company, dbo.Address_List.CreateUser, dbo.Address_List.CreateDate, dbo.Address_List.ModifyUser, dbo.Address_List.ModifyDate, dbo.View_User_List.FullName, 
                      dbo.View_User_List.DepartmentName, '|' + dbo.Address_List.UserList + '|' AS UserList2, Address_List_1.FullName AS ParentName, dbo.Customer_List.FullName AS Customer
FROM         dbo.Address_List LEFT OUTER JOIN
                      dbo.Customer_List ON dbo.Address_List.fk_Company = dbo.Customer_List.pk_Customer LEFT OUTER JOIN
                      dbo.Address_List AS Address_List_1 ON dbo.Address_List.ParentID = Address_List_1.pk_Address LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Address_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Car_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Car_List]
AS
SELECT     dbo.Car_List.*, dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName, View_User_List_1.FullName AS CheckFullName, dbo.Car_Set.Title AS CarTitle
FROM         dbo.Car_List LEFT OUTER JOIN
                      dbo.Car_Set ON dbo.Car_List.fk_Set = dbo.Car_Set.pk_Set LEFT OUTER JOIN
                      dbo.View_User_List AS View_User_List_1 ON dbo.Car_List.CheckUser = View_User_List_1.pk_User LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Car_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Calendar_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Calendar_List]
AS
SELECT     dbo.Calendar_List.pk_Calendar, dbo.Calendar_List.fk_User, dbo.Calendar_List.fk_Department, dbo.Calendar_List.TypeID, dbo.Calendar_List.StatusID, 
                      dbo.Calendar_List.Title, dbo.Calendar_List.Description, dbo.Calendar_List.Note, dbo.Calendar_List.ImagePath, dbo.Calendar_List.FilePath, 
                      dbo.Calendar_List.UserList, dbo.Calendar_List.DepartmentList, dbo.Calendar_List.RoleList, dbo.Calendar_List.Url, dbo.Calendar_List.StartDate, 
                      dbo.Calendar_List.EndDate, dbo.Calendar_List.IsRemind, dbo.Calendar_List.AdvancedTime, dbo.Calendar_List.fk_Company, 
                      dbo.Calendar_List.CreateUser, dbo.Calendar_List.CreateDate, dbo.Calendar_List.ModifyUser, dbo.Calendar_List.ModifyDate, 
                      dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName, '|' + dbo.Calendar_List.UserList + '|' AS UserList2
FROM         dbo.Calendar_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Calendar_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Forum_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Forum_List]
AS
SELECT     dbo.Forum_List.pk_Forum, dbo.Forum_List.fk_User, dbo.Forum_List.fk_Department, dbo.Forum_List.TypeID, dbo.Forum_List.StatusID, 
                      dbo.Forum_List.Title, dbo.Forum_List.Description, dbo.Forum_List.Note, dbo.Forum_List.ImagePath, dbo.Forum_List.FilePath, 
                      dbo.Forum_List.UserList, dbo.Forum_List.DepartmentList, dbo.Forum_List.RoleList, dbo.Forum_List.Url, dbo.Forum_List.IsStar, dbo.Forum_List.IsTop, 
                      dbo.Forum_List.IsVote, dbo.Forum_List.ParentID, dbo.Forum_List.SortID, dbo.Forum_List.IsReply, dbo.Forum_List.LastReplyUser, 
                      dbo.Forum_List.LastReply, dbo.Forum_List.Replies, dbo.Forum_List.Clicks, dbo.Forum_List.Likes, dbo.Forum_List.Tags, dbo.Forum_List.fk_Company, 
                      dbo.Forum_List.CreateUser, dbo.Forum_List.CreateDate, dbo.Forum_List.ModifyUser, dbo.Forum_List.ModifyDate, dbo.View_User_List.FullName, 
                      dbo.View_User_List.DepartmentName, '|' + dbo.Forum_List.UserList + '|' AS UserList2, dbo.View_User_List.ImagePath1
FROM         dbo.Forum_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Forum_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Task_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Task_List]
AS
SELECT     dbo.Task_List.*, dbo.View_User_List.FullName, dbo.View_User_List.DepartmentName
FROM         dbo.Task_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Task_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Process_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Process_List]
AS
SELECT     dbo.Process_List.pk_Process, dbo.Process_List.fk_User, dbo.Process_List.fk_Department, dbo.Process_List.TypeID, dbo.Process_List.StatusID, 
                      dbo.Process_List.Title, dbo.Process_List.Description, dbo.Process_List.Note, dbo.Process_List.ImagePath, dbo.Process_List.FilePath, 
                      dbo.Process_List.fk_Company, dbo.Process_List.CreateUser, dbo.Process_List.CreateDate, dbo.Process_List.ModifyUser, 
                      dbo.Process_List.ModifyDate, dbo.Process_List.IsCheck, dbo.Process_List.CheckUser, dbo.Process_List.CheckDate, 
                      dbo.Process_List.CheckDepartment, dbo.Process_List.AtUser, dbo.Process_List.Tags, dbo.Process_List.ParentID, dbo.View_User_List.FullName, 
                      dbo.View_User_List.DepartmentName, dbo.View_User_List.ImagePath1, View_User_List_1.FullName AS CheckFullName, 
                      View_User_List_1.DepartmentName AS CheckDepartmentName, View_User_List_1.ImagePath1 AS ImagePath2
FROM         dbo.Process_List LEFT OUTER JOIN
                      dbo.View_User_List AS View_User_List_1 ON dbo.Process_List.CheckUser = View_User_List_1.pk_User LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Process_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Plan_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Plan_List]
AS
SELECT     dbo.Plan_List.pk_Plan, dbo.Plan_List.fk_User, dbo.Plan_List.fk_Department, dbo.Plan_List.TypeID, dbo.Plan_List.StatusID, dbo.Plan_List.Title, 
                      dbo.Plan_List.Description, dbo.Plan_List.Note, dbo.Plan_List.Feedback, dbo.Plan_List.ImagePath, dbo.Plan_List.FilePath, dbo.Plan_List.UserList, 
                      dbo.Plan_List.DepartmentList, dbo.Plan_List.RoleList, dbo.Plan_List.Url, dbo.Plan_List.StartDate, dbo.Plan_List.EndDate, dbo.Plan_List.fk_Company, 
                      dbo.Plan_List.CreateUser, dbo.Plan_List.CreateDate, dbo.Plan_List.ModifyUser, dbo.Plan_List.ModifyDate, dbo.View_User_List.FullName, 
                      dbo.View_User_List.DepartmentName
FROM         dbo.Plan_List LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.Plan_List.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_User_Online]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_User_Online]
AS
SELECT     dbo.User_Online.pk_Online, dbo.User_Online.fk_User, dbo.User_Online.SessionID, dbo.User_Online.IPAddress, dbo.User_Online.Browser, 
                      dbo.User_Online.TypeID, dbo.User_Online.LoginTime, dbo.User_Online.fk_Company, dbo.View_User_List.UserName, dbo.View_User_List.FullName, 
                      dbo.View_User_List.DepartmentName
FROM         dbo.User_Online LEFT OUTER JOIN
                      dbo.View_User_List ON dbo.User_Online.fk_User = dbo.View_User_List.pk_User
GO
/****** Object:  View [dbo].[View_Task_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Task_Receiver]
AS
SELECT     dbo.Task_Receiver.pk_Receiver, dbo.Task_Receiver.fk_Task, dbo.Task_Receiver.fk_User, dbo.Task_Receiver.fk_Department, dbo.Task_Receiver.IsRead, dbo.Task_Receiver.ReadDate, 
                      dbo.Task_Receiver.IsReceive, dbo.Task_Receiver.ReceiveDate, dbo.View_Task_List.TypeID, dbo.View_Task_List.StatusID, dbo.View_Task_List.Title, dbo.View_Task_List.Description, 
                      dbo.View_Task_List.IsTop, dbo.View_Task_List.CreateDate, dbo.View_Task_List.FullName, dbo.View_Task_List.DepartmentName, dbo.View_Task_List.IsComplete, dbo.View_Task_List.IsCancel, 
                      dbo.View_Task_List.CreateUser, dbo.View_Task_List.FilePath, dbo.User_List.FullName AS Receiver
FROM         dbo.Task_Receiver LEFT OUTER JOIN
                      dbo.User_List ON dbo.Task_Receiver.fk_User = dbo.User_List.pk_User LEFT OUTER JOIN
                      dbo.View_Task_List ON dbo.Task_Receiver.fk_Task = dbo.View_Task_List.pk_Task
GO
/****** Object:  View [dbo].[View_Notice_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Notice_Receiver]
AS
SELECT     dbo.Notice_Receiver.pk_Receiver, dbo.Notice_Receiver.fk_Notice, dbo.Notice_Receiver.fk_User, dbo.Notice_Receiver.fk_Department, dbo.Notice_Receiver.IsRead, dbo.Notice_Receiver.ReadDate, 
                      dbo.View_Notice_List.TypeID, dbo.View_Notice_List.StatusID, dbo.View_Notice_List.Title, dbo.View_Notice_List.Description, dbo.View_Notice_List.FullName, dbo.View_Notice_List.DepartmentName, 
                      dbo.View_Notice_List.CreateDate, dbo.View_Notice_List.IsTop, dbo.View_Notice_List.Url, dbo.View_Notice_List.FilePath
FROM         dbo.Notice_Receiver LEFT OUTER JOIN
                      dbo.View_Notice_List ON dbo.Notice_Receiver.fk_Notice = dbo.View_Notice_List.pk_Notice
GO
/****** Object:  View [dbo].[View_Activity_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Activity_List]
AS
SELECT   dbo.Activity_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Activity_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Activity_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Building_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Building_List]
AS
SELECT   dbo.Building_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Building_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Building_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Calendar_Check]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Calendar_Check]
AS
SELECT     pk_Calendar, fk_User, fk_Department, TypeID, StatusID, Title, Description, Note, ImagePath, FilePath, UserList, DepartmentList, RoleList, Url, 
                      StartDate, EndDate, IsRemind, AdvancedTime, fk_Company, CreateUser, CreateDate, ModifyUser, ModifyDate, DATEDIFF(HOUR, GETDATE(), StartDate) 
                      AS TimeDiff
FROM         dbo.Calendar_List
WHERE     (IsRemind = 1)
GO
/****** Object:  View [dbo].[View_Complain_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Complain_List]
AS
SELECT   dbo.Complain_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Complain_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Complain_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Customer_Follow]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Customer_Follow]
AS
SELECT     dbo.Customer_Follow.pk_Follow, dbo.Customer_Follow.fk_Customer, dbo.Customer_Follow.fk_User, dbo.Customer_Follow.fk_Department, dbo.Customer_Follow.TypeID, 
                      dbo.Customer_Follow.StatusID, dbo.Customer_Follow.Title, dbo.Customer_Follow.Description, dbo.Customer_Follow.FollowDate, dbo.Customer_Follow.NextFollow, dbo.Customer_Follow.Remark, 
                      dbo.Customer_Follow.CreateUser, dbo.Customer_Follow.CreateDate, dbo.Customer_Follow.ModifyUser, dbo.Customer_Follow.ModifyDate, dbo.Customer_List.FullName, 
                      dbo.User_List.FullName AS UserFullName, dbo.Customer_List.Contact, dbo.Customer_List.Mobile
FROM         dbo.Customer_Follow LEFT OUTER JOIN
                      dbo.User_List ON dbo.Customer_Follow.fk_User = dbo.User_List.pk_User LEFT OUTER JOIN
                      dbo.Customer_List ON dbo.Customer_Follow.fk_Customer = dbo.Customer_List.pk_Customer
GO
/****** Object:  View [dbo].[View_Customer_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Customer_List]
AS
SELECT     dbo.Customer_List.pk_Customer, dbo.Customer_List.fk_User, dbo.Customer_List.fk_Department, dbo.Customer_List.TypeID, dbo.Customer_List.StatusID, dbo.Customer_List.FullName, 
                      dbo.Customer_List.ShortName, dbo.Customer_List.CustomerType, dbo.Customer_List.CustomerLevel, dbo.Customer_List.CustomerProperty, dbo.Customer_List.CustomerState, 
                      dbo.Customer_List.CustomerSource, dbo.Customer_List.Industry, dbo.Customer_List.Nature, dbo.Customer_List.EmployeNum, dbo.Customer_List.License, dbo.Customer_List.Tags, 
                      dbo.Customer_List.Contact, dbo.Customer_List.Website, dbo.Customer_List.Email, dbo.Customer_List.TEL, dbo.Customer_List.Mobile, dbo.Customer_List.Fax, dbo.Customer_List.Wechat, 
                      dbo.Customer_List.QQ, dbo.Customer_List.Wangwang, dbo.Customer_List.Weibo, dbo.Customer_List.ZipCode, dbo.Customer_List.Country, dbo.Customer_List.Province, dbo.Customer_List.City, 
                      dbo.Customer_List.County, dbo.Customer_List.Address, dbo.Customer_List.Remark, dbo.Customer_List.Description, dbo.Customer_List.ImagePath, dbo.Customer_List.FilePath, 
                      dbo.Customer_List.StartDate, dbo.Customer_List.EndDate, dbo.Customer_List.IsStar, dbo.Customer_List.IsAlert, dbo.Customer_List.AlertDate, dbo.Customer_List.AlertInfo, 
                      dbo.Customer_List.CreateUser, dbo.Customer_List.CreateDate, dbo.Customer_List.ModifyUser, dbo.Customer_List.ModifyDate, dbo.User_List.FullName AS UserFullName
FROM         dbo.Customer_List LEFT OUTER JOIN
                      dbo.User_List ON dbo.Customer_List.fk_User = dbo.User_List.pk_User
GO
/****** Object:  View [dbo].[View_Device_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Device_List]
AS
SELECT   dbo.Device_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Device_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Device_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Fee_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Fee_List]
AS
SELECT   dbo.Fee_List.pk_Fee, dbo.Fee_List.fk_Community, dbo.Fee_List.fk_User, dbo.Fee_List.fk_Department, 
                dbo.Fee_List.fk_Owner, dbo.Fee_List.TypeID, dbo.Fee_List.StatusID, dbo.Fee_List.Number, dbo.Fee_List.Name, 
                dbo.Fee_List.Description, dbo.Fee_List.StartDate, dbo.Fee_List.EndDate, dbo.Fee_List.Amount1, dbo.Fee_List.Amount2, 
                dbo.Fee_List.CreateUser, dbo.Fee_List.CreateDate, dbo.Fee_List.ModifyUser, dbo.Fee_List.ModifyDate, 
                dbo.Community_List.Name AS CommunityName, dbo.Owner_List.Name AS Owner, dbo.Owner_List.Contact
FROM      dbo.Community_List RIGHT OUTER JOIN
                dbo.Fee_List ON dbo.Community_List.pk_Community = dbo.Fee_List.fk_Community LEFT OUTER JOIN
                dbo.Owner_List ON dbo.Fee_List.fk_Owner = dbo.Owner_List.pk_Owner
GO
/****** Object:  View [dbo].[View_Fee_Meter]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Fee_Meter]
AS
SELECT   dbo.Fee_Meter.pk_Meter, dbo.Fee_Meter.fk_Community, dbo.Fee_Meter.fk_Building, dbo.Fee_Meter.fk_House, 
                dbo.Fee_Meter.fk_Owner, dbo.Fee_Meter.fk_User, dbo.Fee_Meter.fk_Department, dbo.Fee_Meter.TypeID, 
                dbo.Fee_Meter.StatusID, dbo.Fee_Meter.Title, dbo.Fee_Meter.ImagePath, dbo.Fee_Meter.Description, 
                dbo.Fee_Meter.Degree1, dbo.Fee_Meter.Degree2, dbo.Fee_Meter.CheckDate1, dbo.Fee_Meter.CheckDate2, 
                dbo.Fee_Meter.CreateUser, dbo.Fee_Meter.CreateDate, dbo.Fee_Meter.ModifyUser, dbo.Fee_Meter.ModifyDate, 
                dbo.Community_List.Name AS CommunityName, dbo.Owner_List.Name AS Owner, dbo.Owner_List.Contact
FROM      dbo.Fee_Meter LEFT OUTER JOIN
                dbo.Owner_List ON dbo.Fee_Meter.fk_Owner = dbo.Owner_List.pk_Owner LEFT OUTER JOIN
                dbo.Community_List ON dbo.Fee_Meter.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Finance_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Finance_List]
AS
SELECT     dbo.Finance_List.*, dbo.User_Department.DepartmentName, dbo.Finance_Account.Title AS AccountTitle
FROM         dbo.Finance_List LEFT OUTER JOIN
                      dbo.Finance_Account ON dbo.Finance_List.fk_Account = dbo.Finance_Account.pk_Account LEFT OUTER JOIN
                      dbo.User_Department ON dbo.Finance_List.fk_Department = dbo.User_Department.pk_Department
GO
/****** Object:  View [dbo].[View_Forum_Vote]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Forum_Vote]
AS
SELECT     pk_Vote, fk_Forum, Title, SortID, Visual, UserList, Votes, '|' + UserList + '|' AS UserList2
FROM         dbo.Forum_Vote
GO
/****** Object:  View [dbo].[View_House_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_House_List]
AS
SELECT   dbo.House_List.*, dbo.Community_List.Name AS CommunityName, dbo.Building_List.Name AS BuildingName
FROM      dbo.House_List LEFT OUTER JOIN
                dbo.Building_List ON dbo.House_List.fk_Building = dbo.Building_List.pk_Building LEFT OUTER JOIN
                dbo.Community_List ON dbo.House_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Menu]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Menu]
AS
SELECT     dbo.Role_List.pk_Role, dbo.Role_List.fk_RoleName, dbo.Role_List.fk_Menu, dbo.Role_List.IsUse, dbo.Role_List.IsAdmin, dbo.Role_List.PowerList, 
                      dbo.Role_List.fk_Company, dbo.Sys_Menu.pk_Menu, dbo.Sys_Menu.ParentID, dbo.Sys_Menu.Name_CHS, dbo.Sys_Menu.Name_CHT, 
                      dbo.Sys_Menu.Name_EN, dbo.Sys_Menu.Url, dbo.Sys_Menu.Icon, dbo.Sys_Menu.SortID, dbo.Sys_Menu.LevelID, dbo.Sys_Menu.TypeID, 
                      dbo.Sys_Menu.Visible, dbo.Sys_Menu.Tag_CHS, dbo.Sys_Menu.Tag_CHT, dbo.Sys_Menu.Tag_EN
FROM         dbo.Role_List LEFT OUTER JOIN
                      dbo.Sys_Menu ON dbo.Role_List.fk_Menu = dbo.Sys_Menu.pk_Menu
GO
/****** Object:  View [dbo].[View_MyHistory]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_MyHistory]
AS
SELECT     Url, fk_User, TypeID, Title, fk_Company, MAX(LogTime) AS CreateDate
FROM         dbo.User_Log
GROUP BY Url, fk_User, TypeID, Title, fk_Company
GO
/****** Object:  View [dbo].[View_Owner_Car]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Owner_Car]
AS
SELECT   dbo.Owner_Car.*, dbo.Owner_List.Name AS OwnerName, dbo.Owner_List.Contact, 
                dbo.Parking_List.Name AS ParkingName
FROM      dbo.Owner_Car LEFT OUTER JOIN
                dbo.Parking_List ON dbo.Owner_Car.fk_Parking = dbo.Parking_List.pk_Parking LEFT OUTER JOIN
                dbo.Owner_List ON dbo.Owner_Car.fk_Owner = dbo.Owner_List.pk_Owner
GO
/****** Object:  View [dbo].[View_Parking_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Parking_List]
AS
SELECT   dbo.Parking_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Parking_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Parking_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Repair_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Repair_List]
AS
SELECT   dbo.Repair_List.pk_Repair, dbo.Repair_List.fk_Community, dbo.Repair_List.fk_User, dbo.Repair_List.fk_Department, 
                dbo.Repair_List.TypeID, dbo.Repair_List.StatusID, dbo.Repair_List.Title, dbo.Repair_List.Description, 
                dbo.Repair_List.Note, dbo.Repair_List.ImagePath, dbo.Repair_List.CreateUser, dbo.Repair_List.CreateDate, 
                dbo.Repair_List.ModifyUser, dbo.Repair_List.ModifyDate, dbo.User_List.FullName, 
                dbo.Community_List.Name AS CommunityName
FROM      dbo.Repair_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Repair_List.fk_Community = dbo.Community_List.pk_Community LEFT OUTER JOIN
                dbo.User_List ON dbo.Repair_List.fk_User = dbo.User_List.pk_User
GO
/****** Object:  View [dbo].[View_Shop_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Shop_List]
AS
SELECT   dbo.Shop_List.*, dbo.Community_List.Name AS CommunityName
FROM      dbo.Shop_List LEFT OUTER JOIN
                dbo.Community_List ON dbo.Shop_List.fk_Community = dbo.Community_List.pk_Community
GO
/****** Object:  View [dbo].[View_Workflow_List]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Workflow_List]
AS
SELECT     dbo.Workflow_List.pk_Workflow, dbo.Workflow_List.fk_User, dbo.Workflow_List.fk_Department, dbo.Workflow_List.fk_Template, dbo.Workflow_List.TypeID, dbo.Workflow_List.StatusID, 
                      dbo.Workflow_List.CurrentStepID, dbo.Workflow_List.NextStepID, dbo.Workflow_List.Number, dbo.Workflow_List.Title, dbo.Workflow_List.Description, dbo.Workflow_List.fk_Company, 
                      dbo.Workflow_List.StartDate, dbo.Workflow_List.EndDate, dbo.Workflow_List.NotifyUser, dbo.Workflow_List.CreateUser, dbo.Workflow_List.CreateDate, dbo.Workflow_List.ModifyUser, 
                      dbo.Workflow_List.ModifyDate, dbo.Workflow_Step.Title AS StepName, '|' + dbo.Workflow_List.NotifyUser + '|' AS UserList, dbo.User_List.FullName
FROM         dbo.Workflow_List LEFT OUTER JOIN
                      dbo.User_List ON dbo.Workflow_List.fk_User = dbo.User_List.pk_User LEFT OUTER JOIN
                      dbo.Workflow_Step ON dbo.Workflow_List.NextStepID = dbo.Workflow_Step.pk_Step
GO
/****** Object:  View [dbo].[View_Workflow_Receiver]    Script Date: 2021/9/14 15:17:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[View_Workflow_Receiver]
AS
SELECT     dbo.Workflow_Receiver.pk_Receiver, dbo.Workflow_Receiver.fk_Workflow, dbo.Workflow_Receiver.fk_Template, dbo.Workflow_Receiver.fk_Step, dbo.Workflow_Receiver.fk_Signature, 
                      dbo.Workflow_Receiver.fk_User, dbo.Workflow_Receiver.fk_Department, dbo.Workflow_Receiver.IsCheck, dbo.Workflow_Receiver.CheckDate, dbo.Workflow_Receiver.TypeID, 
                      dbo.Workflow_Receiver.StatusID, dbo.Workflow_Receiver.Note, dbo.Workflow_Receiver.CreateUser, dbo.Workflow_Receiver.CreateDate, dbo.Workflow_List.Number, dbo.Workflow_List.Title, 
                      dbo.Workflow_Step.Title AS StepName, dbo.User_List.FullName, dbo.Workflow_List.StatusID AS WorkflowStatus, dbo.Workflow_List.EndDate
FROM         dbo.User_List RIGHT OUTER JOIN
                      dbo.Workflow_List ON dbo.User_List.pk_User = dbo.Workflow_List.fk_User RIGHT OUTER JOIN
                      dbo.Workflow_Receiver LEFT OUTER JOIN
                      dbo.Workflow_Step ON dbo.Workflow_Receiver.fk_Step = dbo.Workflow_Step.pk_Step ON dbo.Workflow_List.pk_Workflow = dbo.Workflow_Receiver.fk_Workflow
GO
SET IDENTITY_INSERT [dbo].[Activity_List] ON 
GO
INSERT [dbo].[Activity_List] ([pk_Activity], [fk_Community], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Place], [Target], [Budget], [Result], [ImagePath], [StartDate], [EndDate], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 0, 0, N'车位促销活动', N'每户一个', N'北一门', N'卖车位', CAST(1000.000 AS Decimal(18, 3)), N'很好', N'', CAST(N'2021-09-01T00:00:00.000' AS DateTime), CAST(N'2021-09-05T00:00:00.000' AS DateTime), 1, CAST(N'2021-09-09T11:32:46.000' AS DateTime), 1, CAST(N'2021-09-09T11:39:40.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Activity_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Address_List] ON 
GO
INSERT [dbo].[Address_List] ([pk_Address], [fk_User], [fk_Department], [TypeID], [StatusID], [NickName], [FullName], [FirstName], [MiddleName], [LastName], [Phone1], [Phone2], [Email1], [Email2], [Fax], [Line], [Wechat], [QQ], [Facebook], [Twitter], [Linkedin], [ZipCode], [Place], [Address1], [Address2], [Sex], [Birthday], [Note], [Feedback], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [IsFolder], [IsStar], [ParentID], [Tags], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'', N'雷军', N'', N'', N'', N'13800138000', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', 0, CAST(N'1995-01-01T00:00:00.000' AS DateTime), N'魔方动力软件有限公司', N'', N'', N'', N'', N'', N'', N'', 0, 0, 0, N'', 1, 1, CAST(N'2019-05-16T20:44:58.000' AS DateTime), 0, CAST(N'2019-05-16T20:44:58.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Address_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Area_List] ON 
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1, 100000, 0, N'中国')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2, 110000, 100000, N'北京')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3, 110100, 110000, N'北京市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4, 110101, 110100, N'东城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (5, 110102, 110100, N'西城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (6, 110105, 110100, N'朝阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (7, 110106, 110100, N'丰台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (8, 110107, 110100, N'石景山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (9, 110108, 110100, N'海淀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (10, 110109, 110100, N'门头沟区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (11, 110111, 110100, N'房山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (12, 110112, 110100, N'通州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (13, 110113, 110100, N'顺义区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (14, 110114, 110100, N'昌平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (15, 110115, 110100, N'大兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (16, 110116, 110100, N'怀柔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (17, 110117, 110100, N'平谷区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (18, 110118, 110100, N'密云区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (19, 110119, 110100, N'延庆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (20, 110120, 110100, N'中关村科技园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (21, 120000, 100000, N'天津')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (22, 120100, 120000, N'天津市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (23, 120101, 120100, N'和平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (24, 120102, 120100, N'河东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (25, 120103, 120100, N'河西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (26, 120104, 120100, N'南开区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (27, 120105, 120100, N'河北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (28, 120106, 120100, N'红桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (29, 120110, 120100, N'东丽区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (30, 120111, 120100, N'西青区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (31, 120112, 120100, N'津南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (32, 120113, 120100, N'北辰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (33, 120114, 120100, N'武清区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (34, 120115, 120100, N'宝坻区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (35, 120116, 120100, N'滨海新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (36, 120117, 120100, N'宁河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (37, 120118, 120100, N'静海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (38, 120119, 120100, N'蓟州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (39, 120120, 120100, N'滨海高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (40, 130000, 100000, N'河北省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (41, 130100, 130000, N'石家庄市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (42, 130102, 130100, N'长安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (43, 130104, 130100, N'桥西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (44, 130105, 130100, N'新华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (45, 130107, 130100, N'井陉矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (46, 130108, 130100, N'裕华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (47, 130109, 130100, N'藁城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (48, 130110, 130100, N'鹿泉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (49, 130111, 130100, N'栾城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (50, 130121, 130100, N'井陉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (51, 130123, 130100, N'正定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (52, 130125, 130100, N'行唐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (53, 130126, 130100, N'灵寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (54, 130127, 130100, N'高邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (55, 130128, 130100, N'深泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (56, 130129, 130100, N'赞皇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (57, 130130, 130100, N'无极县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (58, 130131, 130100, N'平山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (59, 130132, 130100, N'元氏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (60, 130133, 130100, N'赵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (61, 130181, 130100, N'辛集市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (62, 130183, 130100, N'晋州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (63, 130184, 130100, N'新乐市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (64, 130185, 130100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (65, 130186, 130100, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (66, 130200, 130000, N'唐山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (67, 130202, 130200, N'路南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (68, 130203, 130200, N'路北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (69, 130204, 130200, N'古冶区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (70, 130205, 130200, N'开平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (71, 130207, 130200, N'丰南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (72, 130208, 130200, N'丰润区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (73, 130209, 130200, N'曹妃甸区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (74, 130223, 130200, N'滦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (75, 130224, 130200, N'滦南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (76, 130225, 130200, N'乐亭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (77, 130227, 130200, N'迁西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (78, 130229, 130200, N'玉田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (79, 130281, 130200, N'遵化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (80, 130283, 130200, N'迁安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (81, 130300, 130000, N'秦皇岛市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (82, 130302, 130300, N'海港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (83, 130303, 130300, N'山海关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (84, 130304, 130300, N'北戴河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (85, 130306, 130300, N'抚宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (86, 130321, 130300, N'青龙满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (87, 130322, 130300, N'昌黎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (88, 130324, 130300, N'卢龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (89, 130325, 130300, N'北戴河新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (90, 130400, 130000, N'邯郸市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (91, 130402, 130400, N'邯山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (92, 130403, 130400, N'丛台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (93, 130404, 130400, N'复兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (94, 130406, 130400, N'峰峰矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (95, 130407, 130400, N'肥乡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (96, 130408, 130400, N'永年区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (97, 130423, 130400, N'临漳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (98, 130424, 130400, N'成安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (99, 130425, 130400, N'大名县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (100, 130426, 130400, N'涉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (101, 130427, 130400, N'磁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (102, 130430, 130400, N'邱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (103, 130431, 130400, N'鸡泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (104, 130432, 130400, N'广平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (105, 130433, 130400, N'馆陶县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (106, 130434, 130400, N'魏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (107, 130435, 130400, N'曲周县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (108, 130481, 130400, N'武安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (109, 130482, 130400, N'高新技术产业开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (110, 130500, 130000, N'邢台市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (111, 130502, 130500, N'桥东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (112, 130503, 130500, N'桥西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (113, 130521, 130500, N'邢台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (114, 130522, 130500, N'临城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (115, 130523, 130500, N'内丘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (116, 130524, 130500, N'柏乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (117, 130525, 130500, N'隆尧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (118, 130526, 130500, N'任县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (119, 130527, 130500, N'南和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (120, 130528, 130500, N'宁晋县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (121, 130529, 130500, N'巨鹿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (122, 130530, 130500, N'新河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (123, 130531, 130500, N'广宗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (124, 130532, 130500, N'平乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (125, 130533, 130500, N'威县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (126, 130534, 130500, N'清河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (127, 130535, 130500, N'临西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (128, 130581, 130500, N'南宫市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (129, 130582, 130500, N'沙河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (130, 130600, 130000, N'保定市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (131, 130602, 130600, N'竞秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (132, 130606, 130600, N'莲池区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (133, 130607, 130600, N'满城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (134, 130608, 130600, N'清苑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (135, 130609, 130600, N'徐水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (136, 130623, 130600, N'涞水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (137, 130624, 130600, N'阜平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (138, 130626, 130600, N'定兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (139, 130627, 130600, N'唐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (140, 130628, 130600, N'高阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (141, 130629, 130600, N'容城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (142, 130630, 130600, N'涞源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (143, 130631, 130600, N'望都县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (144, 130632, 130600, N'安新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (145, 130633, 130600, N'易县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (146, 130634, 130600, N'曲阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (147, 130635, 130600, N'蠡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (148, 130636, 130600, N'顺平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (149, 130637, 130600, N'博野县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (150, 130638, 130600, N'雄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (151, 130681, 130600, N'涿州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (152, 130682, 130600, N'定州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (153, 130683, 130600, N'安国市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (154, 130684, 130600, N'高碑店市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (155, 130685, 130600, N'雄安新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (156, 130686, 130600, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (157, 130700, 130000, N'张家口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (158, 130702, 130700, N'桥东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (159, 130703, 130700, N'桥西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (160, 130705, 130700, N'宣化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (161, 130706, 130700, N'下花园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (162, 130708, 130700, N'万全区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (163, 130709, 130700, N'崇礼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (164, 130722, 130700, N'张北县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (165, 130723, 130700, N'康保县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (166, 130724, 130700, N'沽源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (167, 130725, 130700, N'尚义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (168, 130726, 130700, N'蔚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (169, 130727, 130700, N'阳原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (170, 130728, 130700, N'怀安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (171, 130730, 130700, N'怀来县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (172, 130731, 130700, N'涿鹿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (173, 130732, 130700, N'赤城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (174, 130800, 130000, N'承德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (175, 130802, 130800, N'双桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (176, 130803, 130800, N'双滦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (177, 130804, 130800, N'鹰手营子矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (178, 130821, 130800, N'承德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (179, 130822, 130800, N'兴隆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (180, 130824, 130800, N'滦平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (181, 130825, 130800, N'隆化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (182, 130826, 130800, N'丰宁满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (183, 130827, 130800, N'宽城满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (184, 130828, 130800, N'围场满族蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (185, 130881, 130800, N'平泉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (186, 130900, 130000, N'沧州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (187, 130902, 130900, N'新华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (188, 130903, 130900, N'运河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (189, 130921, 130900, N'沧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (190, 130922, 130900, N'青县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (191, 130923, 130900, N'东光县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (192, 130924, 130900, N'海兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (193, 130925, 130900, N'盐山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (194, 130926, 130900, N'肃宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (195, 130927, 130900, N'南皮县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (196, 130928, 130900, N'吴桥县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (197, 130929, 130900, N'献县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (198, 130930, 130900, N'孟村回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (199, 130981, 130900, N'泊头市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (200, 130982, 130900, N'任丘市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (201, 130983, 130900, N'黄骅市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (202, 130984, 130900, N'河间市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (203, 130985, 130900, N'渤海新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (204, 130986, 130900, N'临港经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (205, 131000, 130000, N'廊坊市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (206, 131002, 131000, N'安次区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (207, 131003, 131000, N'广阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (208, 131022, 131000, N'固安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (209, 131023, 131000, N'永清县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (210, 131024, 131000, N'香河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (211, 131025, 131000, N'大城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (212, 131026, 131000, N'文安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (213, 131028, 131000, N'大厂回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (214, 131081, 131000, N'霸州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (215, 131082, 131000, N'三河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (216, 131083, 131000, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (217, 131100, 130000, N'衡水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (218, 131102, 131100, N'桃城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (219, 131103, 131100, N'冀州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (220, 131121, 131100, N'枣强县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (221, 131122, 131100, N'武邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (222, 131123, 131100, N'武强县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (223, 131124, 131100, N'饶阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (224, 131125, 131100, N'安平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (225, 131126, 131100, N'故城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (226, 131127, 131100, N'景县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (227, 131128, 131100, N'阜城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (228, 131182, 131100, N'深州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (229, 140000, 100000, N'山西省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (230, 140100, 140000, N'太原市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (231, 140105, 140100, N'小店区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (232, 140106, 140100, N'迎泽区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (233, 140107, 140100, N'杏花岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (234, 140108, 140100, N'尖草坪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (235, 140109, 140100, N'万柏林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (236, 140110, 140100, N'晋源区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (237, 140121, 140100, N'清徐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (238, 140122, 140100, N'阳曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (239, 140123, 140100, N'娄烦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (240, 140181, 140100, N'古交市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (241, 140182, 140100, N'高新阳曲园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (242, 140183, 140100, N'高新汾东园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (243, 140184, 140100, N'高新姚村园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (244, 140200, 140000, N'大同市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (245, 140202, 140200, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (246, 140203, 140200, N'矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (247, 140211, 140200, N'南郊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (248, 140212, 140200, N'新荣区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (249, 140221, 140200, N'阳高县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (250, 140222, 140200, N'天镇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (251, 140223, 140200, N'广灵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (252, 140224, 140200, N'灵丘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (253, 140225, 140200, N'浑源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (254, 140226, 140200, N'左云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (255, 140227, 140200, N'大同县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (256, 140228, 140200, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (257, 140300, 140000, N'阳泉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (258, 140302, 140300, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (259, 140303, 140300, N'矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (260, 140311, 140300, N'郊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (261, 140321, 140300, N'平定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (262, 140322, 140300, N'盂县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (263, 140400, 140000, N'长治市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (264, 140402, 140400, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (265, 140411, 140400, N'郊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (266, 140421, 140400, N'长治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (267, 140423, 140400, N'襄垣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (268, 140424, 140400, N'屯留县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (269, 140425, 140400, N'平顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (270, 140426, 140400, N'黎城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (271, 140427, 140400, N'壶关县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (272, 140428, 140400, N'长子县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (273, 140429, 140400, N'武乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (274, 140430, 140400, N'沁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (275, 140431, 140400, N'沁源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (276, 140481, 140400, N'潞城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (277, 140500, 140000, N'晋城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (278, 140502, 140500, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (279, 140521, 140500, N'沁水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (280, 140522, 140500, N'阳城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (281, 140524, 140500, N'陵川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (282, 140525, 140500, N'泽州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (283, 140581, 140500, N'高平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (284, 140582, 140500, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (285, 140600, 140000, N'朔州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (286, 140602, 140600, N'朔城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (287, 140603, 140600, N'平鲁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (288, 140621, 140600, N'山阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (289, 140622, 140600, N'应县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (290, 140623, 140600, N'右玉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (291, 140624, 140600, N'怀仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (292, 140700, 140000, N'晋中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (293, 140702, 140700, N'榆次区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (294, 140721, 140700, N'榆社县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (295, 140722, 140700, N'左权县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (296, 140723, 140700, N'和顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (297, 140724, 140700, N'昔阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (298, 140725, 140700, N'寿阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (299, 140726, 140700, N'太谷县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (300, 140727, 140700, N'祁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (301, 140728, 140700, N'平遥县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (302, 140729, 140700, N'灵石县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (303, 140781, 140700, N'介休市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (304, 140800, 140000, N'运城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (305, 140802, 140800, N'盐湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (306, 140821, 140800, N'临猗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (307, 140822, 140800, N'万荣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (308, 140823, 140800, N'闻喜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (309, 140824, 140800, N'稷山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (310, 140825, 140800, N'新绛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (311, 140826, 140800, N'绛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (312, 140827, 140800, N'垣曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (313, 140828, 140800, N'夏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (314, 140829, 140800, N'平陆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (315, 140830, 140800, N'芮城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (316, 140881, 140800, N'永济市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (317, 140882, 140800, N'河津市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (318, 140900, 140000, N'忻州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (319, 140902, 140900, N'忻府区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (320, 140921, 140900, N'定襄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (321, 140922, 140900, N'五台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (322, 140923, 140900, N'代县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (323, 140924, 140900, N'繁峙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (324, 140925, 140900, N'宁武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (325, 140926, 140900, N'静乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (326, 140927, 140900, N'神池县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (327, 140928, 140900, N'五寨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (328, 140929, 140900, N'岢岚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (329, 140930, 140900, N'河曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (330, 140931, 140900, N'保德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (331, 140932, 140900, N'偏关县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (332, 140981, 140900, N'原平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (333, 141000, 140000, N'临汾市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (334, 141002, 141000, N'尧都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (335, 141021, 141000, N'曲沃县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (336, 141022, 141000, N'翼城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (337, 141023, 141000, N'襄汾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (338, 141024, 141000, N'洪洞县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (339, 141025, 141000, N'古县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (340, 141026, 141000, N'安泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (341, 141027, 141000, N'浮山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (342, 141028, 141000, N'吉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (343, 141029, 141000, N'乡宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (344, 141030, 141000, N'大宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (345, 141031, 141000, N'隰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (346, 141032, 141000, N'永和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (347, 141033, 141000, N'蒲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (348, 141034, 141000, N'汾西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (349, 141081, 141000, N'侯马市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (350, 141082, 141000, N'霍州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (351, 141100, 140000, N'吕梁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (352, 141102, 141100, N'离石区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (353, 141121, 141100, N'文水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (354, 141122, 141100, N'交城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (355, 141123, 141100, N'兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (356, 141124, 141100, N'临县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (357, 141125, 141100, N'柳林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (358, 141126, 141100, N'石楼县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (359, 141127, 141100, N'岚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (360, 141128, 141100, N'方山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (361, 141129, 141100, N'中阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (362, 141130, 141100, N'交口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (363, 141181, 141100, N'孝义市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (364, 141182, 141100, N'汾阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (365, 150000, 100000, N'内蒙古自治区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (366, 150100, 150000, N'呼和浩特市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (367, 150102, 150100, N'新城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (368, 150103, 150100, N'回民区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (369, 150104, 150100, N'玉泉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (370, 150105, 150100, N'赛罕区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (371, 150121, 150100, N'土默特左旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (372, 150122, 150100, N'托克托县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (373, 150123, 150100, N'和林格尔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (374, 150124, 150100, N'清水河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (375, 150125, 150100, N'武川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (376, 150200, 150000, N'包头市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (377, 150202, 150200, N'东河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (378, 150203, 150200, N'昆都仑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (379, 150204, 150200, N'青山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (380, 150205, 150200, N'石拐区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (381, 150206, 150200, N'白云鄂博矿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (382, 150207, 150200, N'九原区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (383, 150221, 150200, N'土默特右旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (384, 150222, 150200, N'固阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (385, 150223, 150200, N'达尔罕茂明安联合旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (386, 150300, 150000, N'乌海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (387, 150302, 150300, N'海勃湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (388, 150303, 150300, N'海南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (389, 150304, 150300, N'乌达区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (390, 150400, 150000, N'赤峰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (391, 150402, 150400, N'红山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (392, 150403, 150400, N'元宝山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (393, 150404, 150400, N'松山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (394, 150421, 150400, N'阿鲁科尔沁旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (395, 150422, 150400, N'巴林左旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (396, 150423, 150400, N'巴林右旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (397, 150424, 150400, N'林西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (398, 150425, 150400, N'克什克腾旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (399, 150426, 150400, N'翁牛特旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (400, 150428, 150400, N'喀喇沁旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (401, 150429, 150400, N'宁城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (402, 150430, 150400, N'敖汉旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (403, 150500, 150000, N'通辽市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (404, 150502, 150500, N'科尔沁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (405, 150521, 150500, N'科尔沁左翼中旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (406, 150522, 150500, N'科尔沁左翼后旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (407, 150523, 150500, N'开鲁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (408, 150524, 150500, N'库伦旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (409, 150525, 150500, N'奈曼旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (410, 150526, 150500, N'扎鲁特旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (411, 150581, 150500, N'霍林郭勒市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (412, 150600, 150000, N'鄂尔多斯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (413, 150602, 150600, N'东胜区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (414, 150603, 150600, N'康巴什区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (415, 150621, 150600, N'达拉特旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (416, 150622, 150600, N'准格尔旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (417, 150623, 150600, N'鄂托克前旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (418, 150624, 150600, N'鄂托克旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (419, 150625, 150600, N'杭锦旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (420, 150626, 150600, N'乌审旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (421, 150627, 150600, N'伊金霍洛旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (422, 150700, 150000, N'呼伦贝尔市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (423, 150702, 150700, N'海拉尔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (424, 150703, 150700, N'扎赉诺尔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (425, 150721, 150700, N'阿荣旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (426, 150722, 150700, N'莫力达瓦达斡尔族自治旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (427, 150723, 150700, N'鄂伦春自治旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (428, 150724, 150700, N'鄂温克族自治旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (429, 150725, 150700, N'陈巴尔虎旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (430, 150726, 150700, N'新巴尔虎左旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (431, 150727, 150700, N'新巴尔虎右旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (432, 150781, 150700, N'满洲里市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (433, 150782, 150700, N'牙克石市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (434, 150783, 150700, N'扎兰屯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (435, 150784, 150700, N'额尔古纳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (436, 150785, 150700, N'根河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (437, 150800, 150000, N'巴彦淖尔市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (438, 150802, 150800, N'临河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (439, 150821, 150800, N'五原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (440, 150822, 150800, N'磴口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (441, 150823, 150800, N'乌拉特前旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (442, 150824, 150800, N'乌拉特中旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (443, 150825, 150800, N'乌拉特后旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (444, 150826, 150800, N'杭锦后旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (445, 150900, 150000, N'乌兰察布市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (446, 150902, 150900, N'集宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (447, 150921, 150900, N'卓资县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (448, 150922, 150900, N'化德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (449, 150923, 150900, N'商都县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (450, 150924, 150900, N'兴和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (451, 150925, 150900, N'凉城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (452, 150926, 150900, N'察哈尔右翼前旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (453, 150927, 150900, N'察哈尔右翼中旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (454, 150928, 150900, N'察哈尔右翼后旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (455, 150929, 150900, N'四子王旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (456, 150981, 150900, N'丰镇市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (457, 152200, 150000, N'兴安盟')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (458, 152201, 152200, N'乌兰浩特市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (459, 152202, 152200, N'阿尔山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (460, 152221, 152200, N'科尔沁右翼前旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (461, 152222, 152200, N'科尔沁右翼中旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (462, 152223, 152200, N'扎赉特旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (463, 152224, 152200, N'突泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (464, 152500, 150000, N'锡林郭勒盟')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (465, 152501, 152500, N'二连浩特市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (466, 152502, 152500, N'锡林浩特市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (467, 152522, 152500, N'阿巴嘎旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (468, 152523, 152500, N'苏尼特左旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (469, 152524, 152500, N'苏尼特右旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (470, 152525, 152500, N'东乌珠穆沁旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (471, 152526, 152500, N'西乌珠穆沁旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (472, 152527, 152500, N'太仆寺旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (473, 152528, 152500, N'镶黄旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (474, 152529, 152500, N'正镶白旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (475, 152530, 152500, N'正蓝旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (476, 152531, 152500, N'多伦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (477, 152900, 150000, N'阿拉善盟')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (478, 152921, 152900, N'阿拉善左旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (479, 152922, 152900, N'阿拉善右旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (480, 152923, 152900, N'额济纳旗')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (481, 210000, 100000, N'辽宁省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (482, 210100, 210000, N'沈阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (483, 210102, 210100, N'和平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (484, 210103, 210100, N'沈河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (485, 210104, 210100, N'大东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (486, 210105, 210100, N'皇姑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (487, 210106, 210100, N'铁西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (488, 210111, 210100, N'苏家屯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (489, 210112, 210100, N'浑南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (490, 210113, 210100, N'沈北新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (491, 210114, 210100, N'于洪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (492, 210115, 210100, N'辽中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (493, 210123, 210100, N'康平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (494, 210124, 210100, N'法库县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (495, 210181, 210100, N'新民市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (496, 210182, 210100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (497, 210200, 210000, N'大连市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (498, 210202, 210200, N'中山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (499, 210203, 210200, N'西岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (500, 210204, 210200, N'沙河口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (501, 210211, 210200, N'甘井子区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (502, 210212, 210200, N'旅顺口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (503, 210213, 210200, N'金州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (504, 210214, 210200, N'普兰店区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (505, 210224, 210200, N'长海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (506, 210281, 210200, N'瓦房店市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (507, 210283, 210200, N'庄河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (508, 210284, 210200, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (509, 210285, 210200, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (510, 210286, 210200, N'金普新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (511, 210300, 210000, N'鞍山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (512, 210302, 210300, N'铁东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (513, 210303, 210300, N'铁西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (514, 210304, 210300, N'立山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (515, 210311, 210300, N'千山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (516, 210321, 210300, N'台安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (517, 210323, 210300, N'岫岩满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (518, 210381, 210300, N'海城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (519, 210382, 210300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (520, 210400, 210000, N'抚顺市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (521, 210402, 210400, N'新抚区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (522, 210403, 210400, N'东洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (523, 210404, 210400, N'望花区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (524, 210411, 210400, N'顺城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (525, 210421, 210400, N'抚顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (526, 210422, 210400, N'新宾满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (527, 210423, 210400, N'清原满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (528, 210500, 210000, N'本溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (529, 210502, 210500, N'平山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (530, 210503, 210500, N'溪湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (531, 210504, 210500, N'明山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (532, 210505, 210500, N'南芬区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (533, 210521, 210500, N'本溪满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (534, 210522, 210500, N'桓仁满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (535, 210600, 210000, N'丹东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (536, 210602, 210600, N'元宝区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (537, 210603, 210600, N'振兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (538, 210604, 210600, N'振安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (539, 210624, 210600, N'宽甸满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (540, 210681, 210600, N'东港市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (541, 210682, 210600, N'凤城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (542, 210700, 210000, N'锦州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (543, 210702, 210700, N'古塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (544, 210703, 210700, N'凌河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (545, 210711, 210700, N'太和区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (546, 210726, 210700, N'黑山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (547, 210727, 210700, N'义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (548, 210781, 210700, N'凌海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (549, 210782, 210700, N'北镇市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (550, 210783, 210700, N'松山新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (551, 210784, 210700, N'龙栖湾新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (552, 210785, 210700, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (553, 210800, 210000, N'营口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (554, 210802, 210800, N'站前区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (555, 210803, 210800, N'西市区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (556, 210804, 210800, N'鲅鱼圈区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (557, 210811, 210800, N'老边区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (558, 210881, 210800, N'盖州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (559, 210882, 210800, N'大石桥市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (560, 210900, 210000, N'阜新市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (561, 210902, 210900, N'海州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (562, 210903, 210900, N'新邱区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (563, 210904, 210900, N'太平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (564, 210905, 210900, N'清河门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (565, 210911, 210900, N'细河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (566, 210921, 210900, N'阜新蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (567, 210922, 210900, N'彰武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (568, 211000, 210000, N'辽阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (569, 211002, 211000, N'白塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (570, 211003, 211000, N'文圣区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (571, 211004, 211000, N'宏伟区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (572, 211005, 211000, N'弓长岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (573, 211011, 211000, N'太子河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (574, 211021, 211000, N'辽阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (575, 211081, 211000, N'灯塔市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (576, 211100, 210000, N'盘锦市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (577, 211102, 211100, N'双台子区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (578, 211103, 211100, N'兴隆台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (579, 211104, 211100, N'大洼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (580, 211122, 211100, N'盘山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (581, 211200, 210000, N'铁岭市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (582, 211202, 211200, N'银州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (583, 211204, 211200, N'清河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (584, 211221, 211200, N'铁岭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (585, 211223, 211200, N'西丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (586, 211224, 211200, N'昌图县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (587, 211281, 211200, N'调兵山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (588, 211282, 211200, N'开原市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (589, 211300, 210000, N'朝阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (590, 211302, 211300, N'双塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (591, 211303, 211300, N'龙城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (592, 211321, 211300, N'朝阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (593, 211322, 211300, N'建平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (594, 211324, 211300, N'喀喇沁左翼蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (595, 211381, 211300, N'北票市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (596, 211382, 211300, N'凌源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (597, 211400, 210000, N'葫芦岛市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (598, 211402, 211400, N'连山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (599, 211403, 211400, N'龙港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (600, 211404, 211400, N'南票区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (601, 211421, 211400, N'绥中县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (602, 211422, 211400, N'建昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (603, 211481, 211400, N'兴城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (604, 220000, 100000, N'吉林省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (605, 220100, 220000, N'长春市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (606, 220102, 220100, N'南关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (607, 220103, 220100, N'宽城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (608, 220104, 220100, N'朝阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (609, 220105, 220100, N'二道区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (610, 220106, 220100, N'绿园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (611, 220112, 220100, N'双阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (612, 220113, 220100, N'九台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (613, 220122, 220100, N'农安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (614, 220182, 220100, N'榆树市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (615, 220183, 220100, N'德惠市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (616, 220184, 220100, N'长春新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (617, 220185, 220100, N'高新技术产业开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (618, 220186, 220100, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (619, 220187, 220100, N'汽车产业开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (620, 220188, 220100, N'兴隆综合保税区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (621, 220200, 220000, N'吉林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (622, 220202, 220200, N'昌邑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (623, 220203, 220200, N'龙潭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (624, 220204, 220200, N'船营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (625, 220211, 220200, N'丰满区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (626, 220221, 220200, N'永吉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (627, 220281, 220200, N'蛟河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (628, 220282, 220200, N'桦甸市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (629, 220283, 220200, N'舒兰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (630, 220284, 220200, N'磐石市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (631, 220285, 220200, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (632, 220300, 220000, N'四平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (633, 220302, 220300, N'铁西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (634, 220303, 220300, N'铁东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (635, 220322, 220300, N'梨树县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (636, 220323, 220300, N'伊通满族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (637, 220381, 220300, N'公主岭市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (638, 220382, 220300, N'双辽市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (639, 220400, 220000, N'辽源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (640, 220402, 220400, N'龙山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (641, 220403, 220400, N'西安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (642, 220421, 220400, N'东丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (643, 220422, 220400, N'东辽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (644, 220500, 220000, N'通化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (645, 220502, 220500, N'东昌区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (646, 220503, 220500, N'二道江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (647, 220521, 220500, N'通化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (648, 220523, 220500, N'辉南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (649, 220524, 220500, N'柳河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (650, 220581, 220500, N'梅河口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (651, 220582, 220500, N'集安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (652, 220600, 220000, N'白山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (653, 220602, 220600, N'浑江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (654, 220605, 220600, N'江源区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (655, 220621, 220600, N'抚松县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (656, 220622, 220600, N'靖宇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (657, 220623, 220600, N'长白朝鲜族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (658, 220681, 220600, N'临江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (659, 220700, 220000, N'松原市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (660, 220702, 220700, N'宁江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (661, 220721, 220700, N'前郭尔罗斯蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (662, 220722, 220700, N'长岭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (663, 220723, 220700, N'乾安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (664, 220781, 220700, N'扶余市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (665, 220800, 220000, N'白城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (666, 220802, 220800, N'洮北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (667, 220821, 220800, N'镇赉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (668, 220822, 220800, N'通榆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (669, 220881, 220800, N'洮南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (670, 220882, 220800, N'大安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (671, 222400, 220000, N'延边朝鲜族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (672, 222401, 222400, N'延吉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (673, 222402, 222400, N'图们市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (674, 222403, 222400, N'敦化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (675, 222404, 222400, N'珲春市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (676, 222405, 222400, N'龙井市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (677, 222406, 222400, N'和龙市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (678, 222424, 222400, N'汪清县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (679, 222426, 222400, N'安图县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (680, 230000, 100000, N'黑龙江省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (681, 230100, 230000, N'哈尔滨市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (682, 230102, 230100, N'道里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (683, 230103, 230100, N'南岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (684, 230104, 230100, N'道外区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (685, 230108, 230100, N'平房区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (686, 230109, 230100, N'松北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (687, 230110, 230100, N'香坊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (688, 230111, 230100, N'呼兰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (689, 230112, 230100, N'阿城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (690, 230113, 230100, N'双城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (691, 230123, 230100, N'依兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (692, 230124, 230100, N'方正县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (693, 230125, 230100, N'宾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (694, 230126, 230100, N'巴彦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (695, 230127, 230100, N'木兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (696, 230128, 230100, N'通河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (697, 230129, 230100, N'延寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (698, 230183, 230100, N'尚志市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (699, 230184, 230100, N'五常市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (700, 230185, 230100, N'哈尔滨新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (701, 230186, 230100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (702, 230200, 230000, N'齐齐哈尔市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (703, 230202, 230200, N'龙沙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (704, 230203, 230200, N'建华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (705, 230204, 230200, N'铁锋区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (706, 230205, 230200, N'昂昂溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (707, 230206, 230200, N'富拉尔基区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (708, 230207, 230200, N'碾子山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (709, 230208, 230200, N'梅里斯达斡尔族区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (710, 230221, 230200, N'龙江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (711, 230223, 230200, N'依安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (712, 230224, 230200, N'泰来县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (713, 230225, 230200, N'甘南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (714, 230227, 230200, N'富裕县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (715, 230229, 230200, N'克山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (716, 230230, 230200, N'克东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (717, 230231, 230200, N'拜泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (718, 230281, 230200, N'讷河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (719, 230282, 230200, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (720, 230300, 230000, N'鸡西市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (721, 230302, 230300, N'鸡冠区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (722, 230303, 230300, N'恒山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (723, 230304, 230300, N'滴道区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (724, 230305, 230300, N'梨树区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (725, 230306, 230300, N'城子河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (726, 230307, 230300, N'麻山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (727, 230321, 230300, N'鸡东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (728, 230381, 230300, N'虎林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (729, 230382, 230300, N'密山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (730, 230400, 230000, N'鹤岗市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (731, 230402, 230400, N'向阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (732, 230403, 230400, N'工农区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (733, 230404, 230400, N'南山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (734, 230405, 230400, N'兴安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (735, 230406, 230400, N'东山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (736, 230407, 230400, N'兴山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (737, 230421, 230400, N'萝北县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (738, 230422, 230400, N'绥滨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (739, 230500, 230000, N'双鸭山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (740, 230502, 230500, N'尖山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (741, 230503, 230500, N'岭东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (742, 230505, 230500, N'四方台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (743, 230506, 230500, N'宝山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (744, 230521, 230500, N'集贤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (745, 230522, 230500, N'友谊县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (746, 230523, 230500, N'宝清县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (747, 230524, 230500, N'饶河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (748, 230600, 230000, N'大庆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (749, 230602, 230600, N'萨尔图区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (750, 230603, 230600, N'龙凤区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (751, 230604, 230600, N'让胡路区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (752, 230605, 230600, N'红岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (753, 230606, 230600, N'大同区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (754, 230621, 230600, N'肇州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (755, 230622, 230600, N'肇源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (756, 230623, 230600, N'林甸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (757, 230624, 230600, N'杜尔伯特蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (758, 230625, 230600, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (759, 230700, 230000, N'伊春市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (760, 230702, 230700, N'伊春区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (761, 230703, 230700, N'南岔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (762, 230704, 230700, N'友好区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (763, 230705, 230700, N'西林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (764, 230706, 230700, N'翠峦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (765, 230707, 230700, N'新青区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (766, 230708, 230700, N'美溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (767, 230709, 230700, N'金山屯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (768, 230710, 230700, N'五营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (769, 230711, 230700, N'乌马河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (770, 230712, 230700, N'汤旺河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (771, 230713, 230700, N'带岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (772, 230714, 230700, N'乌伊岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (773, 230715, 230700, N'红星区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (774, 230716, 230700, N'上甘岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (775, 230722, 230700, N'嘉荫县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (776, 230781, 230700, N'铁力市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (777, 230800, 230000, N'佳木斯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (778, 230803, 230800, N'向阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (779, 230804, 230800, N'前进区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (780, 230805, 230800, N'东风区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (781, 230811, 230800, N'郊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (782, 230822, 230800, N'桦南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (783, 230826, 230800, N'桦川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (784, 230828, 230800, N'汤原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (785, 230881, 230800, N'同江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (786, 230882, 230800, N'富锦市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (787, 230883, 230800, N'抚远市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (788, 230900, 230000, N'七台河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (789, 230902, 230900, N'新兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (790, 230903, 230900, N'桃山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (791, 230904, 230900, N'茄子河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (792, 230921, 230900, N'勃利县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (793, 231000, 230000, N'牡丹江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (794, 231002, 231000, N'东安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (795, 231003, 231000, N'阳明区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (796, 231004, 231000, N'爱民区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (797, 231005, 231000, N'西安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (798, 231025, 231000, N'林口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (799, 231081, 231000, N'绥芬河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (800, 231083, 231000, N'海林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (801, 231084, 231000, N'宁安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (802, 231085, 231000, N'穆棱市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (803, 231086, 231000, N'东宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (804, 231100, 230000, N'黑河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (805, 231102, 231100, N'爱辉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (806, 231121, 231100, N'嫩江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (807, 231123, 231100, N'逊克县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (808, 231124, 231100, N'孙吴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (809, 231181, 231100, N'北安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (810, 231182, 231100, N'五大连池市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (811, 231200, 230000, N'绥化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (812, 231202, 231200, N'北林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (813, 231221, 231200, N'望奎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (814, 231222, 231200, N'兰西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (815, 231223, 231200, N'青冈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (816, 231224, 231200, N'庆安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (817, 231225, 231200, N'明水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (818, 231226, 231200, N'绥棱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (819, 231281, 231200, N'安达市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (820, 231282, 231200, N'肇东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (821, 231283, 231200, N'海伦市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (822, 232700, 230000, N'大兴安岭地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (823, 232701, 232700, N'加格达奇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (824, 232702, 232700, N'新林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (825, 232703, 232700, N'松岭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (826, 232704, 232700, N'呼中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (827, 232721, 232700, N'呼玛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (828, 232722, 232700, N'塔河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (829, 232723, 232700, N'漠河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (830, 310000, 100000, N'上海')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (831, 310100, 310000, N'上海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (832, 310101, 310100, N'黄浦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (833, 310104, 310100, N'徐汇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (834, 310105, 310100, N'长宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (835, 310106, 310100, N'静安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (836, 310107, 310100, N'普陀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (837, 310109, 310100, N'虹口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (838, 310110, 310100, N'杨浦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (839, 310112, 310100, N'闵行区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (840, 310113, 310100, N'宝山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (841, 310114, 310100, N'嘉定区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (842, 310115, 310100, N'浦东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (843, 310116, 310100, N'金山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (844, 310117, 310100, N'松江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (845, 310118, 310100, N'青浦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (846, 310120, 310100, N'奉贤区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (847, 310151, 310100, N'崇明区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (848, 310231, 310100, N'张江高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (849, 310232, 310100, N'紫竹高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (850, 310233, 310100, N'漕河泾开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (851, 320000, 100000, N'江苏省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (852, 320100, 320000, N'南京市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (853, 320102, 320100, N'玄武区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (854, 320104, 320100, N'秦淮区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (855, 320105, 320100, N'建邺区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (856, 320106, 320100, N'鼓楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (857, 320111, 320100, N'浦口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (858, 320113, 320100, N'栖霞区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (859, 320114, 320100, N'雨花台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (860, 320115, 320100, N'江宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (861, 320116, 320100, N'六合区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (862, 320117, 320100, N'溧水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (863, 320118, 320100, N'高淳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (864, 320119, 320100, N'江北新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (865, 320120, 320100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (866, 320200, 320000, N'无锡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (867, 320205, 320200, N'锡山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (868, 320206, 320200, N'惠山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (869, 320211, 320200, N'滨湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (870, 320213, 320200, N'梁溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (871, 320214, 320200, N'新吴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (872, 320281, 320200, N'江阴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (873, 320282, 320200, N'宜兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (874, 320300, 320000, N'徐州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (875, 320302, 320300, N'鼓楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (876, 320303, 320300, N'云龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (877, 320305, 320300, N'贾汪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (878, 320311, 320300, N'泉山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (879, 320312, 320300, N'铜山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (880, 320321, 320300, N'丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (881, 320322, 320300, N'沛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (882, 320324, 320300, N'睢宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (883, 320381, 320300, N'新沂市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (884, 320382, 320300, N'邳州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (885, 320383, 320300, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (886, 320384, 320300, N'高新技术产业开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (887, 320385, 320300, N'软件园')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (888, 320400, 320000, N'常州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (889, 320402, 320400, N'天宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (890, 320404, 320400, N'钟楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (891, 320411, 320400, N'新北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (892, 320412, 320400, N'武进区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (893, 320413, 320400, N'金坛区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (894, 320481, 320400, N'溧阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (895, 320482, 320400, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (896, 320500, 320000, N'苏州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (897, 320505, 320500, N'虎丘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (898, 320506, 320500, N'吴中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (899, 320507, 320500, N'相城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (900, 320508, 320500, N'姑苏区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (901, 320509, 320500, N'吴江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (902, 320581, 320500, N'常熟市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (903, 320582, 320500, N'张家港市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (904, 320583, 320500, N'昆山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (905, 320585, 320500, N'太仓市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (906, 320586, 320500, N'苏州新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (907, 320587, 320500, N'工业园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (908, 320588, 320500, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (909, 320600, 320000, N'南通市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (910, 320602, 320600, N'崇川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (911, 320611, 320600, N'港闸区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (912, 320612, 320600, N'通州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (913, 320621, 320600, N'海安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (914, 320623, 320600, N'如东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (915, 320681, 320600, N'启东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (916, 320682, 320600, N'如皋市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (917, 320684, 320600, N'海门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (918, 320685, 320600, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (919, 320700, 320000, N'连云港市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (920, 320703, 320700, N'连云区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (921, 320706, 320700, N'海州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (922, 320707, 320700, N'赣榆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (923, 320722, 320700, N'东海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (924, 320723, 320700, N'灌云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (925, 320724, 320700, N'灌南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (926, 320725, 320700, N'新海新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (927, 320726, 320700, N'连云新城')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (928, 320727, 320700, N'徐圩新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (929, 320728, 320700, N'济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (930, 320800, 320000, N'淮安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (931, 320803, 320800, N'淮安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (932, 320804, 320800, N'淮阴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (933, 320812, 320800, N'清江浦区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (934, 320813, 320800, N'洪泽区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (935, 320826, 320800, N'涟水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (936, 320830, 320800, N'盱眙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (937, 320831, 320800, N'金湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (938, 320832, 320800, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (939, 320900, 320000, N'盐城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (940, 320902, 320900, N'亭湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (941, 320903, 320900, N'盐都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (942, 320904, 320900, N'大丰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (943, 320921, 320900, N'响水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (944, 320922, 320900, N'滨海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (945, 320923, 320900, N'阜宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (946, 320924, 320900, N'射阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (947, 320925, 320900, N'建湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (948, 320981, 320900, N'东台市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (949, 321000, 320000, N'扬州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (950, 321002, 321000, N'广陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (951, 321003, 321000, N'邗江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (952, 321012, 321000, N'江都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (953, 321023, 321000, N'宝应县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (954, 321081, 321000, N'仪征市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (955, 321084, 321000, N'高邮市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (956, 321100, 320000, N'镇江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (957, 321102, 321100, N'京口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (958, 321111, 321100, N'润州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (959, 321112, 321100, N'丹徒区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (960, 321181, 321100, N'丹阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (961, 321182, 321100, N'扬中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (962, 321183, 321100, N'句容市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (963, 321184, 321100, N'镇江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (964, 321185, 321100, N'镇江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (965, 321186, 321100, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (966, 321200, 320000, N'泰州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (967, 321202, 321200, N'海陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (968, 321203, 321200, N'高港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (969, 321204, 321200, N'姜堰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (970, 321281, 321200, N'兴化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (971, 321282, 321200, N'靖江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (972, 321283, 321200, N'泰兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (973, 321300, 320000, N'宿迁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (974, 321302, 321300, N'宿城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (975, 321311, 321300, N'宿豫区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (976, 321322, 321300, N'沭阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (977, 321323, 321300, N'泗阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (978, 321324, 321300, N'泗洪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (979, 321325, 321300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (980, 330000, 100000, N'浙江省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (981, 330100, 330000, N'杭州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (982, 330102, 330100, N'上城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (983, 330103, 330100, N'下城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (984, 330104, 330100, N'江干区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (985, 330105, 330100, N'拱墅区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (986, 330106, 330100, N'西湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (987, 330108, 330100, N'滨江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (988, 330109, 330100, N'萧山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (989, 330110, 330100, N'余杭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (990, 330111, 330100, N'富阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (991, 330122, 330100, N'桐庐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (992, 330127, 330100, N'淳安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (993, 330182, 330100, N'建德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (994, 330185, 330100, N'临安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (995, 330186, 330100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (996, 330200, 330000, N'宁波市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (997, 330203, 330200, N'海曙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (998, 330205, 330200, N'江北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (999, 330206, 330200, N'北仑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1000, 330211, 330200, N'镇海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1001, 330212, 330200, N'鄞州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1002, 330213, 330200, N'奉化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1003, 330225, 330200, N'象山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1004, 330226, 330200, N'宁海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1005, 330281, 330200, N'余姚市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1006, 330282, 330200, N'慈溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1007, 330284, 330200, N'杭州湾新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1008, 330285, 330200, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1009, 330300, 330000, N'温州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1010, 330302, 330300, N'鹿城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1011, 330303, 330300, N'龙湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1012, 330304, 330300, N'瓯海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1013, 330305, 330300, N'洞头区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1014, 330324, 330300, N'永嘉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1015, 330326, 330300, N'平阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1016, 330327, 330300, N'苍南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1017, 330328, 330300, N'文成县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1018, 330329, 330300, N'泰顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1019, 330381, 330300, N'瑞安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1020, 330382, 330300, N'乐清市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1021, 330400, 330000, N'嘉兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1022, 330402, 330400, N'南湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1023, 330411, 330400, N'秀洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1024, 330421, 330400, N'嘉善县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1025, 330424, 330400, N'海盐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1026, 330481, 330400, N'海宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1027, 330482, 330400, N'平湖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1028, 330483, 330400, N'桐乡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1029, 330500, 330000, N'湖州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1030, 330502, 330500, N'吴兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1031, 330503, 330500, N'南浔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1032, 330521, 330500, N'德清县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1033, 330522, 330500, N'长兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1034, 330523, 330500, N'安吉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1035, 330600, 330000, N'绍兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1036, 330602, 330600, N'越城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1037, 330603, 330600, N'柯桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1038, 330604, 330600, N'上虞区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1039, 330624, 330600, N'新昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1040, 330681, 330600, N'诸暨市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1041, 330683, 330600, N'嵊州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1042, 330700, 330000, N'金华市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1043, 330702, 330700, N'婺城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1044, 330703, 330700, N'金东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1045, 330723, 330700, N'武义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1046, 330726, 330700, N'浦江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1047, 330727, 330700, N'磐安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1048, 330781, 330700, N'兰溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1049, 330782, 330700, N'义乌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1050, 330783, 330700, N'东阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1051, 330784, 330700, N'永康市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1052, 330800, 330000, N'衢州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1053, 330802, 330800, N'柯城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1054, 330803, 330800, N'衢江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1055, 330822, 330800, N'常山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1056, 330824, 330800, N'开化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1057, 330825, 330800, N'龙游县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1058, 330881, 330800, N'江山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1059, 330900, 330000, N'舟山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1060, 330902, 330900, N'定海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1061, 330903, 330900, N'普陀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1062, 330921, 330900, N'岱山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1063, 330922, 330900, N'嵊泗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1064, 331000, 330000, N'台州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1065, 331002, 331000, N'椒江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1066, 331003, 331000, N'黄岩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1067, 331004, 331000, N'路桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1068, 331021, 331000, N'玉环市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1069, 331022, 331000, N'三门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1070, 331023, 331000, N'天台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1071, 331024, 331000, N'仙居县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1072, 331081, 331000, N'温岭市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1073, 331082, 331000, N'临海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1074, 331100, 330000, N'丽水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1075, 331102, 331100, N'莲都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1076, 331121, 331100, N'青田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1077, 331122, 331100, N'缙云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1078, 331123, 331100, N'遂昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1079, 331124, 331100, N'松阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1080, 331125, 331100, N'云和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1081, 331126, 331100, N'庆元县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1082, 331127, 331100, N'景宁畲族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1083, 331181, 331100, N'龙泉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1084, 331200, 330000, N'舟山群岛新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1085, 331201, 331200, N'金塘岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1086, 331202, 331200, N'六横岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1087, 331203, 331200, N'衢山岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1088, 331204, 331200, N'舟山本岛西北部')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1089, 331205, 331200, N'岱山岛西南部')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1090, 331206, 331200, N'泗礁岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1091, 331207, 331200, N'朱家尖岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1092, 331208, 331200, N'洋山岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1093, 331209, 331200, N'长涂岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1094, 331210, 331200, N'虾峙岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1095, 340000, 100000, N'安徽省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1096, 340100, 340000, N'合肥市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1097, 340102, 340100, N'瑶海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1098, 340103, 340100, N'庐阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1099, 340104, 340100, N'蜀山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1100, 340111, 340100, N'包河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1101, 340121, 340100, N'长丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1102, 340122, 340100, N'肥东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1103, 340123, 340100, N'肥西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1104, 340124, 340100, N'庐江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1105, 340181, 340100, N'巢湖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1106, 340184, 340100, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1107, 340185, 340100, N'高新技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1108, 340186, 340100, N'北城新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1109, 340187, 340100, N'滨湖新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1110, 340188, 340100, N'政务文化新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1111, 340189, 340100, N'新站综合开发试验区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1112, 340200, 340000, N'芜湖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1113, 340202, 340200, N'镜湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1114, 340203, 340200, N'弋江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1115, 340207, 340200, N'鸠江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1116, 340208, 340200, N'三山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1117, 340221, 340200, N'芜湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1118, 340222, 340200, N'繁昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1119, 340223, 340200, N'南陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1120, 340225, 340200, N'无为县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1121, 340226, 340200, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1122, 340300, 340000, N'蚌埠市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1123, 340302, 340300, N'龙子湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1124, 340303, 340300, N'蚌山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1125, 340304, 340300, N'禹会区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1126, 340311, 340300, N'淮上区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1127, 340321, 340300, N'怀远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1128, 340322, 340300, N'五河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1129, 340323, 340300, N'固镇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1130, 340324, 340300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1131, 340400, 340000, N'淮南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1132, 340402, 340400, N'大通区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1133, 340403, 340400, N'田家庵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1134, 340404, 340400, N'谢家集区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1135, 340405, 340400, N'八公山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1136, 340406, 340400, N'潘集区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1137, 340421, 340400, N'凤台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1138, 340422, 340400, N'寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1139, 340423, 340400, N'山南新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1140, 340424, 340400, N'毛集实验区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1141, 340425, 340400, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1142, 340500, 340000, N'马鞍山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1143, 340503, 340500, N'花山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1144, 340504, 340500, N'雨山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1145, 340506, 340500, N'博望区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1146, 340521, 340500, N'当涂县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1147, 340522, 340500, N'含山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1148, 340523, 340500, N'和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1149, 340600, 340000, N'淮北市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1150, 340602, 340600, N'杜集区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1151, 340603, 340600, N'相山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1152, 340604, 340600, N'烈山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1153, 340621, 340600, N'濉溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1154, 340700, 340000, N'铜陵市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1155, 340705, 340700, N'铜官区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1156, 340706, 340700, N'义安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1157, 340711, 340700, N'郊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1158, 340722, 340700, N'枞阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1159, 340800, 340000, N'安庆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1160, 340802, 340800, N'迎江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1161, 340803, 340800, N'大观区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1162, 340811, 340800, N'宜秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1163, 340822, 340800, N'怀宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1164, 340824, 340800, N'潜山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1165, 340825, 340800, N'太湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1166, 340826, 340800, N'宿松县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1167, 340827, 340800, N'望江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1168, 340828, 340800, N'岳西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1169, 340881, 340800, N'桐城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1170, 341000, 340000, N'黄山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1171, 341002, 341000, N'屯溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1172, 341003, 341000, N'黄山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1173, 341004, 341000, N'徽州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1174, 341021, 341000, N'歙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1175, 341022, 341000, N'休宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1176, 341023, 341000, N'黟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1177, 341024, 341000, N'祁门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1178, 341100, 340000, N'滁州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1179, 341102, 341100, N'琅琊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1180, 341103, 341100, N'南谯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1181, 341122, 341100, N'来安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1182, 341124, 341100, N'全椒县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1183, 341125, 341100, N'定远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1184, 341126, 341100, N'凤阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1185, 341181, 341100, N'天长市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1186, 341182, 341100, N'明光市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1187, 341200, 340000, N'阜阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1188, 341202, 341200, N'颍州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1189, 341203, 341200, N'颍东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1190, 341204, 341200, N'颍泉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1191, 341221, 341200, N'临泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1192, 341222, 341200, N'太和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1193, 341225, 341200, N'阜南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1194, 341226, 341200, N'颍上县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1195, 341282, 341200, N'界首市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1196, 341283, 341200, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1197, 341300, 340000, N'宿州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1198, 341302, 341300, N'埇桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1199, 341321, 341300, N'砀山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1200, 341322, 341300, N'萧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1201, 341323, 341300, N'灵璧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1202, 341324, 341300, N'泗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1203, 341325, 341300, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1204, 341500, 340000, N'六安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1205, 341502, 341500, N'金安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1206, 341503, 341500, N'裕安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1207, 341504, 341500, N'叶集区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1208, 341522, 341500, N'霍邱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1209, 341523, 341500, N'舒城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1210, 341524, 341500, N'金寨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1211, 341525, 341500, N'霍山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1212, 341600, 340000, N'亳州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1213, 341602, 341600, N'谯城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1214, 341621, 341600, N'涡阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1215, 341622, 341600, N'蒙城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1216, 341623, 341600, N'利辛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1217, 341700, 340000, N'池州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1218, 341702, 341700, N'贵池区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1219, 341721, 341700, N'东至县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1220, 341722, 341700, N'石台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1221, 341723, 341700, N'青阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1222, 341800, 340000, N'宣城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1223, 341802, 341800, N'宣州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1224, 341821, 341800, N'郎溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1225, 341822, 341800, N'广德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1226, 341823, 341800, N'泾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1227, 341824, 341800, N'绩溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1228, 341825, 341800, N'旌德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1229, 341881, 341800, N'宁国市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1230, 350000, 100000, N'福建省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1231, 350100, 350000, N'福州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1232, 350102, 350100, N'鼓楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1233, 350103, 350100, N'台江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1234, 350104, 350100, N'仓山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1235, 350105, 350100, N'马尾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1236, 350111, 350100, N'晋安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1237, 350121, 350100, N'闽侯县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1238, 350122, 350100, N'连江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1239, 350123, 350100, N'罗源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1240, 350124, 350100, N'闽清县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1241, 350125, 350100, N'永泰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1242, 350128, 350100, N'平潭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1243, 350181, 350100, N'福清市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1244, 350182, 350100, N'长乐市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1245, 350183, 350100, N'福州新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1246, 350200, 350000, N'厦门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1247, 350203, 350200, N'思明区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1248, 350205, 350200, N'海沧区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1249, 350206, 350200, N'湖里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1250, 350211, 350200, N'集美区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1251, 350212, 350200, N'同安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1252, 350213, 350200, N'翔安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1253, 350300, 350000, N'莆田市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1254, 350302, 350300, N'城厢区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1255, 350303, 350300, N'涵江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1256, 350304, 350300, N'荔城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1257, 350305, 350300, N'秀屿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1258, 350322, 350300, N'仙游县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1259, 350400, 350000, N'三明市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1260, 350402, 350400, N'梅列区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1261, 350403, 350400, N'三元区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1262, 350421, 350400, N'明溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1263, 350423, 350400, N'清流县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1264, 350424, 350400, N'宁化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1265, 350425, 350400, N'大田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1266, 350426, 350400, N'尤溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1267, 350427, 350400, N'沙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1268, 350428, 350400, N'将乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1269, 350429, 350400, N'泰宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1270, 350430, 350400, N'建宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1271, 350481, 350400, N'永安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1272, 350500, 350000, N'泉州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1273, 350502, 350500, N'鲤城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1274, 350503, 350500, N'丰泽区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1275, 350504, 350500, N'洛江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1276, 350505, 350500, N'泉港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1277, 350521, 350500, N'惠安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1278, 350524, 350500, N'安溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1279, 350525, 350500, N'永春县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1280, 350526, 350500, N'德化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1281, 350527, 350500, N'金门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1282, 350581, 350500, N'石狮市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1283, 350582, 350500, N'晋江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1284, 350583, 350500, N'南安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1285, 350584, 350500, N'台商投资区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1286, 350585, 350500, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1287, 350586, 350500, N'高新技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1288, 350587, 350500, N'综合保税区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1289, 350600, 350000, N'漳州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1290, 350602, 350600, N'芗城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1291, 350603, 350600, N'龙文区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1292, 350622, 350600, N'云霄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1293, 350623, 350600, N'漳浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1294, 350624, 350600, N'诏安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1295, 350625, 350600, N'长泰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1296, 350626, 350600, N'东山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1297, 350627, 350600, N'南靖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1298, 350628, 350600, N'平和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1299, 350629, 350600, N'华安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1300, 350681, 350600, N'龙海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1301, 350700, 350000, N'南平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1302, 350702, 350700, N'延平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1303, 350703, 350700, N'建阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1304, 350721, 350700, N'顺昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1305, 350722, 350700, N'浦城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1306, 350723, 350700, N'光泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1307, 350724, 350700, N'松溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1308, 350725, 350700, N'政和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1309, 350781, 350700, N'邵武市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1310, 350782, 350700, N'武夷山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1311, 350783, 350700, N'建瓯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1312, 350800, 350000, N'龙岩市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1313, 350802, 350800, N'新罗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1314, 350803, 350800, N'永定区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1315, 350821, 350800, N'长汀县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1316, 350823, 350800, N'上杭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1317, 350824, 350800, N'武平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1318, 350825, 350800, N'连城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1319, 350881, 350800, N'漳平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1320, 350900, 350000, N'宁德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1321, 350902, 350900, N'蕉城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1322, 350921, 350900, N'霞浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1323, 350922, 350900, N'古田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1324, 350923, 350900, N'屏南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1325, 350924, 350900, N'寿宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1326, 350925, 350900, N'周宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1327, 350926, 350900, N'柘荣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1328, 350981, 350900, N'福安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1329, 350982, 350900, N'福鼎市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1330, 350983, 350900, N'东侨开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1331, 360000, 100000, N'江西省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1332, 360100, 360000, N'南昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1333, 360102, 360100, N'东湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1334, 360103, 360100, N'西湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1335, 360104, 360100, N'青云谱区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1336, 360105, 360100, N'湾里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1337, 360111, 360100, N'青山湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1338, 360112, 360100, N'新建区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1339, 360121, 360100, N'南昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1340, 360123, 360100, N'安义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1341, 360124, 360100, N'进贤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1342, 360125, 360100, N'红谷滩新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1343, 360126, 360100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1344, 360127, 360100, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1345, 360128, 360100, N'小蓝开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1346, 360129, 360100, N'桑海开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1347, 360130, 360100, N'望城新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1348, 360131, 360100, N'赣江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1349, 360200, 360000, N'景德镇市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1350, 360202, 360200, N'昌江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1351, 360203, 360200, N'珠山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1352, 360222, 360200, N'浮梁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1353, 360281, 360200, N'乐平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1354, 360300, 360000, N'萍乡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1355, 360302, 360300, N'安源区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1356, 360313, 360300, N'湘东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1357, 360321, 360300, N'莲花县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1358, 360322, 360300, N'上栗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1359, 360323, 360300, N'芦溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1360, 360400, 360000, N'九江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1361, 360402, 360400, N'濂溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1362, 360403, 360400, N'浔阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1363, 360421, 360400, N'九江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1364, 360423, 360400, N'武宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1365, 360424, 360400, N'修水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1366, 360425, 360400, N'永修县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1367, 360426, 360400, N'德安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1368, 360428, 360400, N'都昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1369, 360429, 360400, N'湖口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1370, 360430, 360400, N'彭泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1371, 360481, 360400, N'瑞昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1372, 360482, 360400, N'共青城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1373, 360483, 360400, N'庐山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1374, 360484, 360400, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1375, 360485, 360400, N'八里湖新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1376, 360486, 360400, N'庐山风景名胜区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1377, 360500, 360000, N'新余市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1378, 360502, 360500, N'渝水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1379, 360521, 360500, N'分宜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1380, 360600, 360000, N'鹰潭市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1381, 360602, 360600, N'月湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1382, 360622, 360600, N'余江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1383, 360681, 360600, N'贵溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1384, 360682, 360600, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1385, 360700, 360000, N'赣州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1386, 360702, 360700, N'章贡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1387, 360703, 360700, N'南康区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1388, 360704, 360700, N'赣县区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1389, 360722, 360700, N'信丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1390, 360723, 360700, N'大余县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1391, 360724, 360700, N'上犹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1392, 360725, 360700, N'崇义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1393, 360726, 360700, N'安远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1394, 360727, 360700, N'龙南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1395, 360728, 360700, N'定南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1396, 360729, 360700, N'全南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1397, 360730, 360700, N'宁都县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1398, 360731, 360700, N'于都县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1399, 360732, 360700, N'兴国县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1400, 360733, 360700, N'会昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1401, 360734, 360700, N'寻乌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1402, 360735, 360700, N'石城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1403, 360781, 360700, N'瑞金市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1404, 360782, 360700, N'章康新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1405, 360800, 360000, N'吉安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1406, 360802, 360800, N'吉州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1407, 360803, 360800, N'青原区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1408, 360821, 360800, N'吉安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1409, 360822, 360800, N'吉水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1410, 360823, 360800, N'峡江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1411, 360824, 360800, N'新干县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1412, 360825, 360800, N'永丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1413, 360826, 360800, N'泰和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1414, 360827, 360800, N'遂川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1415, 360828, 360800, N'万安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1416, 360829, 360800, N'安福县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1417, 360830, 360800, N'永新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1418, 360881, 360800, N'井冈山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1419, 360900, 360000, N'宜春市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1420, 360902, 360900, N'袁州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1421, 360921, 360900, N'奉新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1422, 360922, 360900, N'万载县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1423, 360923, 360900, N'上高县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1424, 360924, 360900, N'宜丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1425, 360925, 360900, N'靖安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1426, 360926, 360900, N'铜鼓县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1427, 360981, 360900, N'丰城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1428, 360982, 360900, N'樟树市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1429, 360983, 360900, N'高安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1430, 361000, 360000, N'抚州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1431, 361002, 361000, N'临川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1432, 361003, 361000, N'东乡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1433, 361021, 361000, N'南城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1434, 361022, 361000, N'黎川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1435, 361023, 361000, N'南丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1436, 361024, 361000, N'崇仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1437, 361025, 361000, N'乐安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1438, 361026, 361000, N'宜黄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1439, 361027, 361000, N'金溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1440, 361028, 361000, N'资溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1441, 361030, 361000, N'广昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1442, 361100, 360000, N'上饶市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1443, 361102, 361100, N'信州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1444, 361103, 361100, N'广丰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1445, 361121, 361100, N'上饶县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1446, 361123, 361100, N'玉山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1447, 361124, 361100, N'铅山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1448, 361125, 361100, N'横峰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1449, 361126, 361100, N'弋阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1450, 361127, 361100, N'余干县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1451, 361128, 361100, N'鄱阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1452, 361129, 361100, N'万年县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1453, 361130, 361100, N'婺源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1454, 361181, 361100, N'德兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1455, 370000, 100000, N'山东省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1456, 370100, 370000, N'济南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1457, 370102, 370100, N'历下区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1458, 370103, 370100, N'市中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1459, 370104, 370100, N'槐荫区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1460, 370105, 370100, N'天桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1461, 370112, 370100, N'历城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1462, 370113, 370100, N'长清区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1463, 370114, 370100, N'章丘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1464, 370124, 370100, N'平阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1465, 370125, 370100, N'济阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1466, 370126, 370100, N'商河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1467, 370182, 370100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1468, 370200, 370000, N'青岛市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1469, 370202, 370200, N'市南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1470, 370203, 370200, N'市北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1471, 370211, 370200, N'黄岛区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1472, 370212, 370200, N'崂山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1473, 370213, 370200, N'李沧区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1474, 370214, 370200, N'城阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1475, 370281, 370200, N'胶州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1476, 370282, 370200, N'即墨市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1477, 370283, 370200, N'平度市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1478, 370285, 370200, N'莱西市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1479, 370286, 370200, N'西海岸新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1480, 370287, 370200, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1481, 370300, 370000, N'淄博市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1482, 370302, 370300, N'淄川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1483, 370303, 370300, N'张店区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1484, 370304, 370300, N'博山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1485, 370305, 370300, N'临淄区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1486, 370306, 370300, N'周村区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1487, 370321, 370300, N'桓台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1488, 370322, 370300, N'高青县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1489, 370323, 370300, N'沂源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1490, 370324, 370300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1491, 370400, 370000, N'枣庄市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1492, 370402, 370400, N'市中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1493, 370403, 370400, N'薛城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1494, 370404, 370400, N'峄城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1495, 370405, 370400, N'台儿庄区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1496, 370406, 370400, N'山亭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1497, 370481, 370400, N'滕州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1498, 370482, 370400, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1499, 370500, 370000, N'东营市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1500, 370502, 370500, N'东营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1501, 370503, 370500, N'河口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1502, 370505, 370500, N'垦利区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1503, 370522, 370500, N'利津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1504, 370523, 370500, N'广饶县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1505, 370600, 370000, N'烟台市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1506, 370602, 370600, N'芝罘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1507, 370611, 370600, N'福山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1508, 370612, 370600, N'牟平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1509, 370613, 370600, N'莱山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1510, 370634, 370600, N'长岛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1511, 370681, 370600, N'龙口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1512, 370682, 370600, N'莱阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1513, 370683, 370600, N'莱州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1514, 370684, 370600, N'蓬莱市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1515, 370685, 370600, N'招远市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1516, 370686, 370600, N'栖霞市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1517, 370687, 370600, N'海阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1518, 370688, 370600, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1519, 370689, 370600, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1520, 370700, 370000, N'潍坊市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1521, 370702, 370700, N'潍城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1522, 370703, 370700, N'寒亭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1523, 370704, 370700, N'坊子区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1524, 370705, 370700, N'奎文区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1525, 370724, 370700, N'临朐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1526, 370725, 370700, N'昌乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1527, 370781, 370700, N'青州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1528, 370782, 370700, N'诸城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1529, 370783, 370700, N'寿光市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1530, 370784, 370700, N'安丘市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1531, 370785, 370700, N'高密市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1532, 370786, 370700, N'昌邑市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1533, 370787, 370700, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1534, 370800, 370000, N'济宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1535, 370811, 370800, N'任城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1536, 370812, 370800, N'兖州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1537, 370826, 370800, N'微山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1538, 370827, 370800, N'鱼台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1539, 370828, 370800, N'金乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1540, 370829, 370800, N'嘉祥县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1541, 370830, 370800, N'汶上县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1542, 370831, 370800, N'泗水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1543, 370832, 370800, N'梁山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1544, 370881, 370800, N'曲阜市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1545, 370883, 370800, N'邹城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1546, 370884, 370800, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1547, 370900, 370000, N'泰安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1548, 370902, 370900, N'泰山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1549, 370911, 370900, N'岱岳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1550, 370921, 370900, N'宁阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1551, 370923, 370900, N'东平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1552, 370982, 370900, N'新泰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1553, 370983, 370900, N'肥城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1554, 371000, 370000, N'威海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1555, 371002, 371000, N'环翠区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1556, 371003, 371000, N'文登区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1557, 371082, 371000, N'荣成市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1558, 371083, 371000, N'乳山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1559, 371100, 370000, N'日照市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1560, 371102, 371100, N'东港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1561, 371103, 371100, N'岚山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1562, 371121, 371100, N'五莲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1563, 371122, 371100, N'莒县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1564, 371200, 370000, N'莱芜市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1565, 371202, 371200, N'莱城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1566, 371203, 371200, N'钢城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1567, 371300, 370000, N'临沂市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1568, 371302, 371300, N'兰山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1569, 371311, 371300, N'罗庄区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1570, 371312, 371300, N'河东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1571, 371321, 371300, N'沂南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1572, 371322, 371300, N'郯城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1573, 371323, 371300, N'沂水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1574, 371324, 371300, N'兰陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1575, 371325, 371300, N'费县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1576, 371326, 371300, N'平邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1577, 371327, 371300, N'莒南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1578, 371328, 371300, N'蒙阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1579, 371329, 371300, N'临沭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1580, 371400, 370000, N'德州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1581, 371402, 371400, N'德城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1582, 371403, 371400, N'陵城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1583, 371422, 371400, N'宁津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1584, 371423, 371400, N'庆云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1585, 371424, 371400, N'临邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1586, 371425, 371400, N'齐河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1587, 371426, 371400, N'平原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1588, 371427, 371400, N'夏津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1589, 371428, 371400, N'武城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1590, 371481, 371400, N'乐陵市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1591, 371482, 371400, N'禹城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1592, 371500, 370000, N'聊城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1593, 371502, 371500, N'东昌府区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1594, 371521, 371500, N'阳谷县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1595, 371522, 371500, N'莘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1596, 371523, 371500, N'茌平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1597, 371524, 371500, N'东阿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1598, 371525, 371500, N'冠县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1599, 371526, 371500, N'高唐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1600, 371581, 371500, N'临清市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1601, 371600, 370000, N'滨州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1602, 371602, 371600, N'滨城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1603, 371603, 371600, N'沾化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1604, 371621, 371600, N'惠民县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1605, 371622, 371600, N'阳信县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1606, 371623, 371600, N'无棣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1607, 371625, 371600, N'博兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1608, 371626, 371600, N'邹平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1609, 371627, 371600, N'北海新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1610, 371700, 370000, N'菏泽市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1611, 371702, 371700, N'牡丹区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1612, 371703, 371700, N'定陶区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1613, 371721, 371700, N'曹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1614, 371722, 371700, N'单县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1615, 371723, 371700, N'成武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1616, 371724, 371700, N'巨野县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1617, 371725, 371700, N'郓城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1618, 371726, 371700, N'鄄城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1619, 371728, 371700, N'东明县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1620, 410000, 100000, N'河南省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1621, 410100, 410000, N'郑州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1622, 410102, 410100, N'中原区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1623, 410103, 410100, N'二七区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1624, 410104, 410100, N'管城回族区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1625, 410105, 410100, N'金水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1626, 410106, 410100, N'上街区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1627, 410108, 410100, N'惠济区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1628, 410122, 410100, N'中牟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1629, 410181, 410100, N'巩义市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1630, 410182, 410100, N'荥阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1631, 410183, 410100, N'新密市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1632, 410184, 410100, N'新郑市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1633, 410185, 410100, N'登封市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1634, 410186, 410100, N'郑东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1635, 410187, 410100, N'郑汴新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1636, 410188, 410100, N'高新开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1637, 410189, 410100, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1638, 410200, 410000, N'开封市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1639, 410202, 410200, N'龙亭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1640, 410203, 410200, N'顺河回族区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1641, 410204, 410200, N'鼓楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1642, 410205, 410200, N'禹王台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1643, 410212, 410200, N'祥符区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1644, 410221, 410200, N'杞县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1645, 410222, 410200, N'通许县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1646, 410223, 410200, N'尉氏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1647, 410225, 410200, N'兰考县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1648, 410226, 410200, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1649, 410300, 410000, N'洛阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1650, 410302, 410300, N'老城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1651, 410303, 410300, N'西工区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1652, 410304, 410300, N'瀍河回族区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1653, 410305, 410300, N'涧西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1654, 410306, 410300, N'吉利区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1655, 410311, 410300, N'洛龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1656, 410322, 410300, N'孟津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1657, 410323, 410300, N'新安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1658, 410324, 410300, N'栾川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1659, 410325, 410300, N'嵩县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1660, 410326, 410300, N'汝阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1661, 410327, 410300, N'宜阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1662, 410328, 410300, N'洛宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1663, 410329, 410300, N'伊川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1664, 410381, 410300, N'偃师市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1665, 410382, 410300, N'洛阳新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1666, 410383, 410300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1667, 410400, 410000, N'平顶山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1668, 410402, 410400, N'新华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1669, 410403, 410400, N'卫东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1670, 410404, 410400, N'石龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1671, 410411, 410400, N'湛河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1672, 410421, 410400, N'宝丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1673, 410422, 410400, N'叶县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1674, 410423, 410400, N'鲁山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1675, 410425, 410400, N'郏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1676, 410481, 410400, N'舞钢市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1677, 410482, 410400, N'汝州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1678, 410500, 410000, N'安阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1679, 410502, 410500, N'文峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1680, 410503, 410500, N'北关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1681, 410505, 410500, N'殷都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1682, 410506, 410500, N'龙安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1683, 410522, 410500, N'安阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1684, 410523, 410500, N'汤阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1685, 410526, 410500, N'滑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1686, 410527, 410500, N'内黄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1687, 410581, 410500, N'林州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1688, 410582, 410500, N'安阳新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1689, 410600, 410000, N'鹤壁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1690, 410602, 410600, N'鹤山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1691, 410603, 410600, N'山城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1692, 410611, 410600, N'淇滨区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1693, 410621, 410600, N'浚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1694, 410622, 410600, N'淇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1695, 410700, 410000, N'新乡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1696, 410702, 410700, N'红旗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1697, 410703, 410700, N'卫滨区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1698, 410704, 410700, N'凤泉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1699, 410711, 410700, N'牧野区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1700, 410721, 410700, N'新乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1701, 410724, 410700, N'获嘉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1702, 410725, 410700, N'原阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1703, 410726, 410700, N'延津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1704, 410727, 410700, N'封丘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1705, 410728, 410700, N'长垣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1706, 410781, 410700, N'卫辉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1707, 410782, 410700, N'辉县市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1708, 410800, 410000, N'焦作市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1709, 410802, 410800, N'解放区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1710, 410803, 410800, N'中站区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1711, 410804, 410800, N'马村区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1712, 410811, 410800, N'山阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1713, 410821, 410800, N'修武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1714, 410822, 410800, N'博爱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1715, 410823, 410800, N'武陟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1716, 410825, 410800, N'温县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1717, 410882, 410800, N'沁阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1718, 410883, 410800, N'孟州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1719, 410900, 410000, N'濮阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1720, 410902, 410900, N'华龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1721, 410922, 410900, N'清丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1722, 410923, 410900, N'南乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1723, 410926, 410900, N'范县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1724, 410927, 410900, N'台前县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1725, 410928, 410900, N'濮阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1726, 411000, 410000, N'许昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1727, 411002, 411000, N'魏都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1728, 411003, 411000, N'建安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1729, 411024, 411000, N'鄢陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1730, 411025, 411000, N'襄城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1731, 411081, 411000, N'禹州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1732, 411082, 411000, N'长葛市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1733, 411100, 410000, N'漯河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1734, 411102, 411100, N'源汇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1735, 411103, 411100, N'郾城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1736, 411104, 411100, N'召陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1737, 411121, 411100, N'舞阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1738, 411122, 411100, N'临颍县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1739, 411200, 410000, N'三门峡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1740, 411202, 411200, N'湖滨区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1741, 411203, 411200, N'陕州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1742, 411221, 411200, N'渑池县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1743, 411224, 411200, N'卢氏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1744, 411281, 411200, N'义马市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1745, 411282, 411200, N'灵宝市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1746, 411300, 410000, N'南阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1747, 411302, 411300, N'宛城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1748, 411303, 411300, N'卧龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1749, 411321, 411300, N'南召县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1750, 411322, 411300, N'方城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1751, 411323, 411300, N'西峡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1752, 411324, 411300, N'镇平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1753, 411325, 411300, N'内乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1754, 411326, 411300, N'淅川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1755, 411327, 411300, N'社旗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1756, 411328, 411300, N'唐河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1757, 411329, 411300, N'新野县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1758, 411330, 411300, N'桐柏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1759, 411381, 411300, N'邓州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1760, 411400, 410000, N'商丘市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1761, 411402, 411400, N'梁园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1762, 411403, 411400, N'睢阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1763, 411421, 411400, N'民权县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1764, 411422, 411400, N'睢县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1765, 411423, 411400, N'宁陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1766, 411424, 411400, N'柘城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1767, 411425, 411400, N'虞城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1768, 411426, 411400, N'夏邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1769, 411481, 411400, N'永城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1770, 411500, 410000, N'信阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1771, 411502, 411500, N'浉河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1772, 411503, 411500, N'平桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1773, 411521, 411500, N'罗山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1774, 411522, 411500, N'光山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1775, 411523, 411500, N'新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1776, 411524, 411500, N'商城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1777, 411525, 411500, N'固始县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1778, 411526, 411500, N'潢川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1779, 411527, 411500, N'淮滨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1780, 411528, 411500, N'息县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1781, 411600, 410000, N'周口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1782, 411602, 411600, N'川汇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1783, 411621, 411600, N'扶沟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1784, 411622, 411600, N'西华县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1785, 411623, 411600, N'商水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1786, 411624, 411600, N'沈丘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1787, 411625, 411600, N'郸城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1788, 411626, 411600, N'淮阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1789, 411627, 411600, N'太康县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1790, 411628, 411600, N'鹿邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1791, 411681, 411600, N'项城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1792, 411682, 411600, N'东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1793, 411683, 411600, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1794, 411700, 410000, N'驻马店市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1795, 411702, 411700, N'驿城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1796, 411721, 411700, N'西平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1797, 411722, 411700, N'上蔡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1798, 411723, 411700, N'平舆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1799, 411724, 411700, N'正阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1800, 411725, 411700, N'确山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1801, 411726, 411700, N'泌阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1802, 411727, 411700, N'汝南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1803, 411728, 411700, N'遂平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1804, 411729, 411700, N'新蔡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1805, 419001, 410000, N'济源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1806, 419011, 419001, N'沁园街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1807, 419012, 419001, N'济水街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1808, 419013, 419001, N'北海街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1809, 419014, 419001, N'天坛街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1810, 419015, 419001, N'玉泉街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1811, 419016, 419001, N'克井镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1812, 419017, 419001, N'五龙口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1813, 419018, 419001, N'梨林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1814, 419019, 419001, N'轵城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1815, 419020, 419001, N'承留镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1816, 419021, 419001, N'坡头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1817, 419022, 419001, N'大峪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1818, 419023, 419001, N'邵原镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1819, 419024, 419001, N'思礼镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1820, 419025, 419001, N'王屋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1821, 419026, 419001, N'下冶镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1822, 420000, 100000, N'湖北省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1823, 420100, 420000, N'武汉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1824, 420102, 420100, N'江岸区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1825, 420103, 420100, N'江汉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1826, 420104, 420100, N'硚口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1827, 420105, 420100, N'汉阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1828, 420106, 420100, N'武昌区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1829, 420107, 420100, N'青山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1830, 420111, 420100, N'洪山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1831, 420112, 420100, N'东西湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1832, 420113, 420100, N'汉南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1833, 420114, 420100, N'蔡甸区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1834, 420115, 420100, N'江夏区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1835, 420116, 420100, N'黄陂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1836, 420117, 420100, N'新洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1837, 420118, 420100, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1838, 420200, 420000, N'黄石市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1839, 420202, 420200, N'黄石港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1840, 420203, 420200, N'西塞山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1841, 420204, 420200, N'下陆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1842, 420205, 420200, N'铁山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1843, 420222, 420200, N'阳新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1844, 420281, 420200, N'大冶市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1845, 420282, 420200, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1846, 420300, 420000, N'十堰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1847, 420302, 420300, N'茅箭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1848, 420303, 420300, N'张湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1849, 420304, 420300, N'郧阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1850, 420322, 420300, N'郧西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1851, 420323, 420300, N'竹山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1852, 420324, 420300, N'竹溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1853, 420325, 420300, N'房县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1854, 420381, 420300, N'丹江口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1855, 420500, 420000, N'宜昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1856, 420502, 420500, N'西陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1857, 420503, 420500, N'伍家岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1858, 420504, 420500, N'点军区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1859, 420505, 420500, N'猇亭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1860, 420506, 420500, N'夷陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1861, 420525, 420500, N'远安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1862, 420526, 420500, N'兴山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1863, 420527, 420500, N'秭归县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1864, 420528, 420500, N'长阳土家族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1865, 420529, 420500, N'五峰土家族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1866, 420581, 420500, N'宜都市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1867, 420582, 420500, N'当阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1868, 420583, 420500, N'枝江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1869, 420584, 420500, N'宜昌新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1870, 420600, 420000, N'襄阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1871, 420602, 420600, N'襄城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1872, 420606, 420600, N'樊城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1873, 420607, 420600, N'襄州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1874, 420624, 420600, N'南漳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1875, 420625, 420600, N'谷城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1876, 420626, 420600, N'保康县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1877, 420682, 420600, N'老河口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1878, 420683, 420600, N'枣阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1879, 420684, 420600, N'宜城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1880, 420685, 420600, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1881, 420686, 420600, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1882, 420700, 420000, N'鄂州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1883, 420702, 420700, N'梁子湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1884, 420703, 420700, N'华容区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1885, 420704, 420700, N'鄂城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1886, 420800, 420000, N'荆门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1887, 420802, 420800, N'东宝区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1888, 420804, 420800, N'掇刀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1889, 420821, 420800, N'京山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1890, 420822, 420800, N'沙洋县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1891, 420881, 420800, N'钟祥市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1892, 420900, 420000, N'孝感市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1893, 420902, 420900, N'孝南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1894, 420921, 420900, N'孝昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1895, 420922, 420900, N'大悟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1896, 420923, 420900, N'云梦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1897, 420981, 420900, N'应城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1898, 420982, 420900, N'安陆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1899, 420984, 420900, N'汉川市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1900, 421000, 420000, N'荆州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1901, 421002, 421000, N'沙市区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1902, 421003, 421000, N'荆州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1903, 421022, 421000, N'公安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1904, 421023, 421000, N'监利县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1905, 421024, 421000, N'江陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1906, 421081, 421000, N'石首市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1907, 421083, 421000, N'洪湖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1908, 421087, 421000, N'松滋市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1909, 421100, 420000, N'黄冈市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1910, 421102, 421100, N'黄州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1911, 421121, 421100, N'团风县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1912, 421122, 421100, N'红安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1913, 421123, 421100, N'罗田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1914, 421124, 421100, N'英山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1915, 421125, 421100, N'浠水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1916, 421126, 421100, N'蕲春县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1917, 421127, 421100, N'黄梅县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1918, 421181, 421100, N'麻城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1919, 421182, 421100, N'武穴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1920, 421200, 420000, N'咸宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1921, 421202, 421200, N'咸安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1922, 421221, 421200, N'嘉鱼县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1923, 421222, 421200, N'通城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1924, 421223, 421200, N'崇阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1925, 421224, 421200, N'通山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1926, 421281, 421200, N'赤壁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1927, 421300, 420000, N'随州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1928, 421303, 421300, N'曾都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1929, 421321, 421300, N'随县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1930, 421381, 421300, N'广水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1931, 422800, 420000, N'恩施土家族苗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1932, 422801, 422800, N'恩施市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1933, 422802, 422800, N'利川市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1934, 422822, 422800, N'建始县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1935, 422823, 422800, N'巴东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1936, 422825, 422800, N'宣恩县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1937, 422826, 422800, N'咸丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1938, 422827, 422800, N'来凤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1939, 422828, 422800, N'鹤峰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1940, 429004, 420000, N'仙桃市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1941, 429005, 420000, N'潜江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1942, 429006, 420000, N'天门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1943, 429021, 420000, N'神农架林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1944, 429022, 429021, N'松柏镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1945, 429023, 429021, N'阳日镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1946, 429024, 429021, N'木鱼镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1947, 429025, 429021, N'红坪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1948, 429026, 429021, N'新华镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1949, 429027, 429021, N'大九湖')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1950, 429028, 429021, N'宋洛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1951, 429029, 429021, N'下谷坪乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1952, 429401, 429004, N'沙嘴街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1953, 429402, 429004, N'干河街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1954, 429403, 429004, N'龙华山街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1955, 429404, 429004, N'郑场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1956, 429405, 429004, N'毛嘴镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1957, 429406, 429004, N'豆河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1958, 429407, 429004, N'三伏潭镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1959, 429408, 429004, N'胡场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1960, 429409, 429004, N'长埫口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1961, 429410, 429004, N'西流河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1962, 429411, 429004, N'沙湖镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1963, 429412, 429004, N'杨林尾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1964, 429413, 429004, N'彭场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1965, 429414, 429004, N'张沟镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1966, 429415, 429004, N'郭河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1967, 429416, 429004, N'沔城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1968, 429417, 429004, N'通海口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1969, 429418, 429004, N'陈场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1970, 429419, 429004, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1971, 429420, 429004, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1972, 429421, 429004, N'工业园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1973, 429422, 429004, N'九合垸原种场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1974, 429423, 429004, N'沙湖原种场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1975, 429424, 429004, N'排湖渔场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1976, 429425, 429004, N'五湖渔场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1977, 429426, 429004, N'赵西垸林场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1978, 429427, 429004, N'刘家垸林场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1979, 429428, 429004, N'畜禽良种场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1980, 429501, 429005, N'园林')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1981, 429502, 429005, N'广华')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1982, 429503, 429005, N'杨市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1983, 429504, 429005, N'周矶')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1984, 429505, 429005, N'泽口')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1985, 429506, 429005, N'泰丰')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1986, 429507, 429005, N'高场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1987, 429508, 429005, N'熊口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1988, 429509, 429005, N'竹根滩镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1989, 429510, 429005, N'高石碑镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1990, 429511, 429005, N'老新镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1991, 429512, 429005, N'王场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1992, 429513, 429005, N'渔洋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1993, 429514, 429005, N'龙湾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1994, 429515, 429005, N'浩口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1995, 429516, 429005, N'积玉口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1996, 429517, 429005, N'张金镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1997, 429518, 429005, N'白鹭湖管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1998, 429519, 429005, N'总口管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (1999, 429520, 429005, N'熊口农场管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2000, 429521, 429005, N'运粮湖管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2001, 429522, 429005, N'后湖管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2002, 429523, 429005, N'周矶管理区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2003, 429524, 429005, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2004, 429601, 429006, N'竟陵街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2005, 429602, 429006, N'杨林街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2006, 429603, 429006, N'佛子山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2007, 429604, 429006, N'多宝镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2008, 429605, 429006, N'拖市镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2009, 429606, 429006, N'张港镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2010, 429607, 429006, N'蒋场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2011, 429608, 429006, N'汪场镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2012, 429609, 429006, N'渔薪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2013, 429610, 429006, N'黄潭镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2014, 429611, 429006, N'岳口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2015, 429612, 429006, N'横林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2016, 429613, 429006, N'彭市镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2017, 429614, 429006, N'麻洋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2018, 429615, 429006, N'多祥镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2019, 429616, 429006, N'干驿镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2020, 429617, 429006, N'马湾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2021, 429618, 429006, N'卢市镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2022, 429619, 429006, N'小板镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2023, 429620, 429006, N'九真镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2024, 429621, 429006, N'皂市镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2025, 429622, 429006, N'胡市镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2026, 429623, 429006, N'石河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2027, 429624, 429006, N'净潭乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2028, 429625, 429006, N'蒋湖农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2029, 429626, 429006, N'白茅湖农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2030, 429627, 429006, N'沉湖林业科技示范区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2031, 429628, 429006, N'天门工业园')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2032, 429629, 429006, N'侨乡街道开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2033, 430000, 100000, N'湖南省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2034, 430100, 430000, N'长沙市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2035, 430102, 430100, N'芙蓉区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2036, 430103, 430100, N'天心区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2037, 430104, 430100, N'岳麓区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2038, 430105, 430100, N'开福区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2039, 430111, 430100, N'雨花区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2040, 430112, 430100, N'望城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2041, 430121, 430100, N'长沙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2042, 430124, 430100, N'宁乡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2043, 430181, 430100, N'浏阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2044, 430182, 430100, N'湘江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2045, 430200, 430000, N'株洲市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2046, 430202, 430200, N'荷塘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2047, 430203, 430200, N'芦淞区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2048, 430204, 430200, N'石峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2049, 430211, 430200, N'天元区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2050, 430221, 430200, N'株洲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2051, 430223, 430200, N'攸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2052, 430224, 430200, N'茶陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2053, 430225, 430200, N'炎陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2054, 430281, 430200, N'醴陵市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2055, 430300, 430000, N'湘潭市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2056, 430302, 430300, N'雨湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2057, 430304, 430300, N'岳塘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2058, 430321, 430300, N'湘潭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2059, 430381, 430300, N'湘乡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2060, 430382, 430300, N'韶山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2061, 430383, 430300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2062, 430400, 430000, N'衡阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2063, 430405, 430400, N'珠晖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2064, 430406, 430400, N'雁峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2065, 430407, 430400, N'石鼓区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2066, 430408, 430400, N'蒸湘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2067, 430412, 430400, N'南岳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2068, 430421, 430400, N'衡阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2069, 430422, 430400, N'衡南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2070, 430423, 430400, N'衡山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2071, 430424, 430400, N'衡东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2072, 430426, 430400, N'祁东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2073, 430481, 430400, N'耒阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2074, 430482, 430400, N'常宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2075, 430483, 430400, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2076, 430500, 430000, N'邵阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2077, 430502, 430500, N'双清区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2078, 430503, 430500, N'大祥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2079, 430511, 430500, N'北塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2080, 430521, 430500, N'邵东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2081, 430522, 430500, N'新邵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2082, 430523, 430500, N'邵阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2083, 430524, 430500, N'隆回县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2084, 430525, 430500, N'洞口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2085, 430527, 430500, N'绥宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2086, 430528, 430500, N'新宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2087, 430529, 430500, N'城步苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2088, 430581, 430500, N'武冈市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2089, 430600, 430000, N'岳阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2090, 430602, 430600, N'岳阳楼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2091, 430603, 430600, N'云溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2092, 430611, 430600, N'君山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2093, 430621, 430600, N'岳阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2094, 430623, 430600, N'华容县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2095, 430624, 430600, N'湘阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2096, 430626, 430600, N'平江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2097, 430681, 430600, N'汨罗市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2098, 430682, 430600, N'临湘市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2099, 430700, 430000, N'常德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2100, 430702, 430700, N'武陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2101, 430703, 430700, N'鼎城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2102, 430721, 430700, N'安乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2103, 430722, 430700, N'汉寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2104, 430723, 430700, N'澧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2105, 430724, 430700, N'临澧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2106, 430725, 430700, N'桃源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2107, 430726, 430700, N'石门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2108, 430781, 430700, N'津市市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2109, 430800, 430000, N'张家界市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2110, 430802, 430800, N'永定区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2111, 430811, 430800, N'武陵源区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2112, 430821, 430800, N'慈利县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2113, 430822, 430800, N'桑植县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2114, 430900, 430000, N'益阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2115, 430902, 430900, N'资阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2116, 430903, 430900, N'赫山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2117, 430921, 430900, N'南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2118, 430922, 430900, N'桃江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2119, 430923, 430900, N'安化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2120, 430981, 430900, N'沅江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2121, 431000, 430000, N'郴州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2122, 431002, 431000, N'北湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2123, 431003, 431000, N'苏仙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2124, 431021, 431000, N'桂阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2125, 431022, 431000, N'宜章县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2126, 431023, 431000, N'永兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2127, 431024, 431000, N'嘉禾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2128, 431025, 431000, N'临武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2129, 431026, 431000, N'汝城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2130, 431027, 431000, N'桂东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2131, 431028, 431000, N'安仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2132, 431081, 431000, N'资兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2133, 431100, 430000, N'永州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2134, 431102, 431100, N'零陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2135, 431103, 431100, N'冷水滩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2136, 431121, 431100, N'祁阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2137, 431122, 431100, N'东安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2138, 431123, 431100, N'双牌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2139, 431124, 431100, N'道县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2140, 431125, 431100, N'江永县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2141, 431126, 431100, N'宁远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2142, 431127, 431100, N'蓝山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2143, 431128, 431100, N'新田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2144, 431129, 431100, N'江华瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2145, 431200, 430000, N'怀化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2146, 431202, 431200, N'鹤城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2147, 431221, 431200, N'中方县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2148, 431222, 431200, N'沅陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2149, 431223, 431200, N'辰溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2150, 431224, 431200, N'溆浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2151, 431225, 431200, N'会同县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2152, 431226, 431200, N'麻阳苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2153, 431227, 431200, N'新晃侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2154, 431228, 431200, N'芷江侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2155, 431229, 431200, N'靖州苗族侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2156, 431230, 431200, N'通道侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2157, 431281, 431200, N'洪江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2158, 431300, 430000, N'娄底市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2159, 431302, 431300, N'娄星区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2160, 431321, 431300, N'双峰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2161, 431322, 431300, N'新化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2162, 431381, 431300, N'冷水江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2163, 431382, 431300, N'涟源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2164, 433100, 430000, N'湘西土家族苗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2165, 433101, 433100, N'吉首市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2166, 433122, 433100, N'泸溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2167, 433123, 433100, N'凤凰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2168, 433124, 433100, N'花垣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2169, 433125, 433100, N'保靖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2170, 433126, 433100, N'古丈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2171, 433127, 433100, N'永顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2172, 433130, 433100, N'龙山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2173, 440000, 100000, N'广东省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2174, 440100, 440000, N'广州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2175, 440103, 440100, N'荔湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2176, 440104, 440100, N'越秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2177, 440105, 440100, N'海珠区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2178, 440106, 440100, N'天河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2179, 440111, 440100, N'白云区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2180, 440112, 440100, N'黄埔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2181, 440113, 440100, N'番禺区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2182, 440114, 440100, N'花都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2183, 440115, 440100, N'南沙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2184, 440117, 440100, N'从化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2185, 440118, 440100, N'增城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2186, 440200, 440000, N'韶关市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2187, 440203, 440200, N'武江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2188, 440204, 440200, N'浈江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2189, 440205, 440200, N'曲江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2190, 440222, 440200, N'始兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2191, 440224, 440200, N'仁化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2192, 440229, 440200, N'翁源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2193, 440232, 440200, N'乳源瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2194, 440233, 440200, N'新丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2195, 440281, 440200, N'乐昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2196, 440282, 440200, N'南雄市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2197, 440300, 440000, N'深圳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2198, 440303, 440300, N'罗湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2199, 440304, 440300, N'福田区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2200, 440305, 440300, N'南山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2201, 440306, 440300, N'宝安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2202, 440307, 440300, N'龙岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2203, 440308, 440300, N'盐田区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2204, 440309, 440300, N'龙华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2205, 440310, 440300, N'坪山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2206, 440311, 440300, N'光明新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2207, 440312, 440300, N'大鹏新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2208, 440400, 440000, N'珠海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2209, 440402, 440400, N'香洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2210, 440403, 440400, N'斗门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2211, 440404, 440400, N'金湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2212, 440405, 440400, N'横琴新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2213, 440406, 440400, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2214, 440500, 440000, N'汕头市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2215, 440507, 440500, N'龙湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2216, 440511, 440500, N'金平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2217, 440512, 440500, N'濠江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2218, 440513, 440500, N'潮阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2219, 440514, 440500, N'潮南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2220, 440515, 440500, N'澄海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2221, 440523, 440500, N'南澳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2222, 440600, 440000, N'佛山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2223, 440604, 440600, N'禅城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2224, 440605, 440600, N'南海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2225, 440606, 440600, N'顺德区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2226, 440607, 440600, N'三水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2227, 440608, 440600, N'高明区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2228, 440700, 440000, N'江门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2229, 440703, 440700, N'蓬江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2230, 440704, 440700, N'江海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2231, 440705, 440700, N'新会区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2232, 440781, 440700, N'台山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2233, 440783, 440700, N'开平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2234, 440784, 440700, N'鹤山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2235, 440785, 440700, N'恩平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2236, 440800, 440000, N'湛江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2237, 440802, 440800, N'赤坎区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2238, 440803, 440800, N'霞山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2239, 440804, 440800, N'坡头区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2240, 440811, 440800, N'麻章区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2241, 440823, 440800, N'遂溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2242, 440825, 440800, N'徐闻县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2243, 440881, 440800, N'廉江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2244, 440882, 440800, N'雷州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2245, 440883, 440800, N'吴川市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2246, 440884, 440800, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2247, 440900, 440000, N'茂名市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2248, 440902, 440900, N'茂南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2249, 440904, 440900, N'电白区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2250, 440981, 440900, N'高州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2251, 440982, 440900, N'化州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2252, 440983, 440900, N'信宜市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2253, 441200, 440000, N'肇庆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2254, 441202, 441200, N'端州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2255, 441203, 441200, N'鼎湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2256, 441204, 441200, N'高要区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2257, 441223, 441200, N'广宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2258, 441224, 441200, N'怀集县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2259, 441225, 441200, N'封开县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2260, 441226, 441200, N'德庆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2261, 441284, 441200, N'四会市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2262, 441300, 440000, N'惠州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2263, 441302, 441300, N'惠城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2264, 441303, 441300, N'惠阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2265, 441322, 441300, N'博罗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2266, 441323, 441300, N'惠东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2267, 441324, 441300, N'龙门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2268, 441325, 441300, N'大亚湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2269, 441400, 440000, N'梅州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2270, 441402, 441400, N'梅江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2271, 441403, 441400, N'梅县区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2272, 441422, 441400, N'大埔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2273, 441423, 441400, N'丰顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2274, 441424, 441400, N'五华县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2275, 441426, 441400, N'平远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2276, 441427, 441400, N'蕉岭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2277, 441481, 441400, N'兴宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2278, 441500, 440000, N'汕尾市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2279, 441502, 441500, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2280, 441521, 441500, N'海丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2281, 441523, 441500, N'陆河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2282, 441581, 441500, N'陆丰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2283, 441600, 440000, N'河源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2284, 441602, 441600, N'源城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2285, 441621, 441600, N'紫金县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2286, 441622, 441600, N'龙川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2287, 441623, 441600, N'连平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2288, 441624, 441600, N'和平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2289, 441625, 441600, N'东源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2290, 441700, 440000, N'阳江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2291, 441702, 441700, N'江城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2292, 441704, 441700, N'阳东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2293, 441721, 441700, N'阳西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2294, 441781, 441700, N'阳春市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2295, 441800, 440000, N'清远市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2296, 441802, 441800, N'清城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2297, 441803, 441800, N'清新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2298, 441821, 441800, N'佛冈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2299, 441823, 441800, N'阳山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2300, 441825, 441800, N'连山壮族瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2301, 441826, 441800, N'连南瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2302, 441881, 441800, N'英德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2303, 441882, 441800, N'连州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2304, 441900, 440000, N'东莞市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2305, 441901, 441900, N'莞城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2306, 441902, 441900, N'南城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2307, 441903, 441900, N'东城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2308, 441904, 441900, N'万江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2309, 441905, 441900, N'石碣镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2310, 441906, 441900, N'石龙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2311, 441907, 441900, N'茶山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2312, 441908, 441900, N'石排镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2313, 441909, 441900, N'企石镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2314, 441910, 441900, N'横沥镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2315, 441911, 441900, N'桥头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2316, 441912, 441900, N'谢岗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2317, 441913, 441900, N'东坑镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2318, 441914, 441900, N'常平镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2319, 441915, 441900, N'寮步镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2320, 441916, 441900, N'大朗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2321, 441917, 441900, N'麻涌镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2322, 441918, 441900, N'中堂镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2323, 441919, 441900, N'高埗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2324, 441920, 441900, N'樟木头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2325, 441921, 441900, N'大岭山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2326, 441922, 441900, N'望牛墩镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2327, 441923, 441900, N'黄江镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2328, 441924, 441900, N'洪梅镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2329, 441925, 441900, N'清溪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2330, 441926, 441900, N'沙田镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2331, 441927, 441900, N'道滘镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2332, 441928, 441900, N'塘厦镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2333, 441929, 441900, N'虎门镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2334, 441930, 441900, N'厚街镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2335, 441931, 441900, N'凤岗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2336, 441932, 441900, N'长安镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2337, 441933, 441900, N'松山湖高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2338, 442000, 440000, N'中山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2339, 442001, 442000, N'石岐区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2340, 442002, 442000, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2341, 442003, 442000, N'西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2342, 442004, 442000, N'南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2343, 442005, 442000, N'五桂山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2344, 442006, 442000, N'火炬开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2345, 442007, 442000, N'黄圃镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2346, 442008, 442000, N'南头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2347, 442009, 442000, N'东凤镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2348, 442010, 442000, N'阜沙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2349, 442011, 442000, N'小榄镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2350, 442012, 442000, N'东升镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2351, 442013, 442000, N'古镇镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2352, 442014, 442000, N'横栏镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2353, 442015, 442000, N'三角镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2354, 442016, 442000, N'民众镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2355, 442017, 442000, N'南朗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2356, 442018, 442000, N'港口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2357, 442019, 442000, N'大涌镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2358, 442020, 442000, N'沙溪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2359, 442021, 442000, N'三乡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2360, 442022, 442000, N'板芙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2361, 442023, 442000, N'神湾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2362, 442024, 442000, N'坦洲镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2363, 445100, 440000, N'潮州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2364, 445102, 445100, N'湘桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2365, 445103, 445100, N'潮安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2366, 445122, 445100, N'饶平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2367, 445200, 440000, N'揭阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2368, 445202, 445200, N'榕城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2369, 445203, 445200, N'揭东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2370, 445222, 445200, N'揭西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2371, 445224, 445200, N'惠来县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2372, 445281, 445200, N'普宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2373, 445300, 440000, N'云浮市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2374, 445302, 445300, N'云城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2375, 445303, 445300, N'云安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2376, 445321, 445300, N'新兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2377, 445322, 445300, N'郁南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2378, 445381, 445300, N'罗定市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2379, 450000, 100000, N'广西壮族自治区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2380, 450100, 450000, N'南宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2381, 450102, 450100, N'兴宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2382, 450103, 450100, N'青秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2383, 450105, 450100, N'江南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2384, 450107, 450100, N'西乡塘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2385, 450108, 450100, N'良庆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2386, 450109, 450100, N'邕宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2387, 450110, 450100, N'武鸣区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2388, 450123, 450100, N'隆安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2389, 450124, 450100, N'马山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2390, 450125, 450100, N'上林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2391, 450126, 450100, N'宾阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2392, 450127, 450100, N'横县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2393, 450128, 450100, N'埌东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2394, 450200, 450000, N'柳州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2395, 450202, 450200, N'城中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2396, 450203, 450200, N'鱼峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2397, 450204, 450200, N'柳南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2398, 450205, 450200, N'柳北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2399, 450206, 450200, N'柳江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2400, 450222, 450200, N'柳城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2401, 450223, 450200, N'鹿寨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2402, 450224, 450200, N'融安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2403, 450225, 450200, N'融水苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2404, 450226, 450200, N'三江侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2405, 450227, 450200, N'柳东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2406, 450300, 450000, N'桂林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2407, 450302, 450300, N'秀峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2408, 450303, 450300, N'叠彩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2409, 450304, 450300, N'象山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2410, 450305, 450300, N'七星区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2411, 450311, 450300, N'雁山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2412, 450312, 450300, N'临桂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2413, 450321, 450300, N'阳朔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2414, 450323, 450300, N'灵川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2415, 450324, 450300, N'全州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2416, 450325, 450300, N'兴安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2417, 450326, 450300, N'永福县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2418, 450327, 450300, N'灌阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2419, 450328, 450300, N'龙胜各族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2420, 450329, 450300, N'资源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2421, 450330, 450300, N'平乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2422, 450331, 450300, N'荔浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2423, 450332, 450300, N'恭城瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2424, 450400, 450000, N'梧州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2425, 450403, 450400, N'万秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2426, 450405, 450400, N'长洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2427, 450406, 450400, N'龙圩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2428, 450421, 450400, N'苍梧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2429, 450422, 450400, N'藤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2430, 450423, 450400, N'蒙山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2431, 450481, 450400, N'岑溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2432, 450500, 450000, N'北海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2433, 450502, 450500, N'海城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2434, 450503, 450500, N'银海区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2435, 450512, 450500, N'铁山港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2436, 450521, 450500, N'合浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2437, 450600, 450000, N'防城港市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2438, 450602, 450600, N'港口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2439, 450603, 450600, N'防城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2440, 450621, 450600, N'上思县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2441, 450681, 450600, N'东兴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2442, 450700, 450000, N'钦州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2443, 450702, 450700, N'钦南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2444, 450703, 450700, N'钦北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2445, 450721, 450700, N'灵山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2446, 450722, 450700, N'浦北县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2447, 450800, 450000, N'贵港市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2448, 450802, 450800, N'港北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2449, 450803, 450800, N'港南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2450, 450804, 450800, N'覃塘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2451, 450821, 450800, N'平南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2452, 450881, 450800, N'桂平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2453, 450900, 450000, N'玉林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2454, 450902, 450900, N'玉州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2455, 450903, 450900, N'福绵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2456, 450921, 450900, N'容县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2457, 450922, 450900, N'陆川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2458, 450923, 450900, N'博白县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2459, 450924, 450900, N'兴业县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2460, 450981, 450900, N'北流市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2461, 450982, 450900, N'玉东新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2462, 450983, 450900, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2463, 451000, 450000, N'百色市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2464, 451002, 451000, N'右江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2465, 451021, 451000, N'田阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2466, 451022, 451000, N'田东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2467, 451023, 451000, N'平果县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2468, 451024, 451000, N'德保县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2469, 451026, 451000, N'那坡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2470, 451027, 451000, N'凌云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2471, 451028, 451000, N'乐业县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2472, 451029, 451000, N'田林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2473, 451030, 451000, N'西林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2474, 451031, 451000, N'隆林各族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2475, 451081, 451000, N'靖西市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2476, 451100, 450000, N'贺州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2477, 451102, 451100, N'八步区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2478, 451103, 451100, N'平桂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2479, 451121, 451100, N'昭平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2480, 451122, 451100, N'钟山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2481, 451123, 451100, N'富川瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2482, 451200, 450000, N'河池市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2483, 451202, 451200, N'金城江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2484, 451203, 451200, N'宜州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2485, 451221, 451200, N'南丹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2486, 451222, 451200, N'天峨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2487, 451223, 451200, N'凤山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2488, 451224, 451200, N'东兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2489, 451225, 451200, N'罗城仫佬族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2490, 451226, 451200, N'环江毛南族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2491, 451227, 451200, N'巴马瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2492, 451228, 451200, N'都安瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2493, 451229, 451200, N'大化瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2494, 451300, 450000, N'来宾市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2495, 451302, 451300, N'兴宾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2496, 451321, 451300, N'忻城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2497, 451322, 451300, N'象州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2498, 451323, 451300, N'武宣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2499, 451324, 451300, N'金秀瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2500, 451381, 451300, N'合山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2501, 451400, 450000, N'崇左市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2502, 451402, 451400, N'江州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2503, 451421, 451400, N'扶绥县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2504, 451422, 451400, N'宁明县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2505, 451423, 451400, N'龙州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2506, 451424, 451400, N'大新县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2507, 451425, 451400, N'天等县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2508, 451481, 451400, N'凭祥市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2509, 460000, 100000, N'海南省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2510, 460100, 460000, N'海口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2511, 460105, 460100, N'秀英区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2512, 460106, 460100, N'龙华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2513, 460107, 460100, N'琼山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2514, 460108, 460100, N'美兰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2515, 460200, 460000, N'三亚市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2516, 460202, 460200, N'海棠区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2517, 460203, 460200, N'吉阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2518, 460204, 460200, N'天涯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2519, 460205, 460200, N'崖州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2520, 460300, 460000, N'三沙市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2521, 460321, 460300, N'西沙群岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2522, 460322, 460300, N'南沙群岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2523, 460323, 460300, N'中沙群岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2524, 460400, 460000, N'儋州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2525, 460401, 460400, N'洋浦经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2526, 460402, 460400, N'那大镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2527, 460403, 460400, N'南丰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2528, 460404, 460400, N'雅星镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2529, 460405, 460400, N'和庆镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2530, 460406, 460400, N'大成镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2531, 460407, 460400, N'新州镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2532, 460408, 460400, N'光村镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2533, 460409, 460400, N'东成镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2534, 460410, 460400, N'中和镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2535, 460411, 460400, N'峨蔓镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2536, 460412, 460400, N'兰洋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2537, 460413, 460400, N'王五镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2538, 460414, 460400, N'排浦镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2539, 460415, 460400, N'海头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2540, 460416, 460400, N'木棠镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2541, 460417, 460400, N'白马井镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2542, 460418, 460400, N'三都镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2543, 460419, 460400, N'西培农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2544, 460420, 460400, N'西联农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2545, 460421, 460400, N'蓝洋农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2546, 460422, 460400, N'八一农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2547, 460423, 460400, N'西华农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2548, 460424, 460400, N'西庆农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2549, 460425, 460400, N'西流农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2550, 460426, 460400, N'新盈农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2551, 460427, 460400, N'龙山农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2552, 460428, 460400, N'红岭农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2553, 469001, 460000, N'五指山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2554, 469002, 460000, N'琼海市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2555, 469005, 460000, N'文昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2556, 469006, 460000, N'万宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2557, 469007, 460000, N'东方市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2558, 469021, 460000, N'定安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2559, 469022, 460000, N'屯昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2560, 469023, 460000, N'澄迈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2561, 469024, 460000, N'临高县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2562, 469025, 460000, N'白沙黎族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2563, 469026, 460000, N'昌江黎族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2564, 469027, 460000, N'乐东黎族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2565, 469028, 460000, N'陵水黎族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2566, 469029, 460000, N'保亭黎族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2567, 469030, 460000, N'琼中黎族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2568, 469101, 469001, N'通什镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2569, 469102, 469001, N'南圣镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2570, 469103, 469001, N'毛阳镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2571, 469104, 469001, N'番阳镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2572, 469105, 469001, N'畅好乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2573, 469106, 469001, N'毛道乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2574, 469107, 469001, N'水满乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2575, 469201, 469002, N'嘉积镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2576, 469202, 469002, N'万泉镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2577, 469203, 469002, N'石壁镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2578, 469204, 469002, N'中原镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2579, 469205, 469002, N'博鳌镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2580, 469206, 469002, N'阳江镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2581, 469207, 469002, N'龙江镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2582, 469208, 469002, N'潭门镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2583, 469209, 469002, N'塔洋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2584, 469210, 469002, N'长坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2585, 469211, 469002, N'大路镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2586, 469212, 469002, N'会山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2587, 469213, 469002, N'东太农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2588, 469214, 469002, N'东红农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2589, 469215, 469002, N'东升农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2590, 469216, 469002, N'南俸农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2591, 469217, 469002, N'彬村山华侨农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2592, 469501, 469005, N'文城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2593, 469502, 469005, N'重兴镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2594, 469503, 469005, N'蓬莱镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2595, 469504, 469005, N'会文镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2596, 469505, 469005, N'东路镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2597, 469506, 469005, N'潭牛镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2598, 469507, 469005, N'东阁镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2599, 469508, 469005, N'文教镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2600, 469509, 469005, N'东郊镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2601, 469510, 469005, N'龙楼镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2602, 469511, 469005, N'昌洒镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2603, 469512, 469005, N'翁田镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2604, 469513, 469005, N'抱罗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2605, 469514, 469005, N'冯坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2606, 469515, 469005, N'锦山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2607, 469516, 469005, N'铺前镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2608, 469517, 469005, N'公坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2609, 469518, 469005, N'迈号镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2610, 469519, 469005, N'清谰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2611, 469520, 469005, N'南阳镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2612, 469521, 469005, N'新桥镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2613, 469522, 469005, N'头苑镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2614, 469523, 469005, N'宝芳乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2615, 469524, 469005, N'龙马乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2616, 469525, 469005, N'湖山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2617, 469526, 469005, N'东路农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2618, 469527, 469005, N'南阳农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2619, 469528, 469005, N'罗豆农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2620, 469601, 469006, N'万城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2621, 469602, 469006, N'龙滚镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2622, 469603, 469006, N'和乐镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2623, 469604, 469006, N'后安镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2624, 469605, 469006, N'大茂镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2625, 469606, 469006, N'东澳镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2626, 469607, 469006, N'礼纪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2627, 469608, 469006, N'长丰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2628, 469609, 469006, N'山根镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2629, 469610, 469006, N'北大镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2630, 469611, 469006, N'南桥镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2631, 469612, 469006, N'三更罗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2632, 469613, 469006, N'东岭农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2633, 469614, 469006, N'南林农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2634, 469615, 469006, N'东兴农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2635, 469616, 469006, N'东和农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2636, 469617, 469006, N'新中农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2637, 469618, 469006, N'兴隆华侨农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2638, 469701, 469007, N'八所镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2639, 469702, 469007, N'东河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2640, 469703, 469007, N'大田镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2641, 469704, 469007, N'感城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2642, 469705, 469007, N'板桥镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2643, 469706, 469007, N'三家镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2644, 469707, 469007, N'四更镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2645, 469708, 469007, N'新龙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2646, 469709, 469007, N'天安乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2647, 469710, 469007, N'江边乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2648, 469711, 469007, N'广坝农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2649, 469712, 469007, N'东方华侨农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2650, 469801, 469021, N'定城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2651, 469802, 469021, N'新竹镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2652, 469803, 469021, N'龙湖镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2653, 469804, 469021, N'雷鸣镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2654, 469805, 469021, N'龙门镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2655, 469806, 469021, N'龙河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2656, 469807, 469021, N'岭口镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2657, 469808, 469021, N'翰林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2658, 469809, 469021, N'富文镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2659, 469810, 469021, N'黄竹镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2660, 469811, 469021, N'金鸡岭农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2661, 469812, 469021, N'中瑞农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2662, 469813, 469021, N'南海农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2663, 469814, 469021, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2664, 469821, 469022, N'屯城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2665, 469822, 469022, N'新兴镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2666, 469823, 469022, N'枫木镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2667, 469824, 469022, N'乌坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2668, 469825, 469022, N'南吕镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2669, 469826, 469022, N'南坤镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2670, 469827, 469022, N'坡心镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2671, 469828, 469022, N'西昌镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2672, 469829, 469022, N'中建农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2673, 469830, 469022, N'中坤农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2674, 469831, 469022, N'县城内')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2675, 469841, 469023, N'金江镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2676, 469842, 469023, N'老城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2677, 469843, 469023, N'瑞溪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2678, 469844, 469023, N'永发镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2679, 469845, 469023, N'加乐镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2680, 469846, 469023, N'文儒镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2681, 469847, 469023, N'中兴镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2682, 469848, 469023, N'仁兴镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2683, 469849, 469023, N'福山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2684, 469850, 469023, N'桥头镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2685, 469851, 469023, N'大丰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2686, 469852, 469023, N'红光农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2687, 469853, 469023, N'西达农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2688, 469854, 469023, N'金安农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2689, 469855, 469023, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2690, 469861, 469024, N'临城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2691, 469862, 469024, N'波莲镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2692, 469863, 469024, N'东英镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2693, 469864, 469024, N'博厚镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2694, 469865, 469024, N'皇桐镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2695, 469866, 469024, N'多文镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2696, 469867, 469024, N'和舍镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2697, 469868, 469024, N'南宝镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2698, 469869, 469024, N'新盈镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2699, 469870, 469024, N'调楼镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2700, 469871, 469024, N'加来镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2701, 469872, 469024, N'红华农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2702, 469873, 469024, N'加来农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2703, 469874, 469024, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2704, 469881, 469025, N'牙叉镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2705, 469882, 469025, N'七坊镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2706, 469883, 469025, N'邦溪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2707, 469884, 469025, N'打安镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2708, 469885, 469025, N'细水乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2709, 469886, 469025, N'元门乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2710, 469887, 469025, N'南开乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2711, 469888, 469025, N'阜龙乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2712, 469889, 469025, N'青松乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2713, 469890, 469025, N'金波乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2714, 469891, 469025, N'荣邦乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2715, 469892, 469025, N'白沙农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2716, 469893, 469025, N'龙江农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2717, 469894, 469025, N'邦溪农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2718, 469895, 469025, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2719, 469901, 469026, N'石碌镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2720, 469902, 469026, N'叉河镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2721, 469903, 469026, N'十月田镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2722, 469904, 469026, N'乌烈镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2723, 469905, 469026, N'海尾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2724, 469906, 469026, N'南罗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2725, 469907, 469026, N'太坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2726, 469908, 469026, N'昌化镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2727, 469909, 469026, N'七叉镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2728, 469910, 469026, N'保平乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2729, 469911, 469026, N'昌城乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2730, 469912, 469026, N'王下乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2731, 469913, 469026, N'霸王岭林场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2732, 469914, 469026, N'红林农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2733, 469915, 469026, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2734, 469920, 469027, N'抱由镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2735, 469921, 469027, N'万冲镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2736, 469922, 469027, N'大安镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2737, 469923, 469027, N'志仲镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2738, 469924, 469027, N'千家镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2739, 469925, 469027, N'九所镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2740, 469926, 469027, N'利国镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2741, 469927, 469027, N'黄流镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2742, 469928, 469027, N'佛罗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2743, 469929, 469027, N'尖峰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2744, 469930, 469027, N'莺歌海镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2745, 469931, 469027, N'乐中农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2746, 469932, 469027, N'山荣农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2747, 469933, 469027, N'乐光农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2748, 469934, 469027, N'报伦农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2749, 469935, 469027, N'福报农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2750, 469936, 469027, N'保国农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2751, 469937, 469027, N'保显农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2752, 469938, 469027, N'尖峰岭林业')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2753, 469939, 469027, N'莺歌海盐场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2754, 469940, 469027, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2755, 469941, 469028, N'椰林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2756, 469942, 469028, N'光坡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2757, 469943, 469028, N'三才镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2758, 469944, 469028, N'英州镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2759, 469945, 469028, N'隆广镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2760, 469946, 469028, N'文罗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2761, 469947, 469028, N'本号镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2762, 469948, 469028, N'新村镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2763, 469949, 469028, N'黎安镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2764, 469950, 469028, N'提蒙乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2765, 469951, 469028, N'群英乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2766, 469952, 469028, N'岭门农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2767, 469953, 469028, N'南平农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2768, 469954, 469028, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2769, 469961, 469029, N'保城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2770, 469962, 469029, N'什玲镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2771, 469963, 469029, N'加茂镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2772, 469964, 469029, N'响水镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2773, 469965, 469029, N'新政镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2774, 469966, 469029, N'三道镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2775, 469967, 469029, N'六弓乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2776, 469968, 469029, N'南林乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2777, 469969, 469029, N'毛感乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2778, 469970, 469029, N'新星农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2779, 469971, 469029, N'金江农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2780, 469972, 469029, N'三道农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2781, 469981, 469030, N'营根镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2782, 469982, 469030, N'湾岭镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2783, 469983, 469030, N'黎母山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2784, 469984, 469030, N'和平镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2785, 469985, 469030, N'长征镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2786, 469986, 469030, N'红毛镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2787, 469987, 469030, N'中平镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2788, 469988, 469030, N'上安乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2789, 469989, 469030, N'什运乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2790, 469990, 469030, N'吊罗山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2791, 469991, 469030, N'阳江农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2792, 469992, 469030, N'乌石农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2793, 469993, 469030, N'加钗农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2794, 469994, 469030, N'长征农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2795, 469995, 469030, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2796, 500000, 100000, N'重庆')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2797, 500100, 500000, N'重庆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2798, 500101, 500100, N'万州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2799, 500102, 500100, N'涪陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2800, 500103, 500100, N'渝中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2801, 500104, 500100, N'大渡口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2802, 500105, 500100, N'江北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2803, 500106, 500100, N'沙坪坝区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2804, 500107, 500100, N'九龙坡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2805, 500108, 500100, N'南岸区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2806, 500109, 500100, N'北碚区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2807, 500110, 500100, N'綦江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2808, 500111, 500100, N'大足区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2809, 500112, 500100, N'渝北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2810, 500113, 500100, N'巴南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2811, 500114, 500100, N'黔江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2812, 500115, 500100, N'长寿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2813, 500116, 500100, N'江津区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2814, 500117, 500100, N'合川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2815, 500118, 500100, N'永川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2816, 500119, 500100, N'南川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2817, 500120, 500100, N'璧山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2818, 500151, 500100, N'铜梁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2819, 500152, 500100, N'潼南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2820, 500153, 500100, N'荣昌区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2821, 500154, 500100, N'开州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2822, 500155, 500100, N'梁平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2823, 500156, 500100, N'武隆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2824, 500229, 500100, N'城口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2825, 500230, 500100, N'丰都县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2826, 500231, 500100, N'垫江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2827, 500233, 500100, N'忠县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2828, 500235, 500100, N'云阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2829, 500236, 500100, N'奉节县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2830, 500237, 500100, N'巫山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2831, 500238, 500100, N'巫溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2832, 500240, 500100, N'石柱土家族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2833, 500241, 500100, N'秀山土家族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2834, 500242, 500100, N'酉阳土家族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2835, 500243, 500100, N'彭水苗族土家族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2836, 500300, 500100, N'两江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2837, 500301, 500100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2838, 500302, 500100, N'璧山高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2839, 510000, 100000, N'四川省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2840, 510100, 510000, N'成都市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2841, 510104, 510100, N'锦江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2842, 510105, 510100, N'青羊区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2843, 510106, 510100, N'金牛区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2844, 510107, 510100, N'武侯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2845, 510108, 510100, N'成华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2846, 510112, 510100, N'龙泉驿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2847, 510113, 510100, N'青白江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2848, 510114, 510100, N'新都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2849, 510115, 510100, N'温江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2850, 510116, 510100, N'双流区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2851, 510117, 510100, N'郫都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2852, 510121, 510100, N'金堂县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2853, 510129, 510100, N'大邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2854, 510131, 510100, N'蒲江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2855, 510132, 510100, N'新津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2856, 510181, 510100, N'都江堰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2857, 510182, 510100, N'彭州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2858, 510183, 510100, N'邛崃市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2859, 510184, 510100, N'崇州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2860, 510185, 510100, N'简阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2861, 510186, 510100, N'天府新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2862, 510187, 510100, N'高新南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2863, 510188, 510100, N'高新西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2864, 510300, 510000, N'自贡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2865, 510302, 510300, N'自流井区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2866, 510303, 510300, N'贡井区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2867, 510304, 510300, N'大安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2868, 510311, 510300, N'沿滩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2869, 510321, 510300, N'荣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2870, 510322, 510300, N'富顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2871, 510323, 510300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2872, 510400, 510000, N'攀枝花市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2873, 510402, 510400, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2874, 510403, 510400, N'西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2875, 510411, 510400, N'仁和区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2876, 510421, 510400, N'米易县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2877, 510422, 510400, N'盐边县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2878, 510500, 510000, N'泸州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2879, 510502, 510500, N'江阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2880, 510503, 510500, N'纳溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2881, 510504, 510500, N'龙马潭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2882, 510521, 510500, N'泸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2883, 510522, 510500, N'合江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2884, 510524, 510500, N'叙永县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2885, 510525, 510500, N'古蔺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2886, 510600, 510000, N'德阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2887, 510603, 510600, N'旌阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2888, 510623, 510600, N'中江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2889, 510626, 510600, N'罗江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2890, 510681, 510600, N'广汉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2891, 510682, 510600, N'什邡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2892, 510683, 510600, N'绵竹市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2893, 510700, 510000, N'绵阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2894, 510703, 510700, N'涪城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2895, 510704, 510700, N'游仙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2896, 510705, 510700, N'安州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2897, 510722, 510700, N'三台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2898, 510723, 510700, N'盐亭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2899, 510725, 510700, N'梓潼县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2900, 510726, 510700, N'北川羌族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2901, 510727, 510700, N'平武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2902, 510781, 510700, N'江油市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2903, 510782, 510700, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2904, 510783, 510700, N'经开区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2905, 510800, 510000, N'广元市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2906, 510802, 510800, N'利州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2907, 510811, 510800, N'昭化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2908, 510812, 510800, N'朝天区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2909, 510821, 510800, N'旺苍县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2910, 510822, 510800, N'青川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2911, 510823, 510800, N'剑阁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2912, 510824, 510800, N'苍溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2913, 510900, 510000, N'遂宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2914, 510903, 510900, N'船山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2915, 510904, 510900, N'安居区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2916, 510921, 510900, N'蓬溪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2917, 510922, 510900, N'射洪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2918, 510923, 510900, N'大英县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2919, 510924, 510900, N'经济技术开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2920, 511000, 510000, N'内江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2921, 511002, 511000, N'市中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2922, 511011, 511000, N'东兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2923, 511024, 511000, N'威远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2924, 511025, 511000, N'资中县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2925, 511083, 511000, N'隆昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2926, 511100, 510000, N'乐山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2927, 511102, 511100, N'市中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2928, 511111, 511100, N'沙湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2929, 511112, 511100, N'五通桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2930, 511113, 511100, N'金口河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2931, 511123, 511100, N'犍为县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2932, 511124, 511100, N'井研县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2933, 511126, 511100, N'夹江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2934, 511129, 511100, N'沐川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2935, 511132, 511100, N'峨边彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2936, 511133, 511100, N'马边彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2937, 511181, 511100, N'峨眉山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2938, 511300, 510000, N'南充市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2939, 511302, 511300, N'顺庆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2940, 511303, 511300, N'高坪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2941, 511304, 511300, N'嘉陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2942, 511321, 511300, N'南部县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2943, 511322, 511300, N'营山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2944, 511323, 511300, N'蓬安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2945, 511324, 511300, N'仪陇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2946, 511325, 511300, N'西充县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2947, 511381, 511300, N'阆中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2948, 511400, 510000, N'眉山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2949, 511402, 511400, N'东坡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2950, 511403, 511400, N'彭山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2951, 511421, 511400, N'仁寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2952, 511423, 511400, N'洪雅县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2953, 511424, 511400, N'丹棱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2954, 511425, 511400, N'青神县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2955, 511500, 510000, N'宜宾市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2956, 511502, 511500, N'翠屏区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2957, 511503, 511500, N'南溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2958, 511521, 511500, N'宜宾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2959, 511523, 511500, N'江安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2960, 511524, 511500, N'长宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2961, 511525, 511500, N'高县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2962, 511526, 511500, N'珙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2963, 511527, 511500, N'筠连县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2964, 511528, 511500, N'兴文县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2965, 511529, 511500, N'屏山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2966, 511600, 510000, N'广安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2967, 511602, 511600, N'广安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2968, 511603, 511600, N'前锋区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2969, 511621, 511600, N'岳池县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2970, 511622, 511600, N'武胜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2971, 511623, 511600, N'邻水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2972, 511681, 511600, N'华蓥市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2973, 511700, 510000, N'达州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2974, 511702, 511700, N'通川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2975, 511703, 511700, N'达川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2976, 511722, 511700, N'宣汉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2977, 511723, 511700, N'开江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2978, 511724, 511700, N'大竹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2979, 511725, 511700, N'渠县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2980, 511781, 511700, N'万源市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2981, 511800, 510000, N'雅安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2982, 511802, 511800, N'雨城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2983, 511803, 511800, N'名山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2984, 511822, 511800, N'荥经县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2985, 511823, 511800, N'汉源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2986, 511824, 511800, N'石棉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2987, 511825, 511800, N'天全县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2988, 511826, 511800, N'芦山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2989, 511827, 511800, N'宝兴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2990, 511900, 510000, N'巴中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2991, 511902, 511900, N'巴州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2992, 511903, 511900, N'恩阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2993, 511921, 511900, N'通江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2994, 511922, 511900, N'南江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2995, 511923, 511900, N'平昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2996, 512000, 510000, N'资阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2997, 512002, 512000, N'雁江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2998, 512021, 512000, N'安岳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (2999, 512022, 512000, N'乐至县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3000, 513200, 510000, N'阿坝藏族羌族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3001, 513201, 513200, N'马尔康市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3002, 513221, 513200, N'汶川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3003, 513222, 513200, N'理县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3004, 513223, 513200, N'茂县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3005, 513224, 513200, N'松潘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3006, 513225, 513200, N'九寨沟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3007, 513226, 513200, N'金川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3008, 513227, 513200, N'小金县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3009, 513228, 513200, N'黑水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3010, 513230, 513200, N'壤塘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3011, 513231, 513200, N'阿坝县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3012, 513232, 513200, N'若尔盖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3013, 513233, 513200, N'红原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3014, 513300, 510000, N'甘孜藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3015, 513301, 513300, N'康定市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3016, 513322, 513300, N'泸定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3017, 513323, 513300, N'丹巴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3018, 513324, 513300, N'九龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3019, 513325, 513300, N'雅江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3020, 513326, 513300, N'道孚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3021, 513327, 513300, N'炉霍县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3022, 513328, 513300, N'甘孜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3023, 513329, 513300, N'新龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3024, 513330, 513300, N'德格县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3025, 513331, 513300, N'白玉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3026, 513332, 513300, N'石渠县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3027, 513333, 513300, N'色达县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3028, 513334, 513300, N'理塘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3029, 513335, 513300, N'巴塘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3030, 513336, 513300, N'乡城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3031, 513337, 513300, N'稻城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3032, 513338, 513300, N'得荣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3033, 513400, 510000, N'凉山彝族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3034, 513401, 513400, N'西昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3035, 513422, 513400, N'木里藏族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3036, 513423, 513400, N'盐源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3037, 513424, 513400, N'德昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3038, 513425, 513400, N'会理县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3039, 513426, 513400, N'会东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3040, 513427, 513400, N'宁南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3041, 513428, 513400, N'普格县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3042, 513429, 513400, N'布拖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3043, 513430, 513400, N'金阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3044, 513431, 513400, N'昭觉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3045, 513432, 513400, N'喜德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3046, 513433, 513400, N'冕宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3047, 513434, 513400, N'越西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3048, 513435, 513400, N'甘洛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3049, 513436, 513400, N'美姑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3050, 513437, 513400, N'雷波县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3051, 520000, 100000, N'贵州省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3052, 520100, 520000, N'贵阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3053, 520102, 520100, N'南明区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3054, 520103, 520100, N'云岩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3055, 520111, 520100, N'花溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3056, 520112, 520100, N'乌当区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3057, 520113, 520100, N'白云区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3058, 520115, 520100, N'观山湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3059, 520121, 520100, N'开阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3060, 520122, 520100, N'息烽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3061, 520123, 520100, N'修文县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3062, 520181, 520100, N'清镇市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3063, 520182, 520100, N'贵安新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3064, 520183, 520100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3065, 520200, 520000, N'六盘水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3066, 520201, 520200, N'钟山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3067, 520203, 520200, N'六枝特区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3068, 520221, 520200, N'水城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3069, 520281, 520200, N'盘州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3070, 520300, 520000, N'遵义市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3071, 520302, 520300, N'红花岗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3072, 520303, 520300, N'汇川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3073, 520304, 520300, N'播州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3074, 520322, 520300, N'桐梓县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3075, 520323, 520300, N'绥阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3076, 520324, 520300, N'正安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3077, 520325, 520300, N'道真仡佬族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3078, 520326, 520300, N'务川仡佬族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3079, 520327, 520300, N'凤冈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3080, 520328, 520300, N'湄潭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3081, 520329, 520300, N'余庆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3082, 520330, 520300, N'习水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3083, 520381, 520300, N'赤水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3084, 520382, 520300, N'仁怀市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3085, 520400, 520000, N'安顺市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3086, 520402, 520400, N'西秀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3087, 520403, 520400, N'平坝区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3088, 520422, 520400, N'普定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3089, 520423, 520400, N'镇宁布依族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3090, 520424, 520400, N'关岭布依族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3091, 520425, 520400, N'紫云苗族布依族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3092, 520500, 520000, N'毕节市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3093, 520502, 520500, N'七星关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3094, 520521, 520500, N'大方县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3095, 520522, 520500, N'黔西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3096, 520523, 520500, N'金沙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3097, 520524, 520500, N'织金县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3098, 520525, 520500, N'纳雍县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3099, 520526, 520500, N'威宁彝族回族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3100, 520527, 520500, N'赫章县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3101, 520600, 520000, N'铜仁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3102, 520602, 520600, N'碧江区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3103, 520603, 520600, N'万山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3104, 520621, 520600, N'江口县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3105, 520622, 520600, N'玉屏侗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3106, 520623, 520600, N'石阡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3107, 520624, 520600, N'思南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3108, 520625, 520600, N'印江土家族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3109, 520626, 520600, N'德江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3110, 520627, 520600, N'沿河土家族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3111, 520628, 520600, N'松桃苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3112, 522300, 520000, N'黔西南布依族苗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3113, 522301, 522300, N'兴义市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3114, 522322, 522300, N'兴仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3115, 522323, 522300, N'普安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3116, 522324, 522300, N'晴隆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3117, 522325, 522300, N'贞丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3118, 522326, 522300, N'望谟县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3119, 522327, 522300, N'册亨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3120, 522328, 522300, N'安龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3121, 522600, 520000, N'黔东南苗族侗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3122, 522601, 522600, N'凯里市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3123, 522622, 522600, N'黄平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3124, 522623, 522600, N'施秉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3125, 522624, 522600, N'三穗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3126, 522625, 522600, N'镇远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3127, 522626, 522600, N'岑巩县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3128, 522627, 522600, N'天柱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3129, 522628, 522600, N'锦屏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3130, 522629, 522600, N'剑河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3131, 522630, 522600, N'台江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3132, 522631, 522600, N'黎平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3133, 522632, 522600, N'榕江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3134, 522633, 522600, N'从江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3135, 522634, 522600, N'雷山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3136, 522635, 522600, N'麻江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3137, 522636, 522600, N'丹寨县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3138, 522700, 520000, N'黔南布依族苗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3139, 522701, 522700, N'都匀市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3140, 522702, 522700, N'福泉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3141, 522722, 522700, N'荔波县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3142, 522723, 522700, N'贵定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3143, 522725, 522700, N'瓮安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3144, 522726, 522700, N'独山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3145, 522727, 522700, N'平塘县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3146, 522728, 522700, N'罗甸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3147, 522729, 522700, N'长顺县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3148, 522730, 522700, N'龙里县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3149, 522731, 522700, N'惠水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3150, 522732, 522700, N'三都水族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3151, 530000, 100000, N'云南省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3152, 530100, 530000, N'昆明市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3153, 530102, 530100, N'五华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3154, 530103, 530100, N'盘龙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3155, 530111, 530100, N'官渡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3156, 530112, 530100, N'西山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3157, 530113, 530100, N'东川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3158, 530114, 530100, N'呈贡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3159, 530115, 530100, N'晋宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3160, 530124, 530100, N'富民县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3161, 530125, 530100, N'宜良县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3162, 530126, 530100, N'石林彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3163, 530127, 530100, N'嵩明县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3164, 530128, 530100, N'禄劝彝族苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3165, 530129, 530100, N'寻甸回族彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3166, 530181, 530100, N'安宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3167, 530182, 530100, N'滇中新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3168, 530183, 530100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3169, 530300, 530000, N'曲靖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3170, 530302, 530300, N'麒麟区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3171, 530303, 530300, N'沾益区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3172, 530321, 530300, N'马龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3173, 530322, 530300, N'陆良县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3174, 530323, 530300, N'师宗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3175, 530324, 530300, N'罗平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3176, 530325, 530300, N'富源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3177, 530326, 530300, N'会泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3178, 530381, 530300, N'宣威市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3179, 530400, 530000, N'玉溪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3180, 530402, 530400, N'红塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3181, 530403, 530400, N'江川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3182, 530422, 530400, N'澄江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3183, 530423, 530400, N'通海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3184, 530424, 530400, N'华宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3185, 530425, 530400, N'易门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3186, 530426, 530400, N'峨山彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3187, 530427, 530400, N'新平彝族傣族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3188, 530428, 530400, N'元江哈尼族彝族傣族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3189, 530500, 530000, N'保山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3190, 530502, 530500, N'隆阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3191, 530521, 530500, N'施甸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3192, 530523, 530500, N'龙陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3193, 530524, 530500, N'昌宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3194, 530581, 530500, N'腾冲市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3195, 530600, 530000, N'昭通市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3196, 530602, 530600, N'昭阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3197, 530621, 530600, N'鲁甸县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3198, 530622, 530600, N'巧家县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3199, 530623, 530600, N'盐津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3200, 530624, 530600, N'大关县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3201, 530625, 530600, N'永善县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3202, 530626, 530600, N'绥江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3203, 530627, 530600, N'镇雄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3204, 530628, 530600, N'彝良县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3205, 530629, 530600, N'威信县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3206, 530630, 530600, N'水富县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3207, 530700, 530000, N'丽江市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3208, 530702, 530700, N'古城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3209, 530721, 530700, N'玉龙纳西族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3210, 530722, 530700, N'永胜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3211, 530723, 530700, N'华坪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3212, 530724, 530700, N'宁蒗彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3213, 530800, 530000, N'普洱市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3214, 530802, 530800, N'思茅区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3215, 530821, 530800, N'宁洱哈尼族彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3216, 530822, 530800, N'墨江哈尼族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3217, 530823, 530800, N'景东彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3218, 530824, 530800, N'景谷傣族彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3219, 530825, 530800, N'镇沅彝族哈尼族拉祜族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3220, 530826, 530800, N'江城哈尼族彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3221, 530827, 530800, N'孟连傣族拉祜族佤族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3222, 530828, 530800, N'澜沧拉祜族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3223, 530829, 530800, N'西盟佤族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3224, 530900, 530000, N'临沧市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3225, 530902, 530900, N'临翔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3226, 530921, 530900, N'凤庆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3227, 530922, 530900, N'云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3228, 530923, 530900, N'永德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3229, 530924, 530900, N'镇康县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3230, 530925, 530900, N'双江拉祜族佤族布朗族傣族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3231, 530926, 530900, N'耿马傣族佤族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3232, 530927, 530900, N'沧源佤族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3233, 532300, 530000, N'楚雄彝族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3234, 532301, 532300, N'楚雄市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3235, 532322, 532300, N'双柏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3236, 532323, 532300, N'牟定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3237, 532324, 532300, N'南华县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3238, 532325, 532300, N'姚安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3239, 532326, 532300, N'大姚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3240, 532327, 532300, N'永仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3241, 532328, 532300, N'元谋县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3242, 532329, 532300, N'武定县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3243, 532331, 532300, N'禄丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3244, 532500, 530000, N'红河哈尼族彝族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3245, 532501, 532500, N'个旧市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3246, 532502, 532500, N'开远市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3247, 532503, 532500, N'蒙自市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3248, 532504, 532500, N'弥勒市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3249, 532523, 532500, N'屏边苗族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3250, 532524, 532500, N'建水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3251, 532525, 532500, N'石屏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3252, 532527, 532500, N'泸西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3253, 532528, 532500, N'元阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3254, 532529, 532500, N'红河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3255, 532530, 532500, N'金平苗族瑶族傣族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3256, 532531, 532500, N'绿春县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3257, 532532, 532500, N'河口瑶族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3258, 532600, 530000, N'文山壮族苗族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3259, 532601, 532600, N'文山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3260, 532622, 532600, N'砚山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3261, 532623, 532600, N'西畴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3262, 532624, 532600, N'麻栗坡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3263, 532625, 532600, N'马关县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3264, 532626, 532600, N'丘北县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3265, 532627, 532600, N'广南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3266, 532628, 532600, N'富宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3267, 532800, 530000, N'西双版纳傣族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3268, 532801, 532800, N'景洪市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3269, 532822, 532800, N'勐海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3270, 532823, 532800, N'勐腊县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3271, 532900, 530000, N'大理白族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3272, 532901, 532900, N'大理市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3273, 532922, 532900, N'漾濞彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3274, 532923, 532900, N'祥云县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3275, 532924, 532900, N'宾川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3276, 532925, 532900, N'弥渡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3277, 532926, 532900, N'南涧彝族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3278, 532927, 532900, N'巍山彝族回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3279, 532928, 532900, N'永平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3280, 532929, 532900, N'云龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3281, 532930, 532900, N'洱源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3282, 532931, 532900, N'剑川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3283, 532932, 532900, N'鹤庆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3284, 533100, 530000, N'德宏傣族景颇族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3285, 533102, 533100, N'瑞丽市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3286, 533103, 533100, N'芒市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3287, 533122, 533100, N'梁河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3288, 533123, 533100, N'盈江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3289, 533124, 533100, N'陇川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3290, 533300, 530000, N'怒江傈僳族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3291, 533301, 533300, N'泸水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3292, 533323, 533300, N'福贡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3293, 533324, 533300, N'贡山独龙族怒族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3294, 533325, 533300, N'兰坪白族普米族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3295, 533400, 530000, N'迪庆藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3296, 533401, 533400, N'香格里拉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3297, 533422, 533400, N'德钦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3298, 533423, 533400, N'维西傈僳族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3299, 540000, 100000, N'西藏自治区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3300, 540100, 540000, N'拉萨市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3301, 540102, 540100, N'城关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3302, 540103, 540100, N'堆龙德庆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3303, 540121, 540100, N'林周县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3304, 540122, 540100, N'当雄县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3305, 540123, 540100, N'尼木县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3306, 540124, 540100, N'曲水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3307, 540126, 540100, N'达孜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3308, 540127, 540100, N'墨竹工卡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3309, 540200, 540000, N'日喀则市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3310, 540202, 540200, N'桑珠孜区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3311, 540221, 540200, N'南木林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3312, 540222, 540200, N'江孜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3313, 540223, 540200, N'定日县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3314, 540224, 540200, N'萨迦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3315, 540225, 540200, N'拉孜县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3316, 540226, 540200, N'昂仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3317, 540227, 540200, N'谢通门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3318, 540228, 540200, N'白朗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3319, 540229, 540200, N'仁布县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3320, 540230, 540200, N'康马县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3321, 540231, 540200, N'定结县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3322, 540232, 540200, N'仲巴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3323, 540233, 540200, N'亚东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3324, 540234, 540200, N'吉隆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3325, 540235, 540200, N'聂拉木县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3326, 540236, 540200, N'萨嘎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3327, 540237, 540200, N'岗巴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3328, 540300, 540000, N'昌都市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3329, 540302, 540300, N'卡若区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3330, 540321, 540300, N'江达县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3331, 540322, 540300, N'贡觉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3332, 540323, 540300, N'类乌齐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3333, 540324, 540300, N'丁青县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3334, 540325, 540300, N'察雅县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3335, 540326, 540300, N'八宿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3336, 540327, 540300, N'左贡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3337, 540328, 540300, N'芒康县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3338, 540329, 540300, N'洛隆县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3339, 540330, 540300, N'边坝县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3340, 540400, 540000, N'林芝市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3341, 540402, 540400, N'巴宜区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3342, 540421, 540400, N'工布江达县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3343, 540422, 540400, N'米林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3344, 540423, 540400, N'墨脱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3345, 540424, 540400, N'波密县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3346, 540425, 540400, N'察隅县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3347, 540426, 540400, N'朗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3348, 540500, 540000, N'山南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3349, 540502, 540500, N'乃东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3350, 540521, 540500, N'扎囊县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3351, 540522, 540500, N'贡嘎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3352, 540523, 540500, N'桑日县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3353, 540524, 540500, N'琼结县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3354, 540525, 540500, N'曲松县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3355, 540526, 540500, N'措美县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3356, 540527, 540500, N'洛扎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3357, 540528, 540500, N'加查县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3358, 540529, 540500, N'隆子县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3359, 540530, 540500, N'错那县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3360, 540531, 540500, N'浪卡子县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3361, 542400, 540000, N'那曲地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3362, 542421, 542400, N'那曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3363, 542422, 542400, N'嘉黎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3364, 542423, 542400, N'比如县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3365, 542424, 542400, N'聂荣县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3366, 542425, 542400, N'安多县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3367, 542426, 542400, N'申扎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3368, 542427, 542400, N'索县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3369, 542428, 542400, N'班戈县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3370, 542429, 542400, N'巴青县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3371, 542430, 542400, N'尼玛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3372, 542431, 542400, N'双湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3373, 542500, 540000, N'阿里地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3374, 542521, 542500, N'普兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3375, 542522, 542500, N'札达县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3376, 542523, 542500, N'噶尔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3377, 542524, 542500, N'日土县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3378, 542525, 542500, N'革吉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3379, 542526, 542500, N'改则县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3380, 542527, 542500, N'措勤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3381, 610000, 100000, N'陕西省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3382, 610100, 610000, N'西安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3383, 610102, 610100, N'新城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3384, 610103, 610100, N'碑林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3385, 610104, 610100, N'莲湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3386, 610111, 610100, N'灞桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3387, 610112, 610100, N'未央区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3388, 610113, 610100, N'雁塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3389, 610114, 610100, N'阎良区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3390, 610115, 610100, N'临潼区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3391, 610116, 610100, N'长安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3392, 610117, 610100, N'高陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3393, 610118, 610100, N'鄠邑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3394, 610122, 610100, N'蓝田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3395, 610124, 610100, N'周至县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3396, 610125, 610100, N'西咸新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3397, 610127, 610100, N'曲江新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3398, 610128, 610100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3399, 610200, 610000, N'铜川市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3400, 610202, 610200, N'王益区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3401, 610203, 610200, N'印台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3402, 610204, 610200, N'耀州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3403, 610222, 610200, N'宜君县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3404, 610300, 610000, N'宝鸡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3405, 610302, 610300, N'渭滨区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3406, 610303, 610300, N'金台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3407, 610304, 610300, N'陈仓区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3408, 610322, 610300, N'凤翔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3409, 610323, 610300, N'岐山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3410, 610324, 610300, N'扶风县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3411, 610326, 610300, N'眉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3412, 610327, 610300, N'陇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3413, 610328, 610300, N'千阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3414, 610329, 610300, N'麟游县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3415, 610330, 610300, N'凤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3416, 610331, 610300, N'太白县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3417, 610332, 610300, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3418, 610400, 610000, N'咸阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3419, 610402, 610400, N'秦都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3420, 610403, 610400, N'杨陵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3421, 610404, 610400, N'渭城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3422, 610422, 610400, N'三原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3423, 610423, 610400, N'泾阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3424, 610424, 610400, N'乾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3425, 610425, 610400, N'礼泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3426, 610426, 610400, N'永寿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3427, 610427, 610400, N'彬县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3428, 610428, 610400, N'长武县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3429, 610429, 610400, N'旬邑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3430, 610430, 610400, N'淳化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3431, 610431, 610400, N'武功县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3432, 610481, 610400, N'兴平市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3433, 610482, 610400, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3434, 610500, 610000, N'渭南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3435, 610502, 610500, N'临渭区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3436, 610503, 610500, N'华州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3437, 610522, 610500, N'潼关县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3438, 610523, 610500, N'大荔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3439, 610524, 610500, N'合阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3440, 610525, 610500, N'澄城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3441, 610526, 610500, N'蒲城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3442, 610527, 610500, N'白水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3443, 610528, 610500, N'富平县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3444, 610581, 610500, N'韩城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3445, 610582, 610500, N'华阴市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3446, 610600, 610000, N'延安市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3447, 610602, 610600, N'宝塔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3448, 610603, 610600, N'安塞区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3449, 610621, 610600, N'延长县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3450, 610622, 610600, N'延川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3451, 610623, 610600, N'子长县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3452, 610625, 610600, N'志丹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3453, 610626, 610600, N'吴起县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3454, 610627, 610600, N'甘泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3455, 610628, 610600, N'富县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3456, 610629, 610600, N'洛川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3457, 610630, 610600, N'宜川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3458, 610631, 610600, N'黄龙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3459, 610632, 610600, N'黄陵县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3460, 610700, 610000, N'汉中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3461, 610702, 610700, N'汉台区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3462, 610721, 610700, N'南郑县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3463, 610722, 610700, N'城固县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3464, 610723, 610700, N'洋县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3465, 610724, 610700, N'西乡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3466, 610725, 610700, N'勉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3467, 610726, 610700, N'宁强县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3468, 610727, 610700, N'略阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3469, 610728, 610700, N'镇巴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3470, 610729, 610700, N'留坝县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3471, 610730, 610700, N'佛坪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3472, 610800, 610000, N'榆林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3473, 610802, 610800, N'榆阳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3474, 610803, 610800, N'横山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3475, 610822, 610800, N'府谷县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3476, 610824, 610800, N'靖边县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3477, 610825, 610800, N'定边县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3478, 610826, 610800, N'绥德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3479, 610827, 610800, N'米脂县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3480, 610828, 610800, N'佳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3481, 610829, 610800, N'吴堡县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3482, 610830, 610800, N'清涧县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3483, 610831, 610800, N'子洲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3484, 610881, 610800, N'神木市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3485, 610900, 610000, N'安康市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3486, 610902, 610900, N'汉滨区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3487, 610921, 610900, N'汉阴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3488, 610922, 610900, N'石泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3489, 610923, 610900, N'宁陕县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3490, 610924, 610900, N'紫阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3491, 610925, 610900, N'岚皋县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3492, 610926, 610900, N'平利县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3493, 610927, 610900, N'镇坪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3494, 610928, 610900, N'旬阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3495, 610929, 610900, N'白河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3496, 611000, 610000, N'商洛市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3497, 611002, 611000, N'商州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3498, 611021, 611000, N'洛南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3499, 611022, 611000, N'丹凤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3500, 611023, 611000, N'商南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3501, 611024, 611000, N'山阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3502, 611025, 611000, N'镇安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3503, 611026, 611000, N'柞水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3504, 620000, 100000, N'甘肃省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3505, 620100, 620000, N'兰州市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3506, 620102, 620100, N'城关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3507, 620103, 620100, N'七里河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3508, 620104, 620100, N'西固区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3509, 620105, 620100, N'安宁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3510, 620111, 620100, N'红古区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3511, 620121, 620100, N'永登县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3512, 620122, 620100, N'皋兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3513, 620123, 620100, N'榆中县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3514, 620124, 620100, N'兰州新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3515, 620125, 620100, N'高新区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3516, 620126, 620100, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3517, 620200, 620000, N'嘉峪关市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3518, 620201, 620200, N'雄关区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3519, 620202, 620200, N'长城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3520, 620203, 620200, N'镜铁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3521, 620300, 620000, N'金昌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3522, 620302, 620300, N'金川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3523, 620321, 620300, N'永昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3524, 620400, 620000, N'白银市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3525, 620402, 620400, N'白银区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3526, 620403, 620400, N'平川区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3527, 620421, 620400, N'靖远县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3528, 620422, 620400, N'会宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3529, 620423, 620400, N'景泰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3530, 620500, 620000, N'天水市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3531, 620502, 620500, N'秦州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3532, 620503, 620500, N'麦积区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3533, 620521, 620500, N'清水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3534, 620522, 620500, N'秦安县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3535, 620523, 620500, N'甘谷县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3536, 620524, 620500, N'武山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3537, 620525, 620500, N'张家川回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3538, 620600, 620000, N'武威市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3539, 620602, 620600, N'凉州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3540, 620621, 620600, N'民勤县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3541, 620622, 620600, N'古浪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3542, 620623, 620600, N'天祝藏族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3543, 620700, 620000, N'张掖市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3544, 620702, 620700, N'甘州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3545, 620721, 620700, N'肃南裕固族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3546, 620722, 620700, N'民乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3547, 620723, 620700, N'临泽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3548, 620724, 620700, N'高台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3549, 620725, 620700, N'山丹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3550, 620800, 620000, N'平凉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3551, 620802, 620800, N'崆峒区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3552, 620821, 620800, N'泾川县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3553, 620822, 620800, N'灵台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3554, 620823, 620800, N'崇信县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3555, 620824, 620800, N'华亭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3556, 620825, 620800, N'庄浪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3557, 620826, 620800, N'静宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3558, 620900, 620000, N'酒泉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3559, 620902, 620900, N'肃州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3560, 620921, 620900, N'金塔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3561, 620922, 620900, N'瓜州县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3562, 620923, 620900, N'肃北蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3563, 620924, 620900, N'阿克塞哈萨克族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3564, 620981, 620900, N'玉门市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3565, 620982, 620900, N'敦煌市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3566, 621000, 620000, N'庆阳市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3567, 621002, 621000, N'西峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3568, 621021, 621000, N'庆城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3569, 621022, 621000, N'环县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3570, 621023, 621000, N'华池县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3571, 621024, 621000, N'合水县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3572, 621025, 621000, N'正宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3573, 621026, 621000, N'宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3574, 621027, 621000, N'镇原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3575, 621100, 620000, N'定西市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3576, 621102, 621100, N'安定区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3577, 621121, 621100, N'通渭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3578, 621122, 621100, N'陇西县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3579, 621123, 621100, N'渭源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3580, 621124, 621100, N'临洮县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3581, 621125, 621100, N'漳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3582, 621126, 621100, N'岷县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3583, 621200, 620000, N'陇南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3584, 621202, 621200, N'武都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3585, 621221, 621200, N'成县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3586, 621222, 621200, N'文县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3587, 621223, 621200, N'宕昌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3588, 621224, 621200, N'康县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3589, 621225, 621200, N'西和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3590, 621226, 621200, N'礼县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3591, 621227, 621200, N'徽县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3592, 621228, 621200, N'两当县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3593, 622900, 620000, N'临夏回族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3594, 622901, 622900, N'临夏市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3595, 622921, 622900, N'临夏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3596, 622922, 622900, N'康乐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3597, 622923, 622900, N'永靖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3598, 622924, 622900, N'广河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3599, 622925, 622900, N'和政县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3600, 622926, 622900, N'东乡族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3601, 622927, 622900, N'积石山保安族东乡族撒拉族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3602, 623000, 620000, N'甘南藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3603, 623001, 623000, N'合作市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3604, 623021, 623000, N'临潭县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3605, 623022, 623000, N'卓尼县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3606, 623023, 623000, N'舟曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3607, 623024, 623000, N'迭部县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3608, 623025, 623000, N'玛曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3609, 623026, 623000, N'碌曲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3610, 623027, 623000, N'夏河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3611, 630000, 100000, N'青海省')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3612, 630100, 630000, N'西宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3613, 630102, 630100, N'城东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3614, 630103, 630100, N'城中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3615, 630104, 630100, N'城西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3616, 630105, 630100, N'城北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3617, 630121, 630100, N'大通回族土族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3618, 630122, 630100, N'湟中县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3619, 630123, 630100, N'湟源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3620, 630200, 630000, N'海东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3621, 630202, 630200, N'乐都区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3622, 630203, 630200, N'平安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3623, 630222, 630200, N'民和回族土族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3624, 630223, 630200, N'互助土族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3625, 630224, 630200, N'化隆回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3626, 630225, 630200, N'循化撒拉族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3627, 632200, 630000, N'海北藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3628, 632221, 632200, N'门源回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3629, 632222, 632200, N'祁连县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3630, 632223, 632200, N'海晏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3631, 632224, 632200, N'刚察县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3632, 632300, 630000, N'黄南藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3633, 632321, 632300, N'同仁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3634, 632322, 632300, N'尖扎县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3635, 632323, 632300, N'泽库县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3636, 632324, 632300, N'河南蒙古族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3637, 632500, 630000, N'海南藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3638, 632521, 632500, N'共和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3639, 632522, 632500, N'同德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3640, 632523, 632500, N'贵德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3641, 632524, 632500, N'兴海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3642, 632525, 632500, N'贵南县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3643, 632600, 630000, N'果洛藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3644, 632621, 632600, N'玛沁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3645, 632622, 632600, N'班玛县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3646, 632623, 632600, N'甘德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3647, 632624, 632600, N'达日县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3648, 632625, 632600, N'久治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3649, 632626, 632600, N'玛多县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3650, 632700, 630000, N'玉树藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3651, 632701, 632700, N'玉树市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3652, 632722, 632700, N'杂多县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3653, 632723, 632700, N'称多县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3654, 632724, 632700, N'治多县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3655, 632725, 632700, N'囊谦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3656, 632726, 632700, N'曲麻莱县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3657, 632800, 630000, N'海西蒙古族藏族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3658, 632801, 632800, N'格尔木市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3659, 632802, 632800, N'德令哈市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3660, 632821, 632800, N'乌兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3661, 632822, 632800, N'都兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3662, 632823, 632800, N'天峻县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3663, 640000, 100000, N'宁夏回族自治区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3664, 640100, 640000, N'银川市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3665, 640104, 640100, N'兴庆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3666, 640105, 640100, N'西夏区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3667, 640106, 640100, N'金凤区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3668, 640121, 640100, N'永宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3669, 640122, 640100, N'贺兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3670, 640181, 640100, N'灵武市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3671, 640182, 640100, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3672, 640200, 640000, N'石嘴山市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3673, 640202, 640200, N'大武口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3674, 640205, 640200, N'惠农区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3675, 640221, 640200, N'平罗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3676, 640222, 640200, N'经济开发区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3677, 640300, 640000, N'吴忠市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3678, 640302, 640300, N'利通区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3679, 640303, 640300, N'红寺堡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3680, 640323, 640300, N'盐池县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3681, 640324, 640300, N'同心县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3682, 640381, 640300, N'青铜峡市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3683, 640400, 640000, N'固原市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3684, 640402, 640400, N'原州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3685, 640422, 640400, N'西吉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3686, 640423, 640400, N'隆德县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3687, 640424, 640400, N'泾源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3688, 640425, 640400, N'彭阳县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3689, 640500, 640000, N'中卫市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3690, 640502, 640500, N'沙坡头区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3691, 640521, 640500, N'中宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3692, 640522, 640500, N'海原县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3693, 650000, 100000, N'新疆维吾尔自治区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3694, 650100, 650000, N'乌鲁木齐市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3695, 650102, 650100, N'天山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3696, 650103, 650100, N'沙依巴克区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3697, 650104, 650100, N'新市区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3698, 650105, 650100, N'水磨沟区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3699, 650106, 650100, N'头屯河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3700, 650107, 650100, N'达坂城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3701, 650109, 650100, N'米东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3702, 650121, 650100, N'乌鲁木齐县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3703, 650200, 650000, N'克拉玛依市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3704, 650202, 650200, N'独山子区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3705, 650203, 650200, N'克拉玛依区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3706, 650204, 650200, N'白碱滩区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3707, 650205, 650200, N'乌尔禾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3708, 650400, 650000, N'吐鲁番市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3709, 650402, 650400, N'高昌区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3710, 650421, 650400, N'鄯善县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3711, 650422, 650400, N'托克逊县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3712, 650500, 650000, N'哈密市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3713, 650502, 650500, N'伊州区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3714, 650521, 650500, N'巴里坤哈萨克自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3715, 650522, 650500, N'伊吾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3716, 652300, 650000, N'昌吉回族自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3717, 652301, 652300, N'昌吉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3718, 652302, 652300, N'阜康市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3719, 652323, 652300, N'呼图壁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3720, 652324, 652300, N'玛纳斯县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3721, 652325, 652300, N'奇台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3722, 652327, 652300, N'吉木萨尔县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3723, 652328, 652300, N'木垒哈萨克自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3724, 652700, 650000, N'博尔塔拉蒙古自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3725, 652701, 652700, N'博乐市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3726, 652702, 652700, N'阿拉山口市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3727, 652722, 652700, N'精河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3728, 652723, 652700, N'温泉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3729, 652800, 650000, N'巴音郭楞蒙古自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3730, 652801, 652800, N'库尔勒市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3731, 652822, 652800, N'轮台县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3732, 652823, 652800, N'尉犁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3733, 652824, 652800, N'若羌县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3734, 652825, 652800, N'且末县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3735, 652826, 652800, N'焉耆回族自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3736, 652827, 652800, N'和静县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3737, 652828, 652800, N'和硕县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3738, 652829, 652800, N'博湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3739, 652900, 650000, N'阿克苏地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3740, 652901, 652900, N'阿克苏市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3741, 652922, 652900, N'温宿县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3742, 652923, 652900, N'库车县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3743, 652924, 652900, N'沙雅县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3744, 652925, 652900, N'新和县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3745, 652926, 652900, N'拜城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3746, 652927, 652900, N'乌什县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3747, 652928, 652900, N'阿瓦提县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3748, 652929, 652900, N'柯坪县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3749, 653000, 650000, N'克孜勒苏柯尔克孜自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3750, 653001, 653000, N'阿图什市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3751, 653022, 653000, N'阿克陶县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3752, 653023, 653000, N'阿合奇县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3753, 653024, 653000, N'乌恰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3754, 653100, 650000, N'喀什地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3755, 653101, 653100, N'喀什市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3756, 653121, 653100, N'疏附县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3757, 653122, 653100, N'疏勒县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3758, 653123, 653100, N'英吉沙县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3759, 653124, 653100, N'泽普县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3760, 653125, 653100, N'莎车县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3761, 653126, 653100, N'叶城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3762, 653127, 653100, N'麦盖提县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3763, 653128, 653100, N'岳普湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3764, 653129, 653100, N'伽师县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3765, 653130, 653100, N'巴楚县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3766, 653131, 653100, N'塔什库尔干塔吉克自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3767, 653200, 650000, N'和田地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3768, 653201, 653200, N'和田市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3769, 653221, 653200, N'和田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3770, 653222, 653200, N'墨玉县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3771, 653223, 653200, N'皮山县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3772, 653224, 653200, N'洛浦县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3773, 653225, 653200, N'策勒县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3774, 653226, 653200, N'于田县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3775, 653227, 653200, N'民丰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3776, 654000, 650000, N'伊犁哈萨克自治州')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3777, 654002, 654000, N'伊宁市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3778, 654003, 654000, N'奎屯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3779, 654004, 654000, N'霍尔果斯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3780, 654021, 654000, N'伊宁县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3781, 654022, 654000, N'察布查尔锡伯自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3782, 654023, 654000, N'霍城县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3783, 654024, 654000, N'巩留县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3784, 654025, 654000, N'新源县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3785, 654026, 654000, N'昭苏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3786, 654027, 654000, N'特克斯县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3787, 654028, 654000, N'尼勒克县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3788, 654200, 650000, N'塔城地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3789, 654201, 654200, N'塔城市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3790, 654202, 654200, N'乌苏市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3791, 654221, 654200, N'额敏县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3792, 654223, 654200, N'沙湾县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3793, 654224, 654200, N'托里县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3794, 654225, 654200, N'裕民县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3795, 654226, 654200, N'和布克赛尔蒙古自治县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3796, 654300, 650000, N'阿勒泰地区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3797, 654301, 654300, N'阿勒泰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3798, 654321, 654300, N'布尔津县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3799, 654322, 654300, N'富蕴县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3800, 654323, 654300, N'福海县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3801, 654324, 654300, N'哈巴河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3802, 654325, 654300, N'青河县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3803, 654326, 654300, N'吉木乃县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3804, 659001, 650000, N'石河子市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3805, 659002, 650000, N'阿拉尔市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3806, 659003, 650000, N'图木舒克市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3807, 659004, 650000, N'五家渠市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3808, 659005, 650000, N'北屯市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3809, 659006, 650000, N'铁门关市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3810, 659007, 650000, N'双河市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3811, 659008, 650000, N'可克达拉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3812, 659009, 650000, N'昆玉市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3813, 659101, 659001, N'新城街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3814, 659102, 659001, N'向阳街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3815, 659103, 659001, N'红山街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3816, 659104, 659001, N'老街街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3817, 659105, 659001, N'东城街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3818, 659106, 659001, N'北泉镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3819, 659107, 659001, N'石河子乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3820, 659108, 659001, N'一五二团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3821, 659201, 659002, N'幸福路街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3822, 659202, 659002, N'金银川路街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3823, 659203, 659002, N'青松路街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3824, 659204, 659002, N'南口街道')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3825, 659205, 659002, N'托喀依乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3826, 659206, 659002, N'金银川镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3827, 659301, 659003, N'图木舒克市区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3828, 659302, 659003, N'兵团四十四团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3829, 659303, 659003, N'兵团四十九团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3830, 659304, 659003, N'兵团五十团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3831, 659305, 659003, N'兵团五十一团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3832, 659306, 659003, N'兵团五十二团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3833, 659307, 659003, N'兵团五十三团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3834, 659308, 659003, N'喀拉拜勒镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3835, 659309, 659003, N'永安坝')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3836, 659401, 659004, N'城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3837, 659402, 659004, N'一零一团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3838, 659403, 659004, N'一零二团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3839, 659404, 659004, N'一零三团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3840, 659501, 659005, N'新城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3841, 659502, 659005, N'老城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3842, 659503, 659005, N'工业园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3843, 659504, 659005, N'海川镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3844, 659505, 659005, N'丰庆镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3845, 659506, 659005, N'锡伯渡镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3846, 659601, 659006, N'二十九团场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3847, 659602, 659006, N'库西经济工业园')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3848, 659603, 659006, N'博古其镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3849, 659604, 659006, N'双丰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3850, 659701, 659007, N'八十一团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3851, 659702, 659007, N'八十四团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3852, 659703, 659007, N'八十五团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3853, 659704, 659007, N'八十六团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3854, 659705, 659007, N'八十九团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3855, 659706, 659007, N'九十团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3856, 659801, 659008, N'63团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3857, 659802, 659008, N'64团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3858, 659803, 659008, N'66团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3859, 659804, 659008, N'67团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3860, 659805, 659008, N'68团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3861, 659901, 659009, N'皮山农场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3862, 659902, 659009, N'二二四团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3863, 659903, 659009, N'四十七团')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3864, 659904, 659009, N'一牧场')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3865, 710000, 100000, N'台湾')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3866, 710100, 710000, N'台北市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3867, 710101, 710100, N'松山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3868, 710102, 710100, N'信义区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3869, 710103, 710100, N'大安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3870, 710104, 710100, N'中山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3871, 710105, 710100, N'中正区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3872, 710106, 710100, N'大同区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3873, 710107, 710100, N'万华区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3874, 710108, 710100, N'文山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3875, 710109, 710100, N'南港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3876, 710110, 710100, N'内湖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3877, 710111, 710100, N'士林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3878, 710112, 710100, N'北投区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3879, 710200, 710000, N'高雄市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3880, 710201, 710200, N'盐埕区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3881, 710202, 710200, N'鼓山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3882, 710203, 710200, N'左营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3883, 710204, 710200, N'楠梓区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3884, 710205, 710200, N'三民区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3885, 710206, 710200, N'新兴区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3886, 710207, 710200, N'前金区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3887, 710208, 710200, N'苓雅区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3888, 710209, 710200, N'前镇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3889, 710210, 710200, N'旗津区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3890, 710211, 710200, N'小港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3891, 710212, 710200, N'凤山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3892, 710213, 710200, N'林园区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3893, 710214, 710200, N'大寮区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3894, 710215, 710200, N'大树区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3895, 710216, 710200, N'大社区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3896, 710217, 710200, N'仁武区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3897, 710218, 710200, N'鸟松区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3898, 710219, 710200, N'冈山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3899, 710220, 710200, N'桥头区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3900, 710221, 710200, N'燕巢区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3901, 710222, 710200, N'田寮区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3902, 710223, 710200, N'阿莲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3903, 710224, 710200, N'路竹区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3904, 710225, 710200, N'湖内区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3905, 710226, 710200, N'茄萣区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3906, 710227, 710200, N'永安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3907, 710228, 710200, N'弥陀区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3908, 710229, 710200, N'梓官区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3909, 710230, 710200, N'旗山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3910, 710231, 710200, N'美浓区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3911, 710232, 710200, N'六龟区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3912, 710233, 710200, N'甲仙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3913, 710234, 710200, N'杉林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3914, 710235, 710200, N'内门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3915, 710236, 710200, N'茂林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3916, 710237, 710200, N'桃源区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3917, 710238, 710200, N'那玛夏区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3918, 710300, 710000, N'基隆市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3919, 710301, 710300, N'中正区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3920, 710302, 710300, N'七堵区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3921, 710303, 710300, N'暖暖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3922, 710304, 710300, N'仁爱区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3923, 710305, 710300, N'中山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3924, 710306, 710300, N'安乐区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3925, 710307, 710300, N'信义区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3926, 710400, 710000, N'台中市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3927, 710401, 710400, N'中区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3928, 710402, 710400, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3929, 710403, 710400, N'南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3930, 710404, 710400, N'西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3931, 710405, 710400, N'北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3932, 710406, 710400, N'西屯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3933, 710407, 710400, N'南屯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3934, 710408, 710400, N'北屯区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3935, 710409, 710400, N'丰原区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3936, 710410, 710400, N'东势区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3937, 710411, 710400, N'大甲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3938, 710412, 710400, N'清水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3939, 710413, 710400, N'沙鹿区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3940, 710414, 710400, N'梧栖区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3941, 710415, 710400, N'后里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3942, 710416, 710400, N'神冈区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3943, 710417, 710400, N'潭子区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3944, 710418, 710400, N'大雅区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3945, 710419, 710400, N'新社区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3946, 710420, 710400, N'石冈区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3947, 710421, 710400, N'外埔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3948, 710422, 710400, N'大安区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3949, 710423, 710400, N'乌日区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3950, 710424, 710400, N'大肚区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3951, 710425, 710400, N'龙井区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3952, 710426, 710400, N'雾峰区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3953, 710427, 710400, N'太平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3954, 710428, 710400, N'大里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3955, 710429, 710400, N'和平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3956, 710500, 710000, N'台南市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3957, 710501, 710500, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3958, 710502, 710500, N'南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3959, 710504, 710500, N'北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3960, 710506, 710500, N'安南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3961, 710507, 710500, N'安平区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3962, 710508, 710500, N'中西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3963, 710509, 710500, N'新营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3964, 710510, 710500, N'盐水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3965, 710511, 710500, N'白河区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3966, 710512, 710500, N'柳营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3967, 710513, 710500, N'后壁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3968, 710514, 710500, N'东山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3969, 710515, 710500, N'麻豆区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3970, 710516, 710500, N'下营区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3971, 710517, 710500, N'六甲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3972, 710518, 710500, N'官田区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3973, 710519, 710500, N'大内区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3974, 710520, 710500, N'佳里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3975, 710521, 710500, N'学甲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3976, 710522, 710500, N'西港区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3977, 710523, 710500, N'七股区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3978, 710524, 710500, N'将军区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3979, 710525, 710500, N'北门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3980, 710526, 710500, N'新化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3981, 710527, 710500, N'善化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3982, 710528, 710500, N'新市区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3983, 710529, 710500, N'安定区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3984, 710530, 710500, N'山上区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3985, 710531, 710500, N'玉井区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3986, 710532, 710500, N'楠西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3987, 710533, 710500, N'南化区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3988, 710534, 710500, N'左镇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3989, 710535, 710500, N'仁德区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3990, 710536, 710500, N'归仁区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3991, 710537, 710500, N'关庙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3992, 710538, 710500, N'龙崎区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3993, 710539, 710500, N'永康区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3994, 710600, 710000, N'新竹市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3995, 710601, 710600, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3996, 710602, 710600, N'北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3997, 710603, 710600, N'香山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3998, 710700, 710000, N'嘉义市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (3999, 710701, 710700, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4000, 710702, 710700, N'西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4001, 710800, 710000, N'新北市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4002, 710801, 710800, N'板桥区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4003, 710802, 710800, N'三重区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4004, 710803, 710800, N'中和区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4005, 710804, 710800, N'永和区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4006, 710805, 710800, N'新庄区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4007, 710806, 710800, N'新店区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4008, 710807, 710800, N'树林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4009, 710808, 710800, N'莺歌区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4010, 710809, 710800, N'三峡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4011, 710810, 710800, N'淡水区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4012, 710811, 710800, N'汐止区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4013, 710812, 710800, N'瑞芳区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4014, 710813, 710800, N'土城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4015, 710814, 710800, N'芦洲区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4016, 710815, 710800, N'五股区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4017, 710816, 710800, N'泰山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4018, 710817, 710800, N'林口区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4019, 710818, 710800, N'深坑区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4020, 710819, 710800, N'石碇区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4021, 710820, 710800, N'坪林区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4022, 710821, 710800, N'三芝区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4023, 710822, 710800, N'石门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4024, 710823, 710800, N'八里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4025, 710824, 710800, N'平溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4026, 710825, 710800, N'双溪区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4027, 710826, 710800, N'贡寮区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4028, 710827, 710800, N'金山区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4029, 710828, 710800, N'万里区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4030, 710829, 710800, N'乌来区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4031, 712200, 710000, N'宜兰县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4032, 712201, 712200, N'宜兰市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4033, 712221, 712200, N'罗东镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4034, 712222, 712200, N'苏澳镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4035, 712223, 712200, N'头城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4036, 712224, 712200, N'礁溪乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4037, 712225, 712200, N'壮围乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4038, 712226, 712200, N'员山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4039, 712227, 712200, N'冬山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4040, 712228, 712200, N'五结乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4041, 712229, 712200, N'三星乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4042, 712230, 712200, N'大同乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4043, 712231, 712200, N'南澳乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4044, 712300, 710000, N'桃园市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4045, 712301, 712300, N'桃园市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4046, 712302, 712300, N'中坜市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4047, 712303, 712300, N'平镇市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4048, 712304, 712300, N'八德市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4049, 712305, 712300, N'杨梅市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4050, 712306, 712300, N'芦竹市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4051, 712321, 712300, N'大溪镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4052, 712324, 712300, N'大园乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4053, 712325, 712300, N'龟山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4054, 712327, 712300, N'龙潭乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4055, 712329, 712300, N'新屋乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4056, 712330, 712300, N'观音乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4057, 712331, 712300, N'复兴乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4058, 712400, 710000, N'新竹县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4059, 712401, 712400, N'竹北市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4060, 712421, 712400, N'竹东镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4061, 712422, 712400, N'新埔镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4062, 712423, 712400, N'关西镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4063, 712424, 712400, N'湖口乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4064, 712425, 712400, N'新丰乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4065, 712426, 712400, N'芎林乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4066, 712427, 712400, N'横山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4067, 712428, 712400, N'北埔乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4068, 712429, 712400, N'宝山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4069, 712430, 712400, N'峨眉乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4070, 712431, 712400, N'尖石乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4071, 712432, 712400, N'五峰乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4072, 712500, 710000, N'苗栗县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4073, 712501, 712500, N'苗栗市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4074, 712521, 712500, N'苑里镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4075, 712522, 712500, N'通霄镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4076, 712523, 712500, N'竹南镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4077, 712524, 712500, N'头份市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4078, 712525, 712500, N'后龙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4079, 712526, 712500, N'卓兰镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4080, 712527, 712500, N'大湖乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4081, 712528, 712500, N'公馆乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4082, 712529, 712500, N'铜锣乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4083, 712530, 712500, N'南庄乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4084, 712531, 712500, N'头屋乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4085, 712532, 712500, N'三义乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4086, 712533, 712500, N'西湖乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4087, 712534, 712500, N'造桥乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4088, 712535, 712500, N'三湾乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4089, 712536, 712500, N'狮潭乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4090, 712537, 712500, N'泰安乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4091, 712700, 710000, N'彰化县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4092, 712701, 712700, N'彰化市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4093, 712721, 712700, N'鹿港镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4094, 712722, 712700, N'和美镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4095, 712723, 712700, N'线西乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4096, 712724, 712700, N'伸港乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4097, 712725, 712700, N'福兴乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4098, 712726, 712700, N'秀水乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4099, 712727, 712700, N'花坛乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4100, 712728, 712700, N'芬园乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4101, 712729, 712700, N'员林市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4102, 712730, 712700, N'溪湖镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4103, 712731, 712700, N'田中镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4104, 712732, 712700, N'大村乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4105, 712733, 712700, N'埔盐乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4106, 712734, 712700, N'埔心乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4107, 712735, 712700, N'永靖乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4108, 712736, 712700, N'社头乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4109, 712737, 712700, N'二水乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4110, 712738, 712700, N'北斗镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4111, 712739, 712700, N'二林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4112, 712740, 712700, N'田尾乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4113, 712741, 712700, N'埤头乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4114, 712742, 712700, N'芳苑乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4115, 712743, 712700, N'大城乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4116, 712744, 712700, N'竹塘乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4117, 712745, 712700, N'溪州乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4118, 712800, 710000, N'南投县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4119, 712801, 712800, N'南投市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4120, 712821, 712800, N'埔里镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4121, 712822, 712800, N'草屯镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4122, 712823, 712800, N'竹山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4123, 712824, 712800, N'集集镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4124, 712825, 712800, N'名间乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4125, 712826, 712800, N'鹿谷乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4126, 712827, 712800, N'中寮乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4127, 712828, 712800, N'鱼池乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4128, 712829, 712800, N'国姓乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4129, 712830, 712800, N'水里乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4130, 712831, 712800, N'信义乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4131, 712832, 712800, N'仁爱乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4132, 712900, 710000, N'云林县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4133, 712901, 712900, N'斗六市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4134, 712921, 712900, N'斗南镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4135, 712922, 712900, N'虎尾镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4136, 712923, 712900, N'西螺镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4137, 712924, 712900, N'土库镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4138, 712925, 712900, N'北港镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4139, 712926, 712900, N'古坑乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4140, 712927, 712900, N'大埤乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4141, 712928, 712900, N'莿桐乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4142, 712929, 712900, N'林内乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4143, 712930, 712900, N'二仑乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4144, 712931, 712900, N'仑背乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4145, 712932, 712900, N'麦寮乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4146, 712933, 712900, N'东势乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4147, 712934, 712900, N'褒忠乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4148, 712935, 712900, N'台西乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4149, 712936, 712900, N'元长乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4150, 712937, 712900, N'四湖乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4151, 712938, 712900, N'口湖乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4152, 712939, 712900, N'水林乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4153, 713000, 710000, N'嘉义县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4154, 713001, 713000, N'太保市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4155, 713002, 713000, N'朴子市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4156, 713023, 713000, N'布袋镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4157, 713024, 713000, N'大林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4158, 713025, 713000, N'民雄乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4159, 713026, 713000, N'溪口乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4160, 713027, 713000, N'新港乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4161, 713028, 713000, N'六脚乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4162, 713029, 713000, N'东石乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4163, 713030, 713000, N'义竹乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4164, 713031, 713000, N'鹿草乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4165, 713032, 713000, N'水上乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4166, 713033, 713000, N'中埔乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4167, 713034, 713000, N'竹崎乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4168, 713035, 713000, N'梅山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4169, 713036, 713000, N'番路乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4170, 713037, 713000, N'大埔乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4171, 713038, 713000, N'阿里山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4172, 713300, 710000, N'屏东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4173, 713301, 713300, N'屏东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4174, 713321, 713300, N'潮州镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4175, 713322, 713300, N'东港镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4176, 713323, 713300, N'恒春镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4177, 713324, 713300, N'万丹乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4178, 713325, 713300, N'长治乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4179, 713326, 713300, N'麟洛乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4180, 713327, 713300, N'九如乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4181, 713328, 713300, N'里港乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4182, 713329, 713300, N'盐埔乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4183, 713330, 713300, N'高树乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4184, 713331, 713300, N'万峦乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4185, 713332, 713300, N'内埔乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4186, 713333, 713300, N'竹田乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4187, 713334, 713300, N'新埤乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4188, 713335, 713300, N'枋寮乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4189, 713336, 713300, N'新园乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4190, 713337, 713300, N'崁顶乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4191, 713338, 713300, N'林边乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4192, 713339, 713300, N'南州乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4193, 713340, 713300, N'佳冬乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4194, 713341, 713300, N'琉球乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4195, 713342, 713300, N'车城乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4196, 713343, 713300, N'满州乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4197, 713344, 713300, N'枋山乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4198, 713345, 713300, N'三地门乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4199, 713346, 713300, N'雾台乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4200, 713347, 713300, N'玛家乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4201, 713348, 713300, N'泰武乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4202, 713349, 713300, N'来义乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4203, 713350, 713300, N'春日乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4204, 713351, 713300, N'狮子乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4205, 713352, 713300, N'牡丹乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4206, 713400, 710000, N'台东县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4207, 713401, 713400, N'台东市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4208, 713421, 713400, N'成功镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4209, 713422, 713400, N'关山镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4210, 713423, 713400, N'卑南乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4211, 713424, 713400, N'鹿野乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4212, 713425, 713400, N'池上乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4213, 713426, 713400, N'东河乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4214, 713427, 713400, N'长滨乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4215, 713428, 713400, N'太麻里乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4216, 713429, 713400, N'大武乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4217, 713430, 713400, N'绿岛乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4218, 713431, 713400, N'海端乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4219, 713432, 713400, N'延平乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4220, 713433, 713400, N'金峰乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4221, 713434, 713400, N'达仁乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4222, 713435, 713400, N'兰屿乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4223, 713500, 710000, N'花莲县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4224, 713501, 713500, N'花莲市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4225, 713521, 713500, N'凤林镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4226, 713522, 713500, N'玉里镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4227, 713523, 713500, N'新城乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4228, 713524, 713500, N'吉安乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4229, 713525, 713500, N'寿丰乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4230, 713526, 713500, N'光复乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4231, 713527, 713500, N'丰滨乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4232, 713528, 713500, N'瑞穗乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4233, 713529, 713500, N'富里乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4234, 713530, 713500, N'秀林乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4235, 713531, 713500, N'万荣乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4236, 713532, 713500, N'卓溪乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4237, 713600, 710000, N'澎湖县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4238, 713601, 713600, N'马公市')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4239, 713621, 713600, N'湖西乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4240, 713622, 713600, N'白沙乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4241, 713623, 713600, N'西屿乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4242, 713624, 713600, N'望安乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4243, 713625, 713600, N'七美乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4244, 713700, 710000, N'金门县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4245, 713701, 713700, N'金城镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4246, 713702, 713700, N'金湖镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4247, 713703, 713700, N'金沙镇')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4248, 713704, 713700, N'金宁乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4249, 713705, 713700, N'烈屿乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4250, 713706, 713700, N'乌丘乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4251, 713800, 710000, N'连江县')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4252, 713801, 713800, N'南竿乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4253, 713802, 713800, N'北竿乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4254, 713803, 713800, N'莒光乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4255, 713804, 713800, N'东引乡')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4256, 810000, 100000, N'香港特别行政区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4257, 810100, 810000, N'香港岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4258, 810101, 810100, N'中西区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4259, 810102, 810100, N'湾仔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4260, 810103, 810100, N'东区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4261, 810104, 810100, N'南区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4262, 810200, 810000, N'九龙')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4263, 810201, 810200, N'油尖旺区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4264, 810202, 810200, N'深水埗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4265, 810203, 810200, N'九龙城区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4266, 810204, 810200, N'黄大仙区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4267, 810205, 810200, N'观塘区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4268, 810300, 810000, N'新界')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4269, 810301, 810300, N'荃湾区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4270, 810302, 810300, N'屯门区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4271, 810303, 810300, N'元朗区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4272, 810304, 810300, N'北区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4273, 810305, 810300, N'大埔区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4274, 810306, 810300, N'西贡区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4275, 810307, 810300, N'沙田区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4276, 810308, 810300, N'葵青区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4277, 810309, 810300, N'离岛区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4278, 820000, 100000, N'澳门特别行政区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4279, 820100, 820000, N'澳门半岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4280, 820101, 820100, N'花地玛堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4281, 820102, 820100, N'圣安多尼堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4282, 820103, 820100, N'大堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4283, 820104, 820100, N'望德堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4284, 820105, 820100, N'风顺堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4285, 820200, 820000, N'氹仔岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4286, 820201, 820200, N'嘉模堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4287, 820300, 820000, N'路环岛')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4288, 820301, 820300, N'圣方济各堂区')
GO
INSERT [dbo].[Area_List] ([pk_Area], [ID], [ParentID], [Name]) VALUES (4289, 900000, 100000, N'钓鱼岛')
GO
SET IDENTITY_INSERT [dbo].[Area_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Attendance_List] ON 
GO
INSERT [dbo].[Attendance_List] ([pk_Attendance], [fk_User], [fk_Department], [TypeID], [StatusID], [Description], [Note], [IPAddress], [Browser], [SessionID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 1, N'路上塞车，故晚到', N'', N'127.0.0.1', N'Chrome 31.0', N'ike11qcike2rhl4dxc4ksln0', 0, 1, CAST(N'2015-10-06T10:44:33.000' AS DateTime), 1, CAST(N'2015-10-06T10:57:36.000' AS DateTime))
GO
INSERT [dbo].[Attendance_List] ([pk_Attendance], [fk_User], [fk_Department], [TypeID], [StatusID], [Description], [Note], [IPAddress], [Browser], [SessionID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 1, 0, N'', N'', N'127.0.0.1', N'Chrome 31.0', N'zewryztzpwqvcg0upmyn100f', 0, 1, CAST(N'2015-10-06T23:10:37.000' AS DateTime), 0, CAST(N'2015-10-06T23:10:37.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Attendance_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Building_List] ON 
GO
INSERT [dbo].[Building_List] ([pk_Building], [fk_Community], [fk_User], [fk_Department], [Number], [Name], [Unit], [Owners], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, N'BD20210901152849', N'501-1', N'一单元', N'100', N'', N'', 1, CAST(N'2021-09-01T15:28:49.000' AS DateTime), 1, CAST(N'2021-09-03T22:04:37.000' AS DateTime))
GO
INSERT [dbo].[Building_List] ([pk_Building], [fk_Community], [fk_User], [fk_Department], [Number], [Name], [Unit], [Owners], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 1, N'BD20210901153911', N'501-2', N'二单元', N'100', N'', N'', 1, CAST(N'2021-09-01T15:39:11.000' AS DateTime), 1, CAST(N'2021-09-03T21:55:28.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Building_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Calendar_List] ON 
GO
INSERT [dbo].[Calendar_List] ([pk_Calendar], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsRemind], [AdvancedTime], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'平安夜倒数晚会', N'各部门负责人请安排一个节目，到时有抽奖环节！', N'', N'', N'', N'3|2', N'', N'', N'', CAST(N'2015-12-24T22:05:00.000' AS DateTime), CAST(N'2015-12-24T23:05:00.000' AS DateTime), 0, 0, 0, 1, CAST(N'2015-12-02T22:06:44.000' AS DateTime), 0, CAST(N'2015-12-02T22:06:44.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Calendar_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Car_List] ON 
GO
INSERT [dbo].[Car_List] ([pk_Car], [fk_User], [fk_Department], [fk_Set], [NumberID], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [IsCheck], [CheckUser], [CheckDate], [CheckDepartment], [StartDate], [EndDate], [Driver], [Passengers], [Destination], [Mileage], [IsBack], [BackDate]) VALUES (1, 1, 1, 1, N'20180422132944543815', 2, 1, N'接待陈副市长', N'接到陈副市长到我司进行考察', N'同意', N'', N'', 1, CAST(N'2018-04-22T13:29:44.000' AS DateTime), 2, CAST(N'2018-04-22T14:47:10.000' AS DateTime), 1, 2, CAST(N'2018-04-22T14:47:10.000' AS DateTime), 2, CAST(N'2018-04-22T00:00:00.000' AS DateTime), CAST(N'2018-04-22T23:59:00.000' AS DateTime), N'张三', N'', N'深圳', N'5000公里', 1, CAST(N'2018-04-22T14:51:38.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Car_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Car_Set] ON 
GO
INSERT [dbo].[Car_Set] ([pk_Set], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [BuyDate], [IsUse], [Mileage], [LastMaintenance]) VALUES (1, 0, 0, N'奔驰S级S 320【粤A 88888】', N'接待专用车', N'加98号汽油', N'Car/2018042212535888941470.jpg', N'', CAST(N'2017-06-20T00:00:00.000' AS DateTime), 1, N'5000公里', CAST(N'2018-04-01T00:00:00.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Car_Set] OFF
GO
SET IDENTITY_INSERT [dbo].[Community_List] ON 
GO
INSERT [dbo].[Community_List] ([pk_Community], [fk_User], [fk_Department], [Number], [Name], [Address], [Area], [Developers], [EstateCompany], [GreeningRate], [Buildings], [Owners], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, N'CM20210901100334', N'东海花园', N'深圳南山一路', N'10000', N'魔方地产', N'魔方物业', N'68', N'20', N'3000', N'', N'', 1, CAST(N'2021-08-31T22:32:21.000' AS DateTime), 1, CAST(N'2021-09-03T22:05:01.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Community_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Complain_List] ON 
GO
INSERT [dbo].[Complain_List] ([pk_Complain], [fk_Community], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [Name], [Contact], [ImagePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 0, 0, N'地库有垃圾', N'501栋楼下有垃圾', N'', N'赵武', N'18987598278', N'', 1, CAST(N'2021-09-11T08:16:45.000' AS DateTime), 1, CAST(N'2021-09-11T08:17:18.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Complain_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Customer_Follow] ON 
GO
INSERT [dbo].[Customer_Follow] ([pk_Follow], [fk_Customer], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [FollowDate], [NextFollow], [Remark], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 0, 0, N'跟客户洽谈OA建设问题', N'', CAST(N'2019-05-16T00:00:00.000' AS DateTime), CAST(N'2019-05-19T00:00:00.000' AS DateTime), N'', 1, CAST(N'2019-05-16T20:44:31.000' AS DateTime), 0, CAST(N'2019-05-16T20:44:31.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Customer_Follow] OFF
GO
SET IDENTITY_INSERT [dbo].[Customer_List] ON 
GO
INSERT [dbo].[Customer_List] ([pk_Customer], [fk_User], [fk_Department], [TypeID], [StatusID], [FullName], [ShortName], [CustomerType], [CustomerLevel], [CustomerProperty], [CustomerState], [CustomerSource], [Industry], [Nature], [EmployeNum], [License], [Tags], [Contact], [Website], [Email], [TEL], [Mobile], [Fax], [Wechat], [QQ], [Wangwang], [Weibo], [ZipCode], [Country], [Province], [City], [County], [Address], [Remark], [Description], [ImagePath], [FilePath], [StartDate], [EndDate], [IsStar], [IsAlert], [AlertDate], [AlertInfo], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'魔方动力软件有限公司', N'MFDL', N'合作伙伴', N'5星', N'合作客户', N'已成交', N'客户介绍', N'科技软件', N'民营企业', N'50人', N'', N'软件', N'马云', N'http://www.mojocube.com/', N'4100@qq.com', N'89729668', N'18600186000', N'', N'', N'4100', N'', N'', N'516000', N'中国', N'广东省', N'惠州市', N'惠城区', N'惠州风尚国际', N'', N'', N'', N'', CAST(N'2019-05-16T20:40:46.000' AS DateTime), CAST(N'2020-05-16T00:00:00.000' AS DateTime), 0, 0, CAST(N'2020-05-16T00:00:00.000' AS DateTime), N'', 1, CAST(N'2019-05-16T20:40:46.000' AS DateTime), 1, CAST(N'2019-05-16T20:43:44.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Customer_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Device_List] ON 
GO
INSERT [dbo].[Device_List] ([pk_Device], [fk_Community], [fk_User], [fk_Department], [TypeID], [StatusID], [Number], [Name], [Brand], [Price], [Qty], [BuyDate], [UseTime], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 0, 0, N'DV20210908142657', N'智能垃圾桶', N'海王', CAST(1800.000 AS Decimal(18, 3)), 100, CAST(N'2021-09-08T00:00:00.000' AS DateTime), 10, N'', N'', 1, CAST(N'2021-09-08T14:26:57.000' AS DateTime), 1, CAST(N'2021-09-09T11:48:00.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Device_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Fee_List] ON 
GO
INSERT [dbo].[Fee_List] ([pk_Fee], [fk_Community], [fk_User], [fk_Department], [fk_Owner], [TypeID], [StatusID], [Number], [Name], [Description], [StartDate], [EndDate], [Amount1], [Amount2], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 1, 0, 0, N'FE20210912113943', N'物业费-202109', N'', CAST(N'2021-09-01T00:00:00.000' AS DateTime), CAST(N'2021-09-30T00:00:00.000' AS DateTime), CAST(300.000 AS Decimal(18, 3)), CAST(300.000 AS Decimal(18, 3)), 1, CAST(N'2021-09-12T11:39:43.000' AS DateTime), 1, CAST(N'2021-09-14T15:07:08.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Fee_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Fee_Meter] ON 
GO
INSERT [dbo].[Fee_Meter] ([pk_Meter], [fk_Community], [fk_Building], [fk_House], [fk_Owner], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [ImagePath], [Description], [Degree1], [Degree2], [CheckDate1], [CheckDate2], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 1, 1, 1, 0, 0, N'501108A水表-202109', N'', N'', CAST(128.000 AS Decimal(18, 3)), CAST(236.000 AS Decimal(18, 3)), CAST(N'2021-08-13T00:00:00.000' AS DateTime), CAST(N'2021-09-13T00:00:00.000' AS DateTime), 1, CAST(N'2021-09-13T11:44:27.000' AS DateTime), 1, CAST(N'2021-09-13T11:46:53.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Fee_Meter] OFF
GO
SET IDENTITY_INSERT [dbo].[Finance_Account] ON 
GO
INSERT [dbo].[Finance_Account] ([pk_Account], [fk_User], [fk_Department], [TypeID], [StatusID], [AccountName], [Owner], [Title], [Description], [Note], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'62269988890163', N'张三', N'建行对公账号', N'开户地址：建行珠江新城支行', N'', N'', N'', 1, CAST(N'2018-04-25T11:31:14.000' AS DateTime), 1, CAST(N'2018-04-25T11:35:00.000' AS DateTime))
GO
INSERT [dbo].[Finance_Account] ([pk_Account], [fk_User], [fk_Department], [TypeID], [StatusID], [AccountName], [Owner], [Title], [Description], [Note], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 1, 0, N'13800138000', N'李四', N'公司财务微信账号', N'密码：123456', N'', N'', N'', 1, CAST(N'2018-04-25T11:44:21.000' AS DateTime), 1, CAST(N'2018-04-25T11:45:45.000' AS DateTime))
GO
INSERT [dbo].[Finance_Account] ([pk_Account], [fk_User], [fk_Department], [TypeID], [StatusID], [AccountName], [Owner], [Title], [Description], [Note], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, 1, 1, 2, 0, N'mojocube', N'王五', N'财务支付宝账号', N'密码：123456', N'', N'', N'', 1, CAST(N'2018-04-25T11:45:00.000' AS DateTime), 1, CAST(N'2018-04-25T11:45:48.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Finance_Account] OFF
GO
SET IDENTITY_INSERT [dbo].[Finance_List] ON 
GO
INSERT [dbo].[Finance_List] ([pk_Finance], [fk_User], [fk_Department], [fk_Account], [TypeID], [StatusID], [Title], [Description], [Note], [HandleName], [HandleDate], [Amount], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 3, 1, 0, 1, N'强盛电子货款', N'材料、运费', N'已付清', N'张三', CAST(N'2018-04-25T13:09:00.000' AS DateTime), CAST(500000.0000 AS Decimal(18, 4)), N'', N'', 1, CAST(N'2018-04-25T13:11:25.000' AS DateTime), 1, CAST(N'2018-04-25T16:30:27.000' AS DateTime))
GO
INSERT [dbo].[Finance_List] ([pk_Finance], [fk_User], [fk_Department], [fk_Account], [TypeID], [StatusID], [Title], [Description], [Note], [HandleName], [HandleDate], [Amount], [ImagePath], [FilePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 3, 1, 1, 1, N'购买公务车', N'', N'', N'李四', CAST(N'2018-04-25T13:14:00.000' AS DateTime), CAST(-200000.0000 AS Decimal(18, 4)), N'', N'', 1, CAST(N'2018-04-25T13:15:31.000' AS DateTime), 0, CAST(N'2018-04-25T13:15:31.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Finance_List] OFF
GO
SET IDENTITY_INSERT [dbo].[House_List] ON 
GO
INSERT [dbo].[House_List] ([pk_House], [fk_Community], [fk_Building], [fk_User], [fk_Department], [TypeID], [StatusID], [Number], [Name], [Owner], [Contact], [Floor], [Rooms], [Area1], [Area2], [Fee], [StartDate], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 1, 0, 1, N'HU20210901180112', N'501108A', N'张三', N'13800138000', N'8', N'四室两厅', CAST(0.000 AS Decimal(18, 3)), CAST(0.000 AS Decimal(18, 3)), CAST(0.000 AS Decimal(18, 3)), CAST(N'2021-09-09T00:00:00.000' AS DateTime), N'', N'', 1, CAST(N'2021-09-01T18:01:12.000' AS DateTime), 1, CAST(N'2021-09-02T10:51:02.000' AS DateTime))
GO
INSERT [dbo].[House_List] ([pk_House], [fk_Community], [fk_Building], [fk_User], [fk_Department], [TypeID], [StatusID], [Number], [Name], [Owner], [Contact], [Floor], [Rooms], [Area1], [Area2], [Fee], [StartDate], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 2, 1, 1, 0, 0, N'HU20210914101300', N'501208A', N'李四', N'18600186000', N'2', N'四室两厅', CAST(0.000 AS Decimal(18, 3)), CAST(0.000 AS Decimal(18, 3)), CAST(0.000 AS Decimal(18, 3)), NULL, N'', N'', 1, CAST(N'2021-09-14T10:13:00.000' AS DateTime), 1, CAST(N'2021-09-14T10:13:43.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[House_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Mail_Account] ON 
GO
INSERT [dbo].[Mail_Account] ([pk_Account], [fk_User], [fk_Department], [TypeID], [StatusID], [AccountName], [DisplayName], [PopHost], [Port], [UseSSL], [SmtpHost], [SmtpPort], [LoginName], [Password], [SmtpPwd], [SmtpUser], [SmtpUseSSL], [Signature], [Note], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'客户询问信', N'魔方动力', N'pop3.126.com', 110, 0, N'smtp.163.com', 25, N'mojocube@163.com', N'XiRAJSMhKiYxMjM0NTY=', N'XiRAJSMhKiYxMjM0NTY=', N'mojocube@163.com', 0, N'', N'', 0, 1, CAST(N'2015-10-25T00:16:37.000' AS DateTime), 1, CAST(N'2017-08-09T13:39:21.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Mail_Account] OFF
GO
SET IDENTITY_INSERT [dbo].[Memo_List] ON 
GO
INSERT [dbo].[Memo_List] ([pk_Memo], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [IsStar], [Tags], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, N'', N'如需要获得更多功能和支持，请到魔方动力淘宝旗舰店购买正版软件，网址：https://520mc.taobao.com/', N'', N'', N'', N'', N'', N'', 0, N'', 0, 1, CAST(N'2021-09-14T09:41:23.000' AS DateTime), 0, CAST(N'2021-09-14T09:41:23.000' AS DateTime))
GO
INSERT [dbo].[Memo_List] ([pk_Memo], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [IsStar], [Tags], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 0, 0, N'', N'更多产品请访问魔方动力官方网站：http://www.mojocube.com/', N'', N'', N'', N'', N'', N'', 0, N'', 0, 1, CAST(N'2021-09-14T09:41:36.000' AS DateTime), 0, CAST(N'2021-09-14T09:41:36.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Memo_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Notice_List] ON 
GO
INSERT [dbo].[Notice_List] ([pk_Notice], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsTop], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 1, N'关于年度总结报告', N'请各部门经理做好年终总结报告，以便在年会上发表', N'', N'', N'', N'', N'', N'', N'', CAST(N'2015-10-21T00:00:00.000' AS DateTime), CAST(N'2015-10-28T00:00:00.000' AS DateTime), 0, 0, 1, CAST(N'2015-10-21T23:54:54.000' AS DateTime), 1, CAST(N'2015-10-24T08:42:34.000' AS DateTime))
GO
INSERT [dbo].[Notice_List] ([pk_Notice], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsTop], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 1, 0, N'元旦放假3天', N'请各部门做好节前卫生工作，祝大家元旦快乐', N'', N'', N'', N'', N'', N'', N'', CAST(N'2015-10-22T00:00:00.000' AS DateTime), CAST(N'2015-10-29T00:00:00.000' AS DateTime), 0, 0, 1, CAST(N'2015-10-22T22:06:10.000' AS DateTime), 0, CAST(N'2015-10-22T22:06:10.000' AS DateTime))
GO
INSERT [dbo].[Notice_List] ([pk_Notice], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsTop], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, 1, 1, 1, 2, N'周一上午全体员工会议', N'请各部门同事务必9点到会议室开会，不得迟到！', N'', N'', N'', N'', N'', N'', N'', CAST(N'2015-10-23T00:00:00.000' AS DateTime), CAST(N'2015-10-30T00:00:00.000' AS DateTime), 0, 0, 1, CAST(N'2015-10-23T22:07:38.000' AS DateTime), 0, CAST(N'2015-10-23T22:07:38.000' AS DateTime))
GO
INSERT [dbo].[Notice_List] ([pk_Notice], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsTop], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (4, 2, 2, 1, 0, N'有1个用车需要您审核', N'请到用车审核查看', N'', N'', N'', N'', N'', N'', N'../Car/CheckList.aspx?active=86,89', CAST(N'2018-04-22T13:29:44.000' AS DateTime), CAST(N'2018-04-22T14:29:44.000' AS DateTime), 0, 0, 1, CAST(N'2018-04-22T13:29:44.000' AS DateTime), 0, CAST(N'2018-04-22T13:29:44.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Notice_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Notice_Receiver] ON 
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (1, 1, 1, 1, 0, CAST(N'2015-10-21T23:54:54.000' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (2, 2, 1, 1, 1, CAST(N'2015-10-23T21:18:46.030' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (3, 3, 1, 1, 1, CAST(N'2015-11-20T21:45:16.560' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (4, 1, 2, 2, 0, CAST(N'2015-10-21T23:54:54.000' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (5, 2, 2, 2, 0, CAST(N'2015-10-23T21:18:46.030' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (6, 3, 2, 2, 0, CAST(N'2015-10-23T22:07:38.000' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (7, 1, 3, 3, 1, CAST(N'2015-10-23T22:39:36.577' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (8, 2, 3, 3, 1, CAST(N'2015-10-23T22:39:34.077' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (9, 3, 3, 3, 1, CAST(N'2015-10-23T22:39:31.280' AS DateTime))
GO
INSERT [dbo].[Notice_Receiver] ([pk_Receiver], [fk_Notice], [fk_User], [fk_Department], [IsRead], [ReadDate]) VALUES (10, 4, 2, 2, 1, CAST(N'2018-04-22T14:38:47.223' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Notice_Receiver] OFF
GO
SET IDENTITY_INSERT [dbo].[Owner_Car] ON 
GO
INSERT [dbo].[Owner_Car] ([pk_Car], [fk_User], [fk_Department], [fk_Owner], [fk_Parking], [TypeID], [StatusID], [Number], [Name], [PlateNumber], [Color], [ImagePath], [Description], [StartDate], [EndDate], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 1, 0, 0, N'CA20210907104845', N'奔驰C200L', N'粤A88088', N'白色', N'', N'女司机开', CAST(N'2021-09-07T10:48:45.000' AS DateTime), CAST(N'2031-09-07T10:48:45.000' AS DateTime), 1, CAST(N'2021-09-07T10:48:45.000' AS DateTime), 1, CAST(N'2021-09-07T11:02:05.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Owner_Car] OFF
GO
SET IDENTITY_INSERT [dbo].[Owner_List] ON 
GO
INSERT [dbo].[Owner_List] ([pk_Owner], [fk_User], [fk_Department], [TypeID], [StatusID], [ParentID], [Number], [Name], [Contact], [Sex], [Birthday], [IDNumber], [SocialMedia], [Job], [Address], [ImagePath], [Description], [IsLogin], [Password], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 0, 0, N'OW20210903110851', N'张三', N'13800138000', 0, CAST(N'1988-09-03T00:00:00.000' AS DateTime), N'130827202106261427', N'', N'工程师', N'广东', N'', N'', 0, N'123456', 1, CAST(N'2021-09-03T11:08:51.000' AS DateTime), 1, CAST(N'2021-09-03T22:07:29.000' AS DateTime))
GO
INSERT [dbo].[Owner_List] ([pk_Owner], [fk_User], [fk_Department], [TypeID], [StatusID], [ParentID], [Number], [Name], [Contact], [Sex], [Birthday], [IDNumber], [SocialMedia], [Job], [Address], [ImagePath], [Description], [IsLogin], [Password], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 1, 1, 0, 0, 0, N'OW20210914144240', N'李四', N'18600186000', 0, CAST(N'1983-10-11T00:00:00.000' AS DateTime), N'150430198310110387', N'', N'', N'江苏', N'', N'', 0, N'123456', 1, CAST(N'2021-09-14T14:42:40.000' AS DateTime), 1, CAST(N'2021-09-14T14:47:15.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Owner_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Parking_List] ON 
GO
INSERT [dbo].[Parking_List] ([pk_Parking], [fk_Community], [fk_Building], [fk_User], [fk_Department], [TypeID], [StatusID], [Number], [Name], [Owner], [Contact], [Floor], [Area], [Rent], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 0, 1, 1, 1, 1, N'PK20210902135245', N'A0001', N'张三', N'13800138000', N'-1', CAST(30.000 AS Decimal(18, 3)), CAST(80.000 AS Decimal(18, 3)), N'', N'', 1, CAST(N'2021-09-02T13:52:45.000' AS DateTime), 1, CAST(N'2021-09-08T11:26:06.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Parking_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Process_List] ON 
GO
INSERT [dbo].[Process_List] ([pk_Process], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [IsCheck], [CheckUser], [CheckDate], [CheckDepartment], [AtUser], [Tags], [ParentID]) VALUES (1, 1, 1, 2, 1, N'购买5颗金士顿固态硬盘', N'商品描述：金士顿固态硬盘（128G）
商品价格：299/颗
商品数量：5
购买原因：升级公司电脑硬件，提高工作效率', N'同意，请尽快去办', N'', N'', 0, 1, CAST(N'2015-10-10T10:29:32.000' AS DateTime), 1, CAST(N'2015-10-10T16:31:52.000' AS DateTime), 1, 1, CAST(N'2015-10-10T16:31:52.000' AS DateTime), 1, N'', N'', 0)
GO
INSERT [dbo].[Process_List] ([pk_Process], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [FilePath], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [IsCheck], [CheckUser], [CheckDate], [CheckDepartment], [AtUser], [Tags], [ParentID]) VALUES (2, 1, 1, 2, 1, N'购买5颗金士顿固态硬盘', N'商品描述：金士顿固态硬盘（128G）', N'同意，请尽快去办', N'', N'', 0, 1, CAST(N'2015-10-10T10:29:32.000' AS DateTime), 1, CAST(N'2015-10-10T16:31:52.000' AS DateTime), 1, 1, CAST(N'2015-10-10T16:31:52.000' AS DateTime), 1, N'', N'', 1)
GO
SET IDENTITY_INSERT [dbo].[Process_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Repair_List] ON 
GO
INSERT [dbo].[Repair_List] ([pk_Repair], [fk_Community], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [ImagePath], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 1, 0, 1, N'北一门大门维修', N'', N'', N'', 1, CAST(N'2021-09-10T17:27:55.000' AS DateTime), 1, CAST(N'2021-09-10T17:29:13.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Repair_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Role_List] ON 
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (1, 1, 1, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (2, 1, 2, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (3, 1, 5, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (4, 1, 4, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (5, 1, 6, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (6, 1, 3, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (7, 1, 7, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (8, 1, 8, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (9, 1, 9, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (10, 1, 10, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (11, 1, 11, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (12, 1, 16, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (13, 1, 12, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (14, 1, 13, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (15, 1, 14, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (16, 1, 15, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (17, 1, 17, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (18, 1, 18, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (19, 1, 19, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (20, 1, 20, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (21, 1, 21, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (22, 1, 22, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (23, 1, 23, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (24, 1, 24, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (25, 1, 25, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (26, 1, 26, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (27, 1, 27, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (28, 1, 28, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (29, 1, 29, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (30, 1, 30, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (31, 1, 31, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (32, 1, 32, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (33, 1, 33, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (34, 1, 34, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (35, 1, 35, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (36, 1, 36, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (37, 1, 37, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (38, 1, 38, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (191, 1, 39, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (192, 1, 40, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (193, 1, 41, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (194, 1, 42, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (195, 1, 43, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (196, 1, 44, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (197, 1, 45, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (198, 1, 46, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (199, 1, 47, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (200, 1, 48, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (201, 1, 49, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (202, 1, 50, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (203, 1, 51, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (204, 1, 52, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (205, 1, 53, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (206, 1, 54, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (223, 1, 55, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (224, 1, 56, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (225, 1, 57, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (226, 1, 58, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (227, 1, 59, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (228, 1, 60, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (229, 1, 61, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (230, 1, 62, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (231, 1, 63, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (232, 1, 64, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (233, 1, 65, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (234, 1, 66, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (235, 1, 67, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (236, 1, 68, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (237, 1, 69, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (238, 1, 70, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (239, 1, 71, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (240, 1, 72, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (241, 1, 73, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (242, 1, 74, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (243, 1, 75, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (244, 1, 76, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (245, 1, 77, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (246, 1, 78, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (247, 1, 79, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (248, 1, 80, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (249, 1, 81, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (406, 1, 82, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (411, 1, 83, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (416, 1, 84, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (417, 1, 85, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (418, 1, 86, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (419, 1, 87, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (420, 1, 88, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (421, 1, 89, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (422, 1, 90, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (423, 1, 91, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (424, 1, 92, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (452, 1, 93, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (456, 1, 94, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (457, 1, 95, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (458, 1, 96, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (459, 1, 97, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (460, 1, 98, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (461, 1, 99, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (462, 1, 100, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (463, 1, 101, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (464, 1, 102, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (465, 1, 103, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (466, 1, 104, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (467, 1, 105, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (468, 1, 106, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (469, 1, 107, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (470, 1, 108, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (471, 1, 109, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (472, 1, 110, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (473, 1, 111, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (474, 1, 112, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (475, 1, 113, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (476, 1, 114, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (477, 1, 115, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (478, 1, 116, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (479, 1, 117, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (480, 1, 118, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (481, 1, 119, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (482, 1, 120, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (483, 1, 121, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (484, 1, 122, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (485, 1, 123, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (486, 1, 124, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (487, 1, 125, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (488, 1, 126, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (489, 1, 127, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (490, 1, 128, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (491, 1, 129, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (492, 1, 130, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (493, 1, 131, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (494, 1, 132, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (495, 1, 133, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (496, 1, 134, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (497, 1, 135, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (498, 1, 136, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (499, 1, 137, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (500, 1, 138, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (501, 1, 139, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (502, 1, 140, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (503, 1, 141, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (504, 1, 142, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (505, 1, 143, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (506, 1, 144, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (507, 1, 145, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (508, 1, 146, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (509, 1, 147, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (510, 1, 148, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (511, 1, 149, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (512, 1, 150, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (513, 1, 151, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (514, 1, 152, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (515, 1, 153, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (516, 1, 154, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (517, 1, 155, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (518, 1, 156, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (519, 1, 157, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (520, 1, 158, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (521, 1, 159, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (522, 1, 160, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (523, 1, 161, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (524, 1, 162, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (525, 1, 163, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (526, 1, 164, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (527, 1, 165, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (528, 1, 166, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (529, 1, 167, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (530, 1, 168, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (531, 1, 169, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (532, 1, 170, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (533, 1, 171, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (534, 1, 172, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (535, 1, 173, 1, 0, N'', 0)
GO
INSERT [dbo].[Role_List] ([pk_Role], [fk_RoleName], [fk_Menu], [IsUse], [IsAdmin], [PowerList], [fk_Company]) VALUES (536, 1, 174, 1, 0, N'', 0)
GO
SET IDENTITY_INSERT [dbo].[Role_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Role_Name] ON 
GO
INSERT [dbo].[Role_Name] ([pk_Name], [RoleName_CHS], [RoleName_CHT], [RoleName_EN], [PowerValue], [fk_Company]) VALUES (1, N'超级管理员', N'', N'', 100, 0)
GO
INSERT [dbo].[Role_Name] ([pk_Name], [RoleName_CHS], [RoleName_CHT], [RoleName_EN], [PowerValue], [fk_Company]) VALUES (2, N'小区管理员', N'', N'', 90, 0)
GO
INSERT [dbo].[Role_Name] ([pk_Name], [RoleName_CHS], [RoleName_CHT], [RoleName_EN], [PowerValue], [fk_Company]) VALUES (3, N'小区科组长', N'', N'', 80, 0)
GO
INSERT [dbo].[Role_Name] ([pk_Name], [RoleName_CHS], [RoleName_CHT], [RoleName_EN], [PowerValue], [fk_Company]) VALUES (4, N'小区普通员工', N'', N'', 60, 0)
GO
SET IDENTITY_INSERT [dbo].[Role_Name] OFF
GO
SET IDENTITY_INSERT [dbo].[Shop_List] ON 
GO
INSERT [dbo].[Shop_List] ([pk_Shop], [fk_Community], [fk_Building], [fk_User], [fk_Department], [TypeID], [StatusID], [Number], [Name], [Owner], [Contact], [Floor], [Area1], [Area2], [Fee], [Rent], [ImagePath], [Description], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 0, 1, 1, 3, 2, N'SO20210902110439', N'钱大妈超市', N'李四', N'18600186000', N'1', CAST(300.000 AS Decimal(18, 3)), CAST(260.000 AS Decimal(18, 3)), CAST(2.000 AS Decimal(18, 3)), CAST(10000.000 AS Decimal(18, 3)), N'', N'', 1, CAST(N'2021-09-02T11:04:39.000' AS DateTime), 1, CAST(N'2021-09-14T14:42:16.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Shop_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_Country] ON 
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (1, N'Afghanistan', N'AF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (2, N'Albania', N'AL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (3, N'Armenia', N'AM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (4, N'Cayman Islands', N'KY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (5, N'Liberia', N'LR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (6, N'Sri Lanka', N'LK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (7, N'Central African Republic', N'CF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (8, N'Libyan Arab Jamahiriya', N'LY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (9, N'Sudan', N'SD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (10, N'Chad', N'TD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (11, N'Liechtenstein', N'LI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (12, N'Suriname', N'SR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (13, N'Chile', N'CL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (14, N'Lithuania', N'LT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (15, N'Svalbard and Jan Mayen', N'SJ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (16, N'China', N'CN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (17, N'Luxembourg', N'LU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (18, N'Swaziland', N'SZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (19, N'Christmas Island', N'CX', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (20, N'Macao', N'MO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (21, N'Sweden', N'SE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (22, N'Cocos (Keeling) Islands', N'CC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (23, N'Macedonia', N'MK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (24, N'Switzerland', N'CH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (25, N'Colombia', N'CO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (26, N'Madagascar', N'MG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (27, N'Syrian Arab Republic', N'SY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (28, N'Comoros', N'KM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (29, N'Malawi', N'MW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (30, N'Taiwan', N'TW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (31, N'Congo', N'CG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (32, N'Malaysia', N'MY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (33, N'Tajikistan', N'TJ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (34, N'Congo, the Democratic Republic of the', N'CD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (35, N'Maldives', N'MV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (36, N'Tanzania, United Republic of', N'TZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (37, N'Cook Islands', N'CK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (38, N'Mali', N'ML', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (39, N'Thailand', N'TH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (40, N'Costa Rica', N'CR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (41, N'Malta', N'MT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (42, N'Timor-Leste', N'TL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (43, N'Cote D’Ivoire', N'CI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (44, N'Marshall Islands', N'MH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (45, N'Togo', N'TG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (46, N'Croatia', N'HR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (47, N'Martinique', N'MQ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (48, N'Tokelau', N'TK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (49, N'Cuba', N'CU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (50, N'Mauritania', N'MR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (51, N'Tonga', N'TO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (52, N'Cyprus', N'CY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (53, N'Mauritius', N'MU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (54, N'Trinidad and Tobago', N'TT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (55, N'Czech Republic', N'CZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (56, N'Mayotte', N'YT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (57, N'Tunisia', N'TN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (58, N'Denmark', N'DK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (59, N'Mexico', N'MX', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (60, N'Turkey', N'TR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (61, N'Djibouti', N'DJ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (62, N'Micronesia, Federate States of', N'FM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (63, N'Turkmenistan', N'TM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (64, N'Dominica', N'DM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (65, N'Moldova, Republic of', N'MD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (66, N'Turks and Caicos Islands', N'TC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (67, N'Dominican Republic', N'DO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (68, N'Monaco', N'MC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (69, N'Tuvalu', N'TV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (70, N'Ecuador', N'EC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (71, N'Mongolia', N'MN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (72, N'Uganda', N'UG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (73, N'Egypt', N'EG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (74, N'Montserrat', N'MS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (75, N'Ukraine', N'UA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (76, N'El Salvador', N'SV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (77, N'Morocco', N'MA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (78, N'United Arab Emirates', N'AE.', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (79, N'Equatorial Guinea', N'GQ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (80, N'Mozambique', N'MZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (81, N'United Kingdom', N'GB', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (82, N'Eritrea', N'ER', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (83, N'Myanmar', N'MM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (84, N'United States', N'US', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (85, N'Estonia', N'EE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (86, N'Namibia', N'NA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (87, N'United States Minor Outlying Islands', N'UM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (88, N'Ethiopia', N'ET', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (89, N'Nauru', N'NR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (90, N'Uruguay', N'UY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (91, N'Falkland Islands (Malvinas)', N'FK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (92, N'Nepal', N'NP', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (93, N'Uzbekistan', N'UZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (94, N'Faroe Islands', N'FO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (95, N'Netherlands', N'NL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (96, N'Vanuatu', N'VU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (97, N'Fiji', N'FJ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (98, N'Netherlands Antilles', N'AN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (99, N'Finland', N'FI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (100, N'New Caledonia', N'NC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (101, N'Venezuela', N'VE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (102, N'France', N'FR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (103, N'New Zealand', N'NZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (104, N'Viet Nam', N'VN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (105, N'French Guiana', N'GF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (106, N'Nicaragua', N'NI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (107, N'Virgin Islands, British', N'VG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (108, N'French Polynesia', N'PF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (109, N'Niger', N'NE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (110, N'Wallis and Futuna', N'WF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (111, N'French Southern Territories', N'TF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (112, N'Nigeria', N'NG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (113, N'Western Sahara', N'EH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (114, N'Gabon', N'GA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (115, N'Niue', N'NU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (116, N'Yemen', N'YE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (117, N'Gambia', N'GM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (118, N'Norfolk Island', N'NF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (119, N'Zambia', N'ZM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (120, N'Georgia', N'GE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (121, N'Northern Mariana Islands', N'MP', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (122, N'Zimbabwe', N'ZW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (123, N'Germany', N'DE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (124, N'Norway', N'NO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (125, N'Aland Islands', N'AX', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (126, N'Ghana', N'GH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (127, N'Oman', N'OM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (128, N'Gibraltar', N'GI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (129, N'Pakistan', N'PK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (130, N'Algeria', N'DZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (131, N'Greece', N'GR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (132, N'Palau', N'PW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (133, N'American Samoa', N'AS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (134, N'Greenland', N'GL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (135, N'Palestinian Territory, Occupied', N'PS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (136, N'Andorra', N'AD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (137, N'Grenada', N'GD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (138, N'Panama', N'PA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (139, N'Angola', N'AO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (140, N'Guadeloupe', N'GP', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (141, N'Papua New Guinea', N'PG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (142, N'Anguilla', N'AI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (143, N'Guam', N'GU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (144, N'Paraguay', N'PY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (145, N'Antarctica', N'AQ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (146, N'Guatemala', N'GT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (147, N'Peru', N'PE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (148, N'Antigua and Barbuda', N'AG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (149, N'Guinea', N'GN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (150, N'Philippines', N'PH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (151, N'Argentina', N'AR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (152, N'Guinea-Bissau', N'GW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (153, N'Pitcairn', N'PN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (154, N'Guyana', N'GY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (155, N'Poland', N'PL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (156, N'Aruba', N'AW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (157, N'Haiti', N'HT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (158, N'Portugal', N'PT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (159, N'Australia', N'AU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (160, N'Heard Island and McDonald Islands', N'HM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (161, N'Puerto Rico', N'PR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (162, N'Austria', N'AT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (163, N'Holy See (Vatican City State)', N'VA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (164, N'Qatar', N'QA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (165, N'Azerbaijan', N'AZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (166, N'Honduras', N'HN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (167, N'Reunion', N'RE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (168, N'Bahamas', N'BS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (169, N'Hong Kong', N'HK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (170, N'Romania', N'RO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (171, N'Bahrain', N'BH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (172, N'Hungary', N'HU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (173, N'Russian Federation', N'RU', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (174, N'Bangladesh', N'BD', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (175, N'Iceland', N'IS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (176, N'Rwanda', N'RW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (177, N'Barbados', N'BB', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (178, N'India', N'IN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (179, N'Saint Helena', N'SH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (180, N'Belarus', N'BY', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (181, N'Indonesia', N'ID', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (182, N'Saint Kitts and Nevis', N'KN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (183, N'Belgium', N'BE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (184, N'Iran, Islamic Republic of', N'IR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (185, N'Saint Lucia', N'LC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (186, N'Belize', N'BZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (187, N'Iraq', N'IQ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (188, N'Saint Pierre and Miquelon', N'PM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (189, N'Benin', N'BJ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (190, N'Ireland', N'IE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (191, N'Saint Vincent and the Grenadines', N'VC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (192, N'Bermuda', N'BM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (193, N'Israel', N'IL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (194, N'Samoa', N'WS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (195, N'Bhutan', N'BT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (196, N'Italy', N'IT', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (197, N'San Marino', N'SM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (198, N'Bolivia', N'BO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (199, N'Jamaica', N'JM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (200, N'Sao Tome and Principe', N'ST', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (201, N'Bosnia and Herzegovina', N'BA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (202, N'Japan', N'JP', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (203, N'Saudi Arabia', N'SA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (204, N'Botswana', N'BW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (205, N'Jordan', N'JO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (206, N'Senegal', N'SN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (207, N'Bouvet Island', N'BV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (208, N'Kazakhstan', N'KZ', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (209, N'Serbia and Montenegro', N'CS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (210, N'Brazil', N'BR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (211, N'Kenya', N'KE', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (212, N'Seychelles', N'SC', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (213, N'British Indian Ocean Territory', N'IO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (214, N'Kiribati', N'KI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (215, N'Sierra Leone', N'SL', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (216, N'Brunei Darussalam', N'BN', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (217, N'Korea, Democratic People’s Republic of', N'KP', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (218, N'Singapore', N'SG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (219, N'Bulgaria', N'BG', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (220, N'Korea, Republic of', N'KR', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (221, N'Slovakia', N'SK', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (222, N'Burkina Faso', N'BF', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (223, N'Kuwait', N'KW', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (224, N'Slovenia', N'SI', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (225, N'Cambodia', N'KH', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (226, N'Lao People’s Democratic Republic', N'LA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (227, N'Somalia', N'SO', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (228, N'Cameroon', N'CM', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (229, N'Latvia', N'LV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (230, N'South Africa', N'ZA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (231, N'Canada', N'CA', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (232, N'Lebanon', N'LB', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (233, N'South Georgia and the South Sandwich Islands', N'GS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (234, N'Cape Verde', N'CV', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (235, N'Lesotho', N'LS', 1)
GO
INSERT [dbo].[Sys_Country] ([pk_Country], [FullName], [ShortName], [Visible]) VALUES (236, N'Spain', N'ES', 1)
GO
SET IDENTITY_INSERT [dbo].[Sys_Country] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_Currency] ON 
GO
INSERT [dbo].[Sys_Currency] ([pk_Currency], [C_ID], [C_Sign], [FullName], [ShortName], [Visible]) VALUES (1, 0, N'￥', N'人民币', N'CNY', 1)
GO
INSERT [dbo].[Sys_Currency] ([pk_Currency], [C_ID], [C_Sign], [FullName], [ShortName], [Visible]) VALUES (2, 1, N'$', N'US Dollar', N'USD', 1)
GO
SET IDENTITY_INSERT [dbo].[Sys_Currency] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_Express] ON 
GO
INSERT [dbo].[Sys_Express] ([pk_Express], [FullName], [ShortName], [ImagePath], [Website], [Url], [Freight], [Visible]) VALUES (1, N'顺丰', N'', N'', N'http://www.sf-express.com/', N'http://www.kiees.cn/sf.php?wen=[TrackingNumber]', 30.0000, 1)
GO
INSERT [dbo].[Sys_Express] ([pk_Express], [FullName], [ShortName], [ImagePath], [Website], [Url], [Freight], [Visible]) VALUES (2, N'圆通', N'', N'', N'http://www.yto.net.cn/', N'', 20.0000, 1)
GO
INSERT [dbo].[Sys_Express] ([pk_Express], [FullName], [ShortName], [ImagePath], [Website], [Url], [Freight], [Visible]) VALUES (3, N'申通', N'', N'', N'http://www.sto.cn/', N'', 20.0000, 1)
GO
INSERT [dbo].[Sys_Express] ([pk_Express], [FullName], [ShortName], [ImagePath], [Website], [Url], [Freight], [Visible]) VALUES (4, N'EMS', N'', N'', N'http://www.ems.com.cn/', N'', 20.0000, 1)
GO
INSERT [dbo].[Sys_Express] ([pk_Express], [FullName], [ShortName], [ImagePath], [Website], [Url], [Freight], [Visible]) VALUES (5, N'韵达', N'', N'', N'http://www.yundaex.com/', N'', 20.0000, 1)
GO
SET IDENTITY_INSERT [dbo].[Sys_Express] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_Menu] ON 
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (1, 0, N'系统管理', N'', N'', N'#', N'fa-gears', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (2, 1, N'菜单管理', N'', N'', N'System/Menu.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (4, 1, N'类型管理', N'', N'', N'System/Type.aspx', N'fa-circle-o', 4, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (5, 1, N'菜单编辑', N'', N'', N'System/MenuEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (6, 1, N'类型编辑', N'', N'', N'System/TypeEdit.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (7, 12, N'角色管理', N'', N'', N'Role/Name.aspx', N'fa-circle-o', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (8, 12, N'角色编辑', N'', N'', N'Role/NameEdit.aspx', N'fa-circle-o', 0, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (9, 12, N'角色设定', N'', N'', N'Role/List.aspx', N'fa-circle-o', 0, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (10, 0, N'系统首页', N'', N'', N'#', N'fa-circle-o', -1, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (11, 10, N'控制面板', N'', N'', N'Dashboard/Default.aspx', N'fa-circle-o', 1, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (12, 0, N'用户管理', N'', N'', N'#', N'fa-users', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (13, 12, N'部门管理', N'', N'', N'User/Department.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (14, 12, N'职位管理', N'', N'', N'User/Position.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (15, 12, N'用户管理', N'', N'', N'User/List.aspx', N'fa-circle-o', 5, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (16, 1, N'菜单图标', N'', N'', N'Skins/Icons.aspx', N'fa-circle-o', 3, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (17, 12, N'部门编辑', N'', N'', N'User/DepartmentEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (18, 12, N'职位编辑', N'', N'', N'User/PositionEdit.aspx', N'fa-circle-o', 4, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (19, 12, N'用户编辑', N'', N'', N'User/Edit.aspx', N'fa-circle-o', 6, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (20, 12, N'用户面板', N'', N'', N'User/Profile.aspx', N'fa-circle-o', 7, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (21, 1, N'状态管理', N'', N'', N'System/Status.aspx', N'fa-circle-o', 6, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (22, 1, N'状态编辑', N'', N'', N'System/StatusEdit.aspx', N'fa-circle-o', 7, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (23, 0, N'考勤管理', N'', N'', N'#', N'fa-clock-o', 4, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (24, 23, N'考勤管理', N'', N'', N'Attendance/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (25, 23, N'考勤编辑', N'', N'', N'Attendance/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (26, 23, N'考勤周报表', N'', N'', N'Attendance/Report_W.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (27, 23, N'考勤月报表', N'', N'', N'Attendance/Report_M.aspx', N'fa-circle-o', 4, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (28, 23, N'考勤审核', N'', N'', N'Attendance/Check.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (29, 0, N'流程管理', N'', N'', N'#', N'fa-hourglass-half', 5, 0, 0, 0, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (30, 29, N'流程管理', N'', N'', N'Process/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (31, 29, N'流程编辑', N'', N'', N'Process/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (32, 29, N'流程审核', N'', N'', N'Process/CheckList.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (33, 29, N'流程审核', N'', N'', N'Process/Check.aspx', N'fa-circle-o', 4, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (34, 0, N'公告通知', N'', N'', N'#', N'fa-bell-o', 6, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (35, 34, N'通知管理', N'', N'', N'Notice/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (36, 34, N'通知编辑', N'', N'', N'Notice/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (37, 34, N'通知列表', N'', N'', N'Notice/ViewList.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (38, 34, N'通知查看', N'', N'', N'Notice/View.aspx', N'fa-circle-o', 4, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (39, 0, N'邮件管理', N'', N'', N'#', N'fa-envelope-o', 7, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (40, 39, N'账号管理', N'', N'', N'Mail/Account.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (41, 39, N'账号编辑', N'', N'', N'Mail/AccountEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (42, 39, N'邮件管理', N'', N'', N'Mail/List.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (43, 39, N'邮件编辑', N'', N'', N'Mail/Edit.aspx', N'fa-circle-o', 4, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (44, 39, N'邮件查看', N'', N'', N'Mail/View.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (45, 39, N'通讯录', N'', N'', N'Mail/Address.aspx', N'fa-circle-o', 6, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (46, 0, N'任务管理', N'', N'', N'#', N'fa-flag-o', 8, 0, 0, 1, N'我的任务', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (47, 46, N'任务管理', N'', N'', N'Task/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (48, 46, N'任务编辑', N'', N'', N'Task/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (49, 46, N'任务接收', N'', N'', N'Task/Receiver.aspx', N'fa-circle-o', 3, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (50, 46, N'我的任务', N'', N'', N'Task/ViewList.aspx', N'fa-circle-o', 4, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (51, 46, N'任务查看', N'', N'', N'Task/View.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (52, 0, N'日程管理', N'', N'', N'#', N'fa-calendar', 9, 0, 0, 1, N'我的日历', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (53, 52, N'日程管理', N'', N'', N'Calendar/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (54, 52, N'日程编辑', N'', N'', N'Calendar/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (55, 52, N'我的日历', N'', N'', N'Calendar/Month.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (56, 52, N'日历接收', N'', N'', N'Calendar/Receiver.aspx', N'fa-circle-o', 4, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (57, 52, N'日历查看', N'', N'', N'Calendar/View.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (58, 0, N'工作计划', N'', N'', N'#', N'fa-calendar-check-o', 10, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (59, 58, N'计划管理', N'', N'', N'Plan/List.aspx', N'fa-circle-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (60, 58, N'计划编辑', N'', N'', N'Plan/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (61, 58, N'计划报表', N'', N'', N'Plan/Report.aspx', N'fa-circle-o', 3, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (62, 0, N'系统工具', N'', N'', N'#', N'fa-desktop', 11, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (63, 62, N'文件管理', N'', N'', N'Document/List.aspx', N'fa-folder-open-o', 1, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (64, 62, N'文件编辑', N'', N'', N'Document/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (65, 62, N'文件接收', N'', N'', N'Document/Receiver.aspx', N'fa-circle-o', 3, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (67, 62, N'笔记管理', N'', N'', N'Note/List.aspx', N'fa-pencil-square-o', 4, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (68, 62, N'笔记编辑', N'', N'', N'Note/Edit.aspx', N'fa-circle-o', 5, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (69, 62, N'笔记接收', N'', N'', N'Note/Receiver.aspx', N'fa-circle-o', 6, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (70, 62, N'笔记查看', N'', N'', N'Note/View.aspx', N'fa-circle-o', 7, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (72, 62, N'通讯录', N'', N'', N'Address/List.aspx', N'fa-phone', 8, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (73, 62, N'通讯录编辑', N'', N'', N'Address/Edit.aspx', N'fa-circle-o', 9, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (74, 62, N'通讯录接收', N'', N'', N'Address/Receiver.aspx', N'fa-circle-o', 10, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (75, 62, N'通讯录查看', N'', N'', N'Address/View.aspx', N'fa-circle-o', 11, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (77, 62, N'讨论区', N'', N'', N'Forum/List.aspx', N'fa-comments-o', 12, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (78, 62, N'讨论区编辑', N'', N'', N'Forum/Edit.aspx', N'fa-circle-o', 13, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (79, 62, N'讨论区接收', N'', N'', N'Forum/Receiver.aspx', N'fa-circle-o', 14, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (80, 62, N'讨论区查看', N'', N'', N'Forum/View.aspx', N'fa-circle-o', 15, 0, 1, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (81, 12, N'在线用户', N'', N'', N'User/Online.aspx', N'fa-circle-o', 8, 0, 0, 1, NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (82, 12, N'历史记录', N'', N'', N'User/History.aspx', N'fa-circle-o', 9, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (83, 29, N'流程通知', N'', N'', N'Process/Receiver.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (84, 29, N'流程汇总', N'', N'', N'Process/ViewList.aspx', N'fa-circle-o', 6, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (85, 29, N'汇总查看', N'', N'', N'Process/View.aspx', N'fa-circle-o', 7, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (86, 0, N'车辆管理', N'', N'', N'#', N'fa-car', 13, 0, 0, 0, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (87, 86, N'用车管理', N'', N'', N'Car/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (88, 86, N'用车编辑', N'', N'', N'Car/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (89, 86, N'用车审核', N'', N'', N'Car/CheckList.aspx', N'fa-circle-o', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (90, 86, N'审核编辑', N'', N'', N'Car/Check.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (91, 86, N'车辆管理', N'', N'', N'Car/SetList.aspx', N'fa-circle-o', 6, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (92, 86, N'车辆编辑', N'', N'', N'Car/Set.aspx', N'fa-circle-o', 7, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (93, 86, N'用车通知', N'', N'', N'Car/Receiver.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (94, 0, N'财务管理', N'', N'', N'#', N'fa-cny', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (95, 94, N'账号管理', N'', N'', N'Finance/Account.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (96, 94, N'账号编辑', N'', N'', N'Finance/AccountEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (97, 94, N'财务管理', N'', N'', N'Finance/List.aspx', N'fa-circle-o', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (98, 94, N'财务编辑', N'', N'', N'Finance/Edit.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (99, 94, N'财务报表', N'', N'', N'Finance/Report.aspx', N'fa-circle-o', 5, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (100, 0, N'工作管理', N'', N'', N'#', N'fa-sitemap', 2, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (101, 100, N'模板管理', N'', N'', N'Workflow/Template.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (102, 100, N'模板编辑', N'', N'', N'Workflow/TemplateEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (103, 100, N'步骤管理', N'', N'', N'Workflow/Step.aspx', N'fa-circle-o', 3, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (104, 100, N'步骤编辑', N'', N'', N'Workflow/StepEdit.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (105, 100, N'签章管理', N'', N'', N'Workflow/Signature.aspx', N'fa-circle-o', 5, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (106, 100, N'签章编辑', N'', N'', N'Workflow/SignatureEdit.aspx', N'fa-circle-o', 6, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (107, 100, N'签章列表', N'', N'', N'Workflow/Sign.aspx', N'fa-circle-o', 7, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (108, 100, N'我的工作', N'', N'', N'Workflow/List.aspx', N'fa-circle-o', 8, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (109, 100, N'工作编辑', N'', N'', N'Workflow/Edit.aspx', N'fa-circle-o', 9, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (110, 100, N'我的审批', N'', N'', N'Workflow/CheckList.aspx', N'fa-circle-o', 10, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (111, 100, N'审批编辑', N'', N'', N'Workflow/Check.aspx', N'fa-circle-o', 11, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (112, 100, N'我的抄送', N'', N'', N'Workflow/ViewList.aspx', N'fa-circle-o', 12, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (113, 100, N'工作查看', N'', N'', N'Workflow/View.aspx', N'fa-circle-o', 13, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (114, 100, N'归档工作', N'', N'', N'Workflow/Complete.aspx', N'fa-circle-o', 14, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (115, 100, N'选择审批人', N'', N'', N'Workflow/Checker.aspx', N'fa-circle-o', 15, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (116, 100, N'审批人列表', N'', N'', N'Workflow/Receiver.aspx', N'fa-circle-o', 16, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (117, 100, N'抄送人列表', N'', N'', N'Workflow/Notify.aspx', N'fa-circle-o', 17, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (118, 100, N'上传附件', N'', N'', N'Workflow/Upload.aspx', N'fa-circle-o', 18, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (119, 100, N'修改记录', N'', N'', N'Workflow/Log.aspx', N'fa-circle-o', 19, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (120, 100, N'流程图', N'', N'', N'Workflow/FlowChart.aspx', N'fa-circle-o', 20, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (121, 0, N'客户管理', N'', N'', N'#', N'fa-user', 3, 0, 0, 0, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (122, 121, N'客户管理', N'', N'', N'Customer/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (123, 121, N'客户编辑', N'', N'', N'Customer/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (124, 121, N'客户跟进', N'', N'', N'Customer/Follow.aspx', N'fa-circle-o', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (125, 121, N'跟进编辑', N'', N'', N'Customer/FollowEdit.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (126, 121, N'查找客户', N'', N'', N'Customer/Search.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (127, 121, N'客户联系人', N'', N'', N'Customer/Contact.aspx', N'fa-circle-o', 6, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (128, 121, N'联系人编辑', N'', N'', N'Customer/ContactEdit.aspx', N'fa-circle-o', 7, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (129, 121, N'客户报表', N'', N'', N'Customer/Report.aspx', N'fa-circle-o', 8, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (130, 0, N'小区管理', N'', N'', N'#', N'fa-map-marker', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (131, 130, N'小区管理', N'', N'', N'Community/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (132, 130, N'小区编辑', N'', N'', N'Community/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (133, 130, N'小区管理员', N'', N'', N'Community/Receiver.aspx', N'fa-circle-o', 3, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (134, 0, N'房产管理', N'', N'', N'#', N'fa-home', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (135, 134, N'楼栋管理', N'', N'', N'Building/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (136, 134, N'楼栋编辑', N'', N'', N'Building/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (137, 134, N'楼栋管理员', N'', N'', N'Building/Receiver.aspx', N'fa-circle-o', 3, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (138, 134, N'房屋管理', N'', N'', N'House/List.aspx', N'fa-circle-o', 4, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (139, 134, N'房屋编辑', N'', N'', N'House/Edit.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (140, 134, N'商铺管理', N'', N'', N'Shop/List.aspx', N'fa-circle-o', 6, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (141, 134, N'商铺编辑', N'', N'', N'Shop/Edit.aspx', N'fa-circle-o', 7, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (142, 134, N'车位管理', N'', N'', N'Parking/List.aspx', N'fa-circle-o', 8, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (143, 134, N'车位编辑', N'', N'', N'Parking/Edit.aspx', N'fa-circle-o', 9, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (144, 0, N'业主管理', N'', N'', N'#', N'fa-user', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (145, 144, N'人员管理', N'', N'', N'Owner/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (146, 144, N'人员编辑', N'', N'', N'Owner/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (147, 144, N'关联人员', N'', N'', N'Owner/Receiver.aspx', N'fa-circle-o', 3, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (148, 144, N'车辆管理', N'', N'', N'Owner/Car.aspx', N'fa-circle-o', 4, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (149, 144, N'车辆编辑', N'', N'', N'Owner/CarEdit.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (150, 144, N'关联车位', N'', N'', N'Owner/Parking.aspx', N'fa-circle-o', 6, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (151, 0, N'资产管理', N'', N'', N'#', N'fa-gavel', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (152, 151, N'设备管理', N'', N'', N'Device/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (153, 151, N'设备编辑', N'', N'', N'Device/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (154, 0, N'服务管理', N'', N'', N'#', N'fa-coffee', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (155, 154, N'活动管理', N'', N'', N'Activity/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (156, 154, N'活动编辑', N'', N'', N'Activity/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (157, 154, N'维修管理', N'', N'', N'Repair/List.aspx', N'fa-circle-o', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (158, 154, N'维修编辑', N'', N'', N'Repair/Edit.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (159, 154, N'投诉管理', N'', N'', N'Complain/List.aspx', N'fa-circle-o', 5, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (160, 154, N'投诉编辑', N'', N'', N'Complain/Edit.aspx', N'fa-circle-o', 6, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (161, 0, N'费用管理', N'', N'', N'#', N'fa-dollar', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (162, 161, N'收费管理', N'', N'', N'Fee/List.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (163, 161, N'收费编辑', N'', N'', N'Fee/Edit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (164, 161, N'抄表管理', N'', N'', N'Fee/Meter.aspx', N'fa-circle-o', 4, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (165, 161, N'抄表编辑', N'', N'', N'Fee/MeterEdit.aspx', N'fa-circle-o', 5, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (166, 0, N'疫情防控', N'', N'', N'#', N'fa-medkit', 0, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (167, 166, N'进门管理', N'', N'', N'Epidemic/In.aspx', N'fa-circle-o', 1, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (168, 166, N'进门编辑', N'', N'', N'Epidemic/InEdit.aspx', N'fa-circle-o', 2, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (169, 166, N'出门管理', N'', N'', N'Epidemic/Out.aspx', N'fa-circle-o', 3, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (170, 166, N'出门编辑', N'', N'', N'Epidemic/OutEdit.aspx', N'fa-circle-o', 4, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (171, 166, N'外来管理', N'', N'', N'Epidemic/Foreign.aspx', N'fa-circle-o', 5, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (172, 166, N'外来编辑', N'', N'', N'Epidemic/ForeignEdit.aspx', N'fa-circle-o', 6, 0, 1, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (173, 166, N'轨迹报表', N'', N'', N'Epidemic/Report.aspx', N'fa-circle-o', 7, 0, 0, 1, N'', N'', N'')
GO
INSERT [dbo].[Sys_Menu] ([pk_Menu], [ParentID], [Name_CHS], [Name_CHT], [Name_EN], [Url], [Icon], [SortID], [LevelID], [TypeID], [Visible], [Tag_CHS], [Tag_CHT], [Tag_EN]) VALUES (174, 161, N'收费查看', N'', N'', N'Fee/View.aspx', N'fa-circle-o', 3, 0, 1, 1, N'', N'', N'')
GO
SET IDENTITY_INSERT [dbo].[Sys_Menu] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_Province] ON 
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (1, 16, N'北京市', N'北京', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (2, 16, N'天津市', N'天津', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (3, 16, N'上海市', N'上海', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (4, 16, N'重庆市', N'重庆', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (5, 16, N'广东省', N'广东', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (6, 16, N'湖南省', N'湖南', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (7, 16, N'湖北省', N'湖北', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (8, 16, N'浙江省', N'浙江', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (9, 16, N'江西省', N'江西', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (10, 16, N'江苏省', N'江苏', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (11, 16, N'福建省', N'福建', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (12, 16, N'甘肃省', N'甘肃', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (13, 16, N'贵州省', N'贵州', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (14, 16, N'云南省', N'云南', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (15, 16, N'海南省', N'海南', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (16, 16, N'四川省', N'四川', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (17, 16, N'河北省', N'河北', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (18, 16, N'河南省', N'河南', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (19, 16, N'山东省', N'山东', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (20, 16, N'山西省', N'山西', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (21, 16, N'陕西省', N'陕西', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (22, 16, N'青海省', N'青海', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (23, 16, N'辽宁省', N'辽宁', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (24, 16, N'吉林省', N'吉林', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (25, 16, N'黑龙江省', N'黑龙江', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (26, 16, N'广西壮族自治区', N'广西', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (27, 16, N'宁夏回族自治区', N'宁夏', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (28, 16, N'内蒙古自治区', N'内蒙古', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (29, 16, N'西藏自治区', N'西藏', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (30, 16, N'新疆维吾尔自治区', N'新疆', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (31, 16, N'香港特别行政区', N'香港', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (32, 16, N'澳门特别行政区', N'澳门', 1)
GO
INSERT [dbo].[Sys_Province] ([pk_Province], [fk_Country], [FullName], [ShortName], [Visible]) VALUES (33, 16, N'台湾省', N'台湾', 1)
GO
SET IDENTITY_INSERT [dbo].[Sys_Province] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_StatusID] ON 
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (1, N'正常', N'', N'', 0, N'#00C0EF', N'Attendance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (2, N'迟到', N'', N'', 1, N'#DD4B39', N'Attendance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (3, N'早退', N'', N'', 2, N'#DD4B39', N'Attendance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (4, N'旷工', N'', N'', 3, N'#DD4B39', N'Attendance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (5, N'处理中', N'', N'', 0, N'#F39C12', N'Process_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (6, N'已批准', N'', N'', 1, N'#00A65A', N'Process_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (7, N'一般', N'', N'', 0, N'#00C0EF', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (8, N'重要', N'', N'', 1, N'#F39C12', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (9, N'紧急', N'', N'', 2, N'#DD4B39', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (10, N'有效', N'', N'', 0, N'#00A65A', N'Mail_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (11, N'无效', N'', N'', 1, N'#D2D6DE', N'Mail_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (12, N'一般', N'', N'', 0, N'#00C0EF', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (13, N'重要', N'', N'', 1, N'#F39C12', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (14, N'紧急', N'', N'', 2, N'#DD4B39', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (15, N'新任务', N'', N'', 0, N'#F39C12', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (16, N'已接收', N'', N'', 1, N'#00C0EF', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (17, N'进行中', N'', N'', 2, N'#3C8DBC', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (18, N'已完成', N'', N'', 3, N'#00A65A', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (19, N'一般', N'', N'', 0, N'#00C0EF', N'Calendar_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (20, N'重要', N'', N'', 1, N'#F39C12', N'Calendar_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (21, N'紧急', N'', N'', 2, N'#DD4B39', N'Calendar_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (22, N'未完成', N'', N'', 0, N'#00C0EF', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (23, N'已完成', N'', N'', 1, N'#00A65A', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (24, N'已取消', N'', N'', 2, N'#999999', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (25, N'一般', N'', N'', 0, N'#00C0EF', N'Document_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (26, N'重要', N'', N'', 1, N'#F39C12', N'Document_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (27, N'一般', N'', N'', 0, N'#00C0EF', N'Note_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (28, N'重要', N'', N'', 1, N'#F39C12', N'Note_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (29, N'一般', N'', N'', 0, N'#00C0EF', N'Address_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (30, N'重要', N'', N'', 1, N'#F39C12', N'Address_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (31, N'一般', N'', N'', 0, N'#00C0EF', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (32, N'重要', N'', N'', 1, N'#F39C12', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (33, N'紧急', N'', N'', 2, N'#DD4B39', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (34, N'未批准', N'', N'', 2, N'#999999', N'Process_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (35, N'申请中', N'', N'', 0, N'#F39C12', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (36, N'已批准', N'', N'', 1, N'#00A65A', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (37, N'未批准', N'', N'', 2, N'#999999', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (38, N'可使用', N'', N'', 0, N'#00A65A', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (39, N'使用中', N'', N'', 1, N'#F39C12', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (40, N'保养中', N'', N'', 2, N'#999999', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (41, N'已报废', N'', N'', 3, N'#DD4B39', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (42, N'有效', N'', N'', 0, N'#00A65A', N'Finance_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (43, N'无效', N'', N'', 1, N'#D2D6DE', N'Finance_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (44, N'待定', N'', N'', 0, N'#999999', N'Finance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (45, N'有效', N'', N'', 1, N'#00A65A', N'Finance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (46, N'无效', N'', N'', 2, N'#D2D6DE', N'Finance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (47, N'新工作', N'', N'', 0, N'#F39C12', N'Workflow_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (48, N'进行中', N'', N'', 1, N'#00C0EF', N'Workflow_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (49, N'已通过', N'', N'', 2, N'#00A65A', N'Workflow_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (50, N'未通过', N'', N'', 3, N'#DD4B39', N'Workflow_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (51, N'已取消', N'', N'', 4, N'#999999', N'Workflow_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (52, N'待审批', N'', N'', 0, N'#F39C12', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (53, N'已同意', N'', N'', 1, N'#00A65A', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (54, N'不同意', N'', N'', 2, N'#DD4B39', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (55, N'已撤回', N'', N'', 3, N'#999999', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (56, N'已退回', N'', N'', 4, N'#999999', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (57, N'有效', N'', N'', 0, N'#00A65A', N'Customer_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (58, N'无效', N'', N'', 1, N'#D2D6DE', N'Customer_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (59, N'新跟进', N'', N'', 0, N'#F39C12', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (60, N'进行中', N'', N'', 1, N'#00C0EF', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (61, N'已完成', N'', N'', 2, N'#00A65A', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (62, N'已取消', N'', N'', 3, N'#999999', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (63, N'未入住', N'', N'', 0, N'#00C0EF', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (64, N'装修中', N'', N'', 1, N'#F39C12', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (65, N'已入住', N'', N'', 2, N'#00A65A', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (66, N'闲置中', N'', N'', 3, N'#D2D6DE', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (67, N'未出售', N'', N'', 0, N'#00C0EF', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (68, N'已出售', N'', N'', 1, N'#00A65A', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (69, N'已出租', N'', N'', 2, N'#3C8DBC', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (70, N'闲置中', N'', N'', 3, N'#D2D6DE', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (71, N'待出售', N'', N'', 0, N'#00C0EF', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (72, N'已出售', N'', N'', 1, N'#00A65A', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (73, N'待出租', N'', N'', 2, N'#3C8DBC', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (74, N'已出租', N'', N'', 3, N'#F39C12', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (75, N'有效', N'', N'', 0, N'#00A65A', N'Owner_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (76, N'无效', N'', N'', 1, N'#D2D6DE', N'Owner_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (77, N'有效', N'', N'', 0, N'#00A65A', N'Owner_Car', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (78, N'无效', N'', N'', 1, N'#D2D6DE', N'Owner_Car', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (79, N'有效', N'', N'', 0, N'#00A65A', N'Activity_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (80, N'无效', N'', N'', 1, N'#999999', N'Activity_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (81, N'待受理', N'', N'', 0, N'#00C0EF', N'Repair_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (82, N'已受理', N'', N'', 1, N'#F39C12', N'Repair_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (83, N'已完成', N'', N'', 2, N'#00A65A', N'Repair_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (84, N'投诉中', N'', N'', 0, N'#F39C12', N'Complain_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (85, N'已处理', N'', N'', 1, N'#00A65A', N'Complain_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (86, N'未收', N'', N'', 0, N'#00C0EF', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (87, N'已收', N'', N'', 1, N'#00A65A', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (88, N'已通过', N'', N'', 0, N'#00A65A', N'Epidemic_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_StatusID] ([pk_StatusID], [StatusName_CHS], [StatusName_CHT], [StatusName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (89, N'已拒绝', N'', N'', 1, N'#DD4B39', N'Epidemic_List', N'', N'', N'')
GO
SET IDENTITY_INSERT [dbo].[Sys_StatusID] OFF
GO
SET IDENTITY_INSERT [dbo].[Sys_TypeID] ON 
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (1, N'菜单', N'', N'', 0, N'#008000', N'Sys_Menu', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (2, N'页面', NULL, NULL, 1, N'#999999', N'Sys_Menu', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (3, N'上班', N'', N'', 0, N'', N'Attendance_List', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (4, N'下班', N'', N'', 1, N'', N'Attendance_List', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (5, N'外出', N'', N'', 2, N'', N'Attendance_List', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (6, N'请假', N'', N'', 3, N'', N'Attendance_List', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (7, N'加班', N'', N'', 4, N'', N'Attendance_List', NULL, NULL, NULL)
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (8, N'请假', N'', N'', 0, N'', N'Process_List', N'请假时间：
请假原因：', N'2|3', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (9, N'加班', N'', N'', 1, N'', N'Process_List', N'加班时间：
加班原因：', N'2|3', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (10, N'报销', N'', N'', 2, N'', N'Process_List', N'商品描述：
商品价格：
商品数量：
购买原因：', N'2|3', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (11, N'出差', N'', N'', 3, N'', N'Process_List', N'出差时间：
出差原因：', N'2|3', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (12, N'公告', N'', N'', 0, N'', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (13, N'通知', N'', N'', 1, N'', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (14, N'投票', N'', N'', 2, N'', N'Notice_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (15, N'系统邮件', N'', N'', 0, N'', N'Mail_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (16, N'公司邮件', N'', N'', 1, N'', N'Mail_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (17, N'邮件', N'', N'', 0, N'', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (18, N'通知', N'', N'', 1, N'', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (19, N'公告', N'', N'', 2, N'red', N'Mail_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (20, N'公事', N'', N'', 0, N'', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (21, N'私事', N'', N'', 1, N'', N'Task_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (22, N'日程提醒', N'', N'', 0, N'', N'Calendar_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (23, N'假日安排', N'', N'', 1, N'', N'Calendar_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (24, N'日计划', N'', N'', 0, N'', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (25, N'周计划', N'', N'', 1, N'', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (26, N'月计划', N'', N'', 2, N'', N'Plan_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (27, N'我的文件', N'', N'', 0, N'', N'Document_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (28, N'公司文件', N'', N'', 1, N'', N'Document_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (29, N'共享文件', N'', N'', 2, N'', N'Document_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (30, N'我的笔记', N'', N'', 0, N'', N'Note_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (31, N'公司笔记', N'', N'', 1, N'', N'Note_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (32, N'共享笔记', N'', N'', 2, N'', N'Note_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (33, N'我的通讯录', N'', N'', 0, N'', N'Address_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (34, N'公司通讯录', N'', N'', 1, N'', N'Address_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (35, N'共享通讯录', N'', N'', 2, N'', N'Address_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (36, N'讨论', N'', N'', 0, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (37, N'公告', N'', N'', 1, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (38, N'投票', N'', N'', 2, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (39, N'活动', N'', N'', 3, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (40, N'业务', N'', N'', 4, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (41, N'下载', N'', N'', 5, N'', N'Forum_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (42, N'手动', N'', N'', 0, N'', N'User_Online', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (43, N'自动', N'', N'', 1, N'', N'User_Online', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (44, N'办事', N'', N'', 0, N'', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (45, N'出差', N'', N'', 1, N'', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (46, N'接待', N'', N'', 2, N'', N'Car_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (47, N'小车', N'', N'', 0, N'', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (48, N'商务车', N'', N'', 1, N'', N'Car_Set', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (49, N'银联', N'', N'', 0, N'', N'Finance_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (50, N'微信', N'', N'', 1, N'', N'Finance_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (51, N'支付宝', N'', N'', 2, N'', N'Finance_Account', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (52, N'收入', N'', N'', 0, N'', N'Finance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (53, N'支出', N'', N'', 1, N'', N'Finance_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (54, N'一般', N'', N'', 0, N'#00A65A', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (55, N'紧急', N'', N'', 1, N'#F39C12', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (56, N'严重', N'', N'', 2, N'#DD4B39', N'Workflow_Receiver', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (57, N'公章', N'', N'', 0, N'', N'Workflow_Signature', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (58, N'私章', N'', N'', 1, N'', N'Workflow_Signature', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (59, N'私有', N'', N'', 0, N'', N'Customer_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (60, N'公开', N'', N'', 1, N'', N'Customer_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (61, N'电话', N'', N'', 0, N'', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (62, N'邮件', N'', N'', 1, N'', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (63, N'信息', N'', N'', 2, N'', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (64, N'拜访', N'', N'', 3, N'', N'Customer_Follow', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (65, N'住宅', N'', N'', 0, N'', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (66, N'办公', N'', N'', 1, N'', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (67, N'宿舍', N'', N'', 2, N'', N'House_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (68, N'百货', N'', N'', 0, N'', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (69, N'餐饮', N'', N'', 1, N'', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (70, N'驿站', N'', N'', 2, N'', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (71, N'生鲜', N'', N'', 3, N'', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (72, N'其他', N'', N'', 4, N'', N'Shop_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (73, N'普通车位', N'', N'', 0, N'', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (74, N'子母车位', N'', N'', 1, N'', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (75, N'豪华车位', N'', N'', 2, N'', N'Parking_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (76, N'业主', N'', N'', 0, N'', N'Owner_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (77, N'成员', N'', N'', 1, N'', N'Owner_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (78, N'租户', N'', N'', 2, N'', N'Owner_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (79, N'小车', N'', N'', 0, N'', N'Owner_Car', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (80, N'电动车', N'', N'', 1, N'', N'Owner_Car', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (81, N'货车', N'', N'', 2, N'', N'Owner_Car', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (82, N'线下', N'', N'', 0, N'', N'Activity_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (83, N'线上', N'', N'', 1, N'', N'Activity_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (84, N'物业费', N'', N'', 0, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (85, N'停车费', N'', N'', 1, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (86, N'燃气费', N'', N'', 2, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (87, N'水费', N'', N'', 3, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (88, N'电费', N'', N'', 4, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (89, N'维修费', N'', N'', 5, N'', N'Fee_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (90, N'水表', N'', N'', 0, N'', N'Fee_Meter', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (91, N'电表', N'', N'', 1, N'', N'Fee_Meter', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (92, N'燃气表', N'', N'', 2, N'', N'Fee_Meter', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (93, N'进门登记', N'', N'', 0, N'', N'Epidemic_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (94, N'出门登记', N'', N'', 1, N'', N'Epidemic_List', N'', N'', N'')
GO
INSERT [dbo].[Sys_TypeID] ([pk_TypeID], [TypeName_CHS], [TypeName_CHT], [TypeName_EN], [ID], [Visual], [TableName], [Description_CHS], [Description_CHT], [Description_EN]) VALUES (95, N'外来人员', N'', N'', 2, N'', N'Epidemic_List', N'', N'', N'')
GO
SET IDENTITY_INSERT [dbo].[Sys_TypeID] OFF
GO
SET IDENTITY_INSERT [dbo].[Task_List] ON 
GO
INSERT [dbo].[Task_List] ([pk_Task], [fk_User], [fk_Department], [TypeID], [StatusID], [Title], [Description], [Note], [Feedback], [ImagePath], [FilePath], [UserList], [DepartmentList], [RoleList], [Url], [StartDate], [EndDate], [IsComplete], [CompleteDate], [IsCancel], [CancelDate], [IsTop], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 1, 1, 0, 3, N'财务科工资报表制作', N'1. 列出更部门员工具体工资
2. 打印员工具体考勤情况
3. 打印银行流水账，盖上公章', N'【盖茨】【盖茨】', N'朱丽叶<span style="font-size:8pt; color:#999; margin-left:3px;">[2015-11-24 23:22]</span>：将状态改为【已接收】
朱丽叶<span style="font-size:8pt; color:#999; margin-left:3px;">[2015-11-25 23:13]</span>：请问离职的员工也需要做进报表吗？
盖茨<span style="font-size:8pt; color:#999; margin-left:3px;">[2015-11-25 23:14]</span>：是的，离职员工也做进报表，谢谢！
', N'', N'', N'3|2|1', N'', N'', N'', CAST(N'2015-11-24T00:00:00.000' AS DateTime), CAST(N'2015-12-24T00:00:00.000' AS DateTime), 0, CAST(N'2015-11-24T23:17:10.000' AS DateTime), 0, CAST(N'2015-11-24T23:17:10.000' AS DateTime), 0, 0, 1, CAST(N'2015-11-24T23:17:10.000' AS DateTime), 1, CAST(N'2017-08-09T13:36:23.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Task_List] OFF
GO
SET IDENTITY_INSERT [dbo].[Task_Receiver] ON 
GO
INSERT [dbo].[Task_Receiver] ([pk_Receiver], [fk_Task], [fk_User], [fk_Department], [IsRead], [ReadDate], [IsReceive], [ReceiveDate], [StatusID]) VALUES (1, 1, 3, 3, 1, CAST(N'2015-11-24T23:17:24.000' AS DateTime), 1, CAST(N'2015-11-24T23:22:24.000' AS DateTime), 1)
GO
INSERT [dbo].[Task_Receiver] ([pk_Receiver], [fk_Task], [fk_User], [fk_Department], [IsRead], [ReadDate], [IsReceive], [ReceiveDate], [StatusID]) VALUES (2, 1, 2, 2, 0, CAST(N'2017-08-09T13:36:04.000' AS DateTime), 0, CAST(N'2017-08-09T13:36:04.000' AS DateTime), 0)
GO
INSERT [dbo].[Task_Receiver] ([pk_Receiver], [fk_Task], [fk_User], [fk_Department], [IsRead], [ReadDate], [IsReceive], [ReceiveDate], [StatusID]) VALUES (3, 1, 1, 1, 0, CAST(N'2017-08-09T13:36:04.000' AS DateTime), 0, CAST(N'2017-08-09T13:36:04.000' AS DateTime), 0)
GO
SET IDENTITY_INSERT [dbo].[Task_Receiver] OFF
GO
SET IDENTITY_INSERT [dbo].[User_Department] ON 
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (1, N'总部', N'88888888', N'', N'88888888', N'hq@mojocube.com', N'中国广东', 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2015-09-26T11:16:47.000' AS DateTime), 1, CAST(N'2021-08-31T17:26:53.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (2, N'办公室', N'88888881', N'', N'88888881', N'office@mojocube.com', N'中国广东', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2015-09-26T11:19:06.000' AS DateTime), 1, CAST(N'2021-08-31T17:27:01.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (3, N'财务科', N'88888882', N'', N'88888882', N'finance@mojocube.com', N'中国广东', 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2015-09-26T11:20:42.000' AS DateTime), 1, CAST(N'2015-10-04T23:41:00.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (4, N'保安科', N'88888883', N'', N'', N'', N'', 1, 1, 3, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2021-08-31T17:29:14.000' AS DateTime), 1, CAST(N'2021-08-31T17:29:40.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (5, N'水电科', N'88888884', N'', N'', N'', N'', 1, 1, 4, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2021-08-31T17:30:07.000' AS DateTime), 0, CAST(N'2021-08-31T17:30:07.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
INSERT [dbo].[User_Department] ([pk_Department], [DepartmentName], [Phone1], [Phone2], [Fax], [Email], [Address], [ParentID], [LevelID], [SortID], [TypeID], [Province], [City], [County], [Zone], [Manager], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate], [Monday], [Tuesday], [Wednesday], [Thursday], [Friday], [Saturday], [Sunday]) VALUES (6, N'保洁科', N'88888885', N'', N'', N'', N'', 1, 1, 5, 0, 0, 0, 0, 0, 0, 0, 1, CAST(N'2021-08-31T17:31:08.000' AS DateTime), 0, CAST(N'2021-08-31T17:31:08.000' AS DateTime), N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'08:00-12:00|14:00-18:00', N'', N'')
GO
SET IDENTITY_INSERT [dbo].[User_Department] OFF
GO
SET IDENTITY_INSERT [dbo].[User_List] ON 
GO
INSERT [dbo].[User_List] ([pk_User], [UserName], [Password], [TypeID], [fk_Department], [RoleValue], [RoleList], [Position], [Number], [Skin], [Language], [IsLock], [LastLoginIP], [LastLoginTime], [NickName], [FullName], [FirstName], [MiddleName], [LastName], [Phone1], [Phone2], [Email1], [Email2], [Fax], [Line], [Wechat], [QQ], [Facebook], [Twitter], [Linkedin], [ZipCode], [Place], [Address1], [Address2], [Province], [City], [County], [Zone], [Sex], [Height], [Weight], [Birthday], [Education], [School], [ImagePath1], [ImagePath2], [IDCardPath], [ResumePath], [Wages], [BankAccount], [IDNumber], [Source], [Note], [Remark], [EntryTime], [IsQuit], [QuitTime], [ShowHistory], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, N'admin', N'21232f297a57a5a743894a0e4a801fc3', 0, 1, 1, N'1', 1, N'', N'blue', N'CHS', 0, N'::1', CAST(N'2021-08-31T17:08:29.247' AS DateTime), N'Administrator', N'盖茨', N'茨', N'', N'盖', N'13800138000', N'18600186000', N'gates@mojocube.com', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'广东省广州市天河区', N'', 0, 0, 0, 0, 0, 0, 0, CAST(N'1983-06-11T00:00:00.000' AS DateTime), N'本科', N'哈佛大学', N'User/1/2015102321215926568945.jpg', N'', N'', N'', CAST(3000.000 AS Decimal(18, 3)), N'（工行）88088800008020', N'441891198801082910', N'', N'天生我材必有用', N'<i class="fa fa-circle text-success"></i> 在线', CAST(N'2015-06-11T00:00:00.000' AS DateTime), 0, CAST(N'2015-06-11T21:24:07.000' AS DateTime), 10, 0, 1, CAST(N'2015-06-11T21:24:07.000' AS DateTime), 1, CAST(N'2021-08-31T17:08:29.250' AS DateTime))
GO
INSERT [dbo].[User_List] ([pk_User], [UserName], [Password], [TypeID], [fk_Department], [RoleValue], [RoleList], [Position], [Number], [Skin], [Language], [IsLock], [LastLoginIP], [LastLoginTime], [NickName], [FullName], [FirstName], [MiddleName], [LastName], [Phone1], [Phone2], [Email1], [Email2], [Fax], [Line], [Wechat], [QQ], [Facebook], [Twitter], [Linkedin], [ZipCode], [Place], [Address1], [Address2], [Province], [City], [County], [Zone], [Sex], [Height], [Weight], [Birthday], [Education], [School], [ImagePath1], [ImagePath2], [IDCardPath], [ResumePath], [Wages], [BankAccount], [IDNumber], [Source], [Note], [Remark], [EntryTime], [IsQuit], [QuitTime], [ShowHistory], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, N'romeo', N'e10adc3949ba59abbe56e057f20f883e', 0, 2, 2, N'2', 2, N'', N'green', N'CHS', 0, N'::1', CAST(N'2018-04-22T14:46:10.063' AS DateTime), N'Romeo', N'罗密欧', N'密欧', N'', N'罗', N'18600186000', N'', N'romeo@mojocube.com', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'广东省广州市天河区', N'', 0, 0, 0, 0, 0, 0, 0, CAST(N'1990-10-23T00:00:00.000' AS DateTime), N'本科', N'北京大学', N'User/2/2015102322505278126894.jpg', N'', N'', N'', CAST(8000.000 AS Decimal(18, 3)), N'（工行）', N'441891198801082911', N'', N'', N'<i class="fa fa-circle text-success"></i> 在线', CAST(N'2015-10-23T00:00:00.000' AS DateTime), 0, CAST(N'2015-10-23T22:17:06.000' AS DateTime), 10, 0, 1, CAST(N'2015-10-23T22:17:06.000' AS DateTime), 1, CAST(N'2018-04-22T14:46:10.070' AS DateTime))
GO
INSERT [dbo].[User_List] ([pk_User], [UserName], [Password], [TypeID], [fk_Department], [RoleValue], [RoleList], [Position], [Number], [Skin], [Language], [IsLock], [LastLoginIP], [LastLoginTime], [NickName], [FullName], [FirstName], [MiddleName], [LastName], [Phone1], [Phone2], [Email1], [Email2], [Fax], [Line], [Wechat], [QQ], [Facebook], [Twitter], [Linkedin], [ZipCode], [Place], [Address1], [Address2], [Province], [City], [County], [Zone], [Sex], [Height], [Weight], [Birthday], [Education], [School], [ImagePath1], [ImagePath2], [IDCardPath], [ResumePath], [Wages], [BankAccount], [IDNumber], [Source], [Note], [Remark], [EntryTime], [IsQuit], [QuitTime], [ShowHistory], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, N'juliet', N'e10adc3949ba59abbe56e057f20f883e', 0, 3, 3, N'3', 6, N'', N'purple', N'CHS', 0, N'127.0.0.1', CAST(N'2015-11-25T23:12:50.000' AS DateTime), N'Juliet', N'朱丽叶', N'丽叶', N'', N'朱', N'15868886888', N'', N'Juliet@mojocube.com', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'', N'广东省广州市天河区', N'', 0, 0, 0, 0, 1, 0, 0, CAST(N'1992-08-01T00:00:00.000' AS DateTime), N'本科', N'中央财经大学', N'User/3/2015102322511228129536.jpg', N'', N'', N'', CAST(6000.000 AS Decimal(18, 3)), N'（工行）', N'441891198801082912', N'', N'', N'', CAST(N'2015-10-23T00:00:00.000' AS DateTime), 0, CAST(N'2015-10-23T22:21:45.000' AS DateTime), 10, 0, 1, CAST(N'2015-10-23T22:21:45.000' AS DateTime), 1, CAST(N'2021-08-31T17:21:56.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[User_List] OFF
GO
SET IDENTITY_INSERT [dbo].[User_Online] ON 
GO
INSERT [dbo].[User_Online] ([pk_Online], [fk_User], [SessionID], [IPAddress], [Browser], [TypeID], [LoginTime], [fk_Company]) VALUES (33, 1, N'zia5jdd3sqnlo1x4245rzwh4', N'::1', N'Chrome 72.0', 0, CAST(N'2019-03-09T09:47:03.517' AS DateTime), 0)
GO
INSERT [dbo].[User_Online] ([pk_Online], [fk_User], [SessionID], [IPAddress], [Browser], [TypeID], [LoginTime], [fk_Company]) VALUES (34, 1, N'2bpes1fkjvn0aaim0n310nin', N'::1', N'Chrome 92.0', 0, CAST(N'2021-08-31T10:04:32.180' AS DateTime), 0)
GO
INSERT [dbo].[User_Online] ([pk_Online], [fk_User], [SessionID], [IPAddress], [Browser], [TypeID], [LoginTime], [fk_Company]) VALUES (35, 1, N'hnl0gdzh5jtquazug5bht142', N'::1', N'Chrome 92.0', 0, CAST(N'2021-08-31T15:30:52.907' AS DateTime), 0)
GO
INSERT [dbo].[User_Online] ([pk_Online], [fk_User], [SessionID], [IPAddress], [Browser], [TypeID], [LoginTime], [fk_Company]) VALUES (36, 1, N'ffh3rdylg20n3xvmviqvgyxv', N'::1', N'Chrome 92.0', 0, CAST(N'2021-08-31T16:21:21.333' AS DateTime), 0)
GO
INSERT [dbo].[User_Online] ([pk_Online], [fk_User], [SessionID], [IPAddress], [Browser], [TypeID], [LoginTime], [fk_Company]) VALUES (37, 1, N'ffh3rdylg20n3xvmviqvgyxv', N'::1', N'Chrome 92.0', 0, CAST(N'2021-08-31T17:08:29.247' AS DateTime), 0)
GO
SET IDENTITY_INSERT [dbo].[User_Online] OFF
GO
SET IDENTITY_INSERT [dbo].[User_Position] ON 
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, N'管理员', 0, 1, 0, 0, 1, CAST(N'2015-09-26T23:03:12.000' AS DateTime), 1, CAST(N'2021-08-31T17:23:17.000' AS DateTime))
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, N'总经理', 0, 2, 0, 0, 1, CAST(N'2015-09-26T23:04:23.000' AS DateTime), 0, CAST(N'2015-09-26T23:04:23.000' AS DateTime))
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, N'副总经理', 0, 3, 0, 0, 1, CAST(N'2015-09-26T23:04:35.000' AS DateTime), 0, CAST(N'2015-09-26T23:04:35.000' AS DateTime))
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (4, N'科长', 0, 4, 0, 0, 1, CAST(N'2015-09-26T23:04:52.000' AS DateTime), 1, CAST(N'2021-08-31T17:23:56.000' AS DateTime))
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (5, N'组长', 0, 5, 0, 0, 1, CAST(N'2015-09-26T23:05:23.000' AS DateTime), 1, CAST(N'2021-08-31T17:27:43.000' AS DateTime))
GO
INSERT [dbo].[User_Position] ([pk_Position], [Title], [ParentID], [LevelID], [SortID], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (6, N'职员', 0, 6, 0, 0, 1, CAST(N'2015-09-26T23:05:46.000' AS DateTime), 1, CAST(N'2021-08-31T17:25:10.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[User_Position] OFF
GO
SET IDENTITY_INSERT [dbo].[Workflow_Step] ON 
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, 4, N'3|2|1', N'', N'', N'部门审批', N'', 1, 0, 0, 1, CAST(N'2019-03-09T00:10:30.000' AS DateTime), 0, CAST(N'2019-03-09T00:10:30.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, 4, N'1', N'', N'', N'人事审批', N'', 2, 0, 0, 1, CAST(N'2019-03-09T00:11:15.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:15.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, 4, N'1', N'', N'', N'总监审批', N'', 3, 0, 0, 1, CAST(N'2019-03-09T00:11:35.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:35.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (4, 5, N'3|2|1', N'', N'', N'部门审批', N'', 1, 0, 0, 1, CAST(N'2019-03-09T00:10:30.000' AS DateTime), 0, CAST(N'2019-03-09T00:10:30.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (5, 5, N'1', N'', N'', N'人事审批', N'', 2, 0, 0, 1, CAST(N'2019-03-09T00:11:15.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:15.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (6, 5, N'1', N'', N'', N'总监审批', N'', 3, 0, 0, 1, CAST(N'2019-03-09T00:11:35.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:35.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (7, 6, N'3|2|1', N'', N'', N'部门审批', N'', 1, 0, 0, 1, CAST(N'2019-03-09T00:10:30.000' AS DateTime), 0, CAST(N'2019-03-09T00:10:30.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (8, 6, N'1', N'', N'', N'财务审批', N'', 2, 0, 0, 1, CAST(N'2019-03-09T00:11:15.000' AS DateTime), 1, CAST(N'2019-03-09T00:14:56.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (9, 6, N'1', N'', N'', N'总监审批', N'', 3, 0, 0, 1, CAST(N'2019-03-09T00:11:35.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:35.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (10, 7, N'3|2|1', N'', N'', N'部门审批', N'', 1, 0, 0, 1, CAST(N'2019-03-09T00:10:30.000' AS DateTime), 0, CAST(N'2019-03-09T00:10:30.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (11, 7, N'1', N'', N'', N'人事审批', N'', 2, 0, 0, 1, CAST(N'2019-03-09T00:11:15.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:15.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Step] ([pk_Step], [fk_Template], [UserList], [DepartmentList], [RoleList], [Title], [Description], [SortID], [IsCounterSign], [fk_Company], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (12, 7, N'1', N'', N'', N'总监审批', N'', 3, 0, 0, 1, CAST(N'2019-03-09T00:11:35.000' AS DateTime), 0, CAST(N'2019-03-09T00:11:35.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Workflow_Step] OFF
GO
SET IDENTITY_INSERT [dbo].[Workflow_Template] ON 
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (1, N'公文', N'', N'', N'', N'', 0, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:26.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:26.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (2, N'财务', N'', N'', N'', N'', 0, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:41.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:41.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (3, N'人事', N'', N'', N'', N'', 0, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:51.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:51.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (4, N'收文', N'', N'', N'', N'<div style="text-align:center;">
	<h2>
		公文收文示例
	</h2>
	<table align="center" style="width:600px;text-align:center;">
		<tbody>
			<tr>
				<td style="height:50px;text-align:left;">
					魔方动力（2019）8 号
				</td>
				<td style="text-align:right;width:50%;">
					签发人：张三
				</td>
			</tr>
		</tbody>
	</table>
	<div style="width:600px;border-top:solid 3px #ff0000;height:3px;margin:0 auto;">
	</div>
	<div style="width:600px;margin:0 auto;font-size:16pt;padding:20px 10px 10px;">
		关于魔方动力OA办公管理系统
	</div>
	<div style="width:600px;padding:10px;line-height:1.8em;text-align:left;margin:0 auto;">
		魔方动力（MojoCube）基于网络，专注于网页设计和网站程序开发。已经开发一系列网站管理程序，如McCMS内容管理系统、McCart购物车系统。系统界面清新， 兼容性强，可扩展性十分强大，可以开发出目前所见的绝大部分网站，适合企业建站自用或者开发者二次开发。目前已支持Access和Mssql数据库，最新版的内容管理系统和购物车系统均支持响应式和HTML5。 我们是一支年轻富有活力的团队，拥有多年网络开发经验。我们了解当前最新最流行的开发模式，对主流的网页设计、系统设计有较深入的了解。 我们是创业团队，热衷帮助中小企业实现网络信息化。相对于同行大型软件公司，我们经营成本相对较低，所以我们拥有较高的性价比优势，更适合中小企业。 魔方动力产品包括内容管理系统（McCMS）、购物车系统（McCart）、办公管理系统等等，我们并不是软件的代理商或者二次开发商，我们具备完整的开发能力。
            魔方动力是什么？
            魔方动力（MojoCube）从事网站系统开发逾10年，积累了很多宝贵的经验，自主研发了一套简单而强大的系统。产品包括内容管理系统（CMS）、购物车系统（eCommerce）、办公管理系统（OA）。
	</div>
	<table align="center" style="width:600px;text-align:center;">
		<tbody>
			<tr>
				<td style="height:60px;text-align:right;">
					盖章：
				</td>
				<td style="text-align:center;width:50%;">
				</td>
			</tr>
		</tbody>
	</table>
</div>', 1, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:51.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:51.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (5, N'发文', N'', N'', N'', N'<div style="text-align:center;">
	<h2>
		公文发文示例
	</h2>
	<table align="center" style="width:600px;text-align:center;">
		<tbody>
			<tr>
				<td style="height:50px;text-align:left;">
					魔方动力（2019）8 号
				</td>
				<td style="text-align:right;width:50%;">
					签发人：张三
				</td>
			</tr>
		</tbody>
	</table>
	<div style="width:600px;border-top:solid 3px #ff0000;height:3px;margin:0 auto;">
	</div>
	<div style="width:600px;margin:0 auto;font-size:16pt;padding:20px 10px 10px;">
		关于魔方动力OA办公管理系统
	</div>
	<div style="width:600px;padding:10px;line-height:1.8em;text-align:left;margin:0 auto;">
		魔方动力（MojoCube）基于网络，专注于网页设计和网站程序开发。已经开发一系列网站管理程序，如McCMS内容管理系统、McCart购物车系统。系统界面清新， 兼容性强，可扩展性十分强大，可以开发出目前所见的绝大部分网站，适合企业建站自用或者开发者二次开发。目前已支持Access和Mssql数据库，最新版的内容管理系统和购物车系统均支持响应式和HTML5。 我们是一支年轻富有活力的团队，拥有多年网络开发经验。我们了解当前最新最流行的开发模式，对主流的网页设计、系统设计有较深入的了解。 我们是创业团队，热衷帮助中小企业实现网络信息化。相对于同行大型软件公司，我们经营成本相对较低，所以我们拥有较高的性价比优势，更适合中小企业。 魔方动力产品包括内容管理系统（McCMS）、购物车系统（McCart）、办公管理系统等等，我们并不是软件的代理商或者二次开发商，我们具备完整的开发能力。
            魔方动力是什么？
            魔方动力（MojoCube）从事网站系统开发逾10年，积累了很多宝贵的经验，自主研发了一套简单而强大的系统。产品包括内容管理系统（CMS）、购物车系统（eCommerce）、办公管理系统（OA）。
	</div>
	<table align="center" style="width:600px;text-align:center;">
		<tbody>
			<tr>
				<td style="height:60px;text-align:right;">
					盖章：
				</td>
				<td style="text-align:center;width:50%;">
				</td>
			</tr>
		</tbody>
	</table>
</div>', 1, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:51.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:51.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (6, N'请款', N'', N'', N'', N'<div style="text-align:center;">
	<h2>
		请款申请单示例
	</h2>
	<table align="center" cellpadding="0" cellspacing="0" style="width:600px;text-align:center;border:solid 1px #000;">
		<tbody>
			<tr>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					申请人
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					申请日期
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
			</tr>
			<tr>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					部门
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					金额
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					申请理由
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					部门审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					财务审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					总监审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
		</tbody>
	</table>
</div>', 2, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:51.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:51.000' AS DateTime))
GO
INSERT [dbo].[Workflow_Template] ([pk_Template], [TemplateName], [UserList], [DepartmentList], [RoleList], [Description], [ParentID], [SortID], [Visible], [fk_Company], [IsStepFree], [CreateUser], [CreateDate], [ModifyUser], [ModifyDate]) VALUES (7, N'请假', N'', N'', N'', N'<div style="text-align:center;">
	<h2>
		请假申请单示例
	</h2>
	<table align="center" cellpadding="0" cellspacing="0" style="width:600px;text-align:center;border:solid 1px #000;">
		<tbody>
			<tr>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					申请人
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					申请日期
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
			</tr>
			<tr>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					部门
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
				<td style="height:35px;text-align:center;width:120px;border:solid 1px #000;">
					请假时间
				</td>
				<td style="text-align:center;border:solid 1px #000;width:180px;">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					申请理由
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					部门审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					人事审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
			<tr>
				<td style="height:80px;text-align:center;width:120px;border:solid 1px #000;">
					总监审批
				</td>
				<td style="text-align:center;border:solid 1px #000;" colspan="3">
				</td>
			</tr>
		</tbody>
	</table>
</div>', 3, 0, 1, 0, 0, 1, CAST(N'2019-03-08T23:53:51.000' AS DateTime), 0, CAST(N'2019-03-08T23:53:51.000' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[Workflow_Template] OFF
GO
ALTER TABLE [dbo].[Address_List] ADD  CONSTRAINT [DF_Address_List_IsFolder]  DEFAULT ((0)) FOR [IsFolder]
GO
ALTER TABLE [dbo].[Calendar_List] ADD  CONSTRAINT [DF_Calendar_List_IsTop]  DEFAULT ((0)) FOR [IsRemind]
GO
ALTER TABLE [dbo].[Document_List] ADD  CONSTRAINT [DF_Document_List_IsTop]  DEFAULT ((0)) FOR [IsFolder]
GO
ALTER TABLE [dbo].[Forum_List] ADD  CONSTRAINT [DF_Forum_List_IsFolder]  DEFAULT ((0)) FOR [IsTop]
GO
ALTER TABLE [dbo].[Note_List] ADD  CONSTRAINT [DF_Note_List_IsFolder]  DEFAULT ((0)) FOR [IsFolder]
GO
ALTER TABLE [dbo].[Notice_List] ADD  CONSTRAINT [DF_Notice_List_IsTop]  DEFAULT ((0)) FOR [IsTop]
GO
ALTER TABLE [dbo].[Owner_List] ADD  CONSTRAINT [DF_Owner_List_IsLogin]  DEFAULT ((0)) FOR [IsLogin]
GO
ALTER TABLE [dbo].[Sys_Menu] ADD  CONSTRAINT [DF_Sys_Menu_ParentID]  DEFAULT ((0)) FOR [ParentID]
GO
ALTER TABLE [dbo].[Sys_Menu] ADD  CONSTRAINT [DF_Sys_Menu_SortID]  DEFAULT ((0)) FOR [SortID]
GO
ALTER TABLE [dbo].[Sys_Menu] ADD  CONSTRAINT [DF_Sys_Menu_LevelID]  DEFAULT ((0)) FOR [LevelID]
GO
ALTER TABLE [dbo].[Sys_Menu] ADD  CONSTRAINT [DF_Sys_Menu_Visible]  DEFAULT ((1)) FOR [Visible]
GO
ALTER TABLE [dbo].[Task_List] ADD  CONSTRAINT [DF_Task_List_IsTop]  DEFAULT ((0)) FOR [IsTop]
GO
ALTER TABLE [dbo].[User_List] ADD  CONSTRAINT [DF_User_List_ShowHistory]  DEFAULT ((10)) FOR [ShowHistory]
GO
ALTER TABLE [dbo].[User_Online] ADD  CONSTRAINT [DF_User_Online_TypeID]  DEFAULT ((0)) FOR [TypeID]
GO
/****** Object:  StoredProcedure [dbo].[pagination3]    Script Date: 2021/9/14 15:17:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
Create PROCEDURE [dbo].[pagination3]  --新建存储过程用:CREATE PROCEDURE [dbo].[pagination3]
@tblName varchar(50),         --表名
@strGetFields varchar(5000) = '*',     --字段名(全部字段为*)
@fldName varchar(5000),         --排序字段(必须!支持多字段)
@strWhere varchar(5000) = Null,--条件语句(不用加where)
@pageSize int,                     --每页多少条记录
@pageIndex int = 1 ,             --指定当前为第几页
@OrderType bit=0,           -- 设置排序类型, 非 0 值则降序 
@doCount bit = 0 
as
begin
     Declare @sql nvarchar(4000)    
     --计算总记录数
     if @doCount != 0
		begin
			if (@strWhere='' or @strWhere=NULL)
				set @sql = 'select count(*) as Total from [' + @tblName + ']'
			else
				set @sql = 'select count(*) as Total from [' + @tblName + '] where '+@strWhere
		end      

	else
		begin   
			 if (@strWhere='' or @strWhere=NULL)
				if(@OrderType=1)
					set @sql = 'Select * FROM (select ROW_NUMBER() Over(order by ' + @fldName + ' desc) as rowId,' + @strGetFields + ' from ' + @tblName 
				else
					set @sql = 'Select * FROM (select ROW_NUMBER() Over(order by ' + @fldName + ' asc) as rowId,' + @strGetFields + ' from ' + @tblName 
			 else
				 if(@OrderType=1)
					set @sql = 'Select * FROM (select ROW_NUMBER() Over(order by ' + @fldName + ' desc) as rowId,' + @strGetFields + ' from ' + @tblName + ' where ' + @strWhere    
				else
					set @sql = 'Select * FROM (select ROW_NUMBER() Over(order by ' + @fldName + ' asc) as rowId,' + @strGetFields + ' from ' + @tblName + ' where ' + @strWhere   

			  --处理开始点和结束点
			 Declare @StartRecord int
			 Declare @EndRecord int 
		    
			 set @StartRecord = (@pageIndex-1)*@PageSize + 1
			 set @EndRecord = @StartRecord + @pageSize - 1

			 --继续合成sql语句
			if(@OrderType=1)
				set @Sql = @Sql + ') as ' + @tblName + ' where rowId between ' + Convert(varchar(50),@StartRecord) + ' and ' +   Convert(varchar(50),@EndRecord) + 'order  by '+@fldName+' desc'
			else
				set @Sql = @Sql + ') as ' + @tblName + ' where rowId between ' + Convert(varchar(50),@StartRecord) + ' and ' +   Convert(varchar(50),@EndRecord) + 'order  by '+@fldName+' asc'
		    
		end
end
Exec(@sql)
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'用户ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'fk_User'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'部门ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'fk_Department'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'类型ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'TypeID'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'状态ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'StatusID'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'姓名' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'FullName'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'手机' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'CellPhone'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'身份证号' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'IDNumber'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'车牌号' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'CarNumber'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'家庭地址' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Address'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'性别' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Sex'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'年龄' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Age'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'体温' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'BodyTemp'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'是否带口罩' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'IsMask'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'口罩佩戴情况' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'MaskRemark'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'外出原因' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'WhyOut'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'外出地址' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'OutAddress'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'行动轨迹' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Tracker'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'接触人员信息' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'TouchInfo'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'到访事由' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'WhyIn'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'来源地信息' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'SourceInfo'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'是否健康' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'IsHealth'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'是否到过疫区' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'IsEpidemicArea'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'备注' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Remark'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'IP地址' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'IPAddress'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'令牌' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Token'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'处理人' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'Handle'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'处理时间' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'HandleTime'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'创建人ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'CreateUser'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'创建时间' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'CreateDate'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'修改者ID' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'ModifyUser'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'修改时间' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Epidemic_List', @level2type=N'COLUMN',@level2name=N'ModifyDate'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Activity_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 323
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 307
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Activity_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Activity_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Address_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Address_List_1"
            Begin Extent = 
               Top = 6
               Left = 433
               Bottom = 121
               Right = 587
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 121
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Customer_List"
            Begin Extent = 
               Top = 6
               Left = 625
               Bottom = 126
               Right = 802
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Address_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane2', @value=N' = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Address_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=2 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Address_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Building_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 273
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 282
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Building_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Building_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Calendar_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Calendar_Check'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Calendar_Check'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Calendar_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 194
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 173
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 57
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Calendar_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Calendar_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Car_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 225
               Right = 213
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 251
               Bottom = 225
               Right = 424
            End
            DisplayFlags = 280
            TopColumn = 54
         End
         Begin Table = "View_User_List_1"
            Begin Extent = 
               Top = 78
               Left = 230
               Bottom = 264
               Right = 403
            End
            DisplayFlags = 280
            TopColumn = 9
         End
         Begin Table = "Car_Set"
            Begin Extent = 
               Top = 113
               Left = 806
               Bottom = 233
               Right = 976
            End
            DisplayFlags = 280
            TopColumn = 1
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 33
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      ' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Car_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane2', @value=N'   Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Car_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=2 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Car_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Complain_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 304
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 301
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Complain_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Complain_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Customer_Follow"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 126
               Right = 199
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_List"
            Begin Extent = 
               Top = 6
               Left = 237
               Bottom = 126
               Right = 398
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Customer_List"
            Begin Extent = 
               Top = 6
               Left = 436
               Bottom = 126
               Right = 613
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Customer_Follow'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Customer_Follow'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Customer_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 126
               Right = 215
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_List"
            Begin Extent = 
               Top = 6
               Left = 253
               Bottom = 126
               Right = 414
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Customer_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Customer_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Device_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 276
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 229
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Device_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Device_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Document_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 168
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 187
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 31
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Document_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane2', @value=N'
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Document_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=2 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Document_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 255
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Fee_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 301
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Owner_List"
            Begin Extent = 
               Top = 18
               Left = 492
               Bottom = 272
               Right = 666
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Fee_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Fee_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Fee_Meter"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 334
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 275
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Owner_List"
            Begin Extent = 
               Top = 21
               Left = 486
               Bottom = 264
               Right = 660
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Fee_Meter'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Fee_Meter'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Finance_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 293
               Right = 199
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_Department"
            Begin Extent = 
               Top = 6
               Left = 237
               Bottom = 175
               Right = 410
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Finance_Account"
            Begin Extent = 
               Top = 108
               Left = 223
               Bottom = 307
               Right = 384
            End
            DisplayFlags = 280
            TopColumn = 3
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Finance_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Finance_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Forum_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 121
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Forum_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Forum_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Forum_Vote"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 182
               Right = 172
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Forum_Vote'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Forum_Vote'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "House_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 276
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 263
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Building_List"
            Begin Extent = 
               Top = 108
               Left = 766
               Bottom = 248
               Right = 940
            End
            DisplayFlags = 280
            TopColumn = 4
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_House_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_House_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Role_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 175
               Right = 182
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Sys_Menu"
            Begin Extent = 
               Top = 6
               Left = 220
               Bottom = 188
               Right = 354
            End
            DisplayFlags = 280
            TopColumn = 6
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 22
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Menu'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Menu'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "User_Log"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 190
               Right = 179
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 12
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_MyHistory'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_MyHistory'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Note_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Note_List_1"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 121
               Right = 384
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 422
               Bottom = 121
               Right = 587
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Note_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Note_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Notice_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 191
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 14
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 121
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 60
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 25
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 2700
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Notice_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Notice_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Notice_Receiver"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 181
               Right = 191
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_Notice_List"
            Begin Extent = 
               Top = 6
               Left = 229
               Bottom = 180
               Right = 394
            End
            DisplayFlags = 280
            TopColumn = 9
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 16
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Notice_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Notice_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Owner_Car"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 288
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Owner_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 254
               Right = 424
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Parking_List"
            Begin Extent = 
               Top = 16
               Left = 490
               Bottom = 246
               Right = 664
            End
            DisplayFlags = 280
            TopColumn = 1
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Owner_Car'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Owner_Car'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Parking_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 300
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 300
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Parking_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Parking_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Plan_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 195
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 172
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 57
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 25
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Plan_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Plan_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Process_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 205
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List_1"
            Begin Extent = 
               Top = 6
               Left = 243
               Bottom = 121
               Right = 408
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 446
               Bottom = 121
               Right = 611
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 24
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = ' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Process_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane2', @value=N'1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Process_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=2 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Process_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Repair_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 278
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 264
               Right = 424
            End
            DisplayFlags = 280
            TopColumn = 7
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 40
               Left = 708
               Bottom = 237
               Right = 887
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Repair_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Repair_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Shop_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 289
               Right = 212
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Community_List"
            Begin Extent = 
               Top = 6
               Left = 250
               Bottom = 301
               Right = 429
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Shop_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Shop_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Task_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 194
               Right = 192
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 230
               Bottom = 172
               Right = 395
            End
            DisplayFlags = 280
            TopColumn = 57
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 30
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 1620
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Task_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Task_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Task_Receiver"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 201
               Right = 191
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_Task_List"
            Begin Extent = 
               Top = 6
               Left = 229
               Bottom = 174
               Right = 394
            End
            DisplayFlags = 280
            TopColumn = 10
         End
         Begin Table = "User_List"
            Begin Extent = 
               Top = 6
               Left = 432
               Bottom = 126
               Right = 593
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 17
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Task_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Task_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "User_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 177
               Right = 191
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Role_Name"
            Begin Extent = 
               Top = 110
               Left = 215
               Bottom = 225
               Right = 370
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_Department"
            Begin Extent = 
               Top = 6
               Left = 229
               Bottom = 156
               Right = 394
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_User_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_User_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "User_Online"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 121
               Right = 179
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "View_User_List"
            Begin Extent = 
               Top = 6
               Left = 217
               Bottom = 121
               Right = 382
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_User_Online'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_User_Online'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "Workflow_List"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 263
               Right = 199
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Workflow_Step"
            Begin Extent = 
               Top = 6
               Left = 237
               Bottom = 200
               Right = 399
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "User_List"
            Begin Extent = 
               Top = 38
               Left = 805
               Bottom = 292
               Right = 966
            End
            DisplayFlags = 280
            TopColumn = 4
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 9
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Workflow_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=1 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Workflow_List'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane1', @value=N'[0E232FF0-B466-11cf-A24F-00AA00A3EFFF, 1.00]
Begin DesignProperties = 
   Begin PaneConfigurations = 
      Begin PaneConfiguration = 0
         NumPanes = 4
         Configuration = "(H (1[40] 4[20] 2[20] 3) )"
      End
      Begin PaneConfiguration = 1
         NumPanes = 3
         Configuration = "(H (1 [50] 4 [25] 3))"
      End
      Begin PaneConfiguration = 2
         NumPanes = 3
         Configuration = "(H (1 [50] 2 [25] 3))"
      End
      Begin PaneConfiguration = 3
         NumPanes = 3
         Configuration = "(H (4 [30] 2 [40] 3))"
      End
      Begin PaneConfiguration = 4
         NumPanes = 2
         Configuration = "(H (1 [56] 3))"
      End
      Begin PaneConfiguration = 5
         NumPanes = 2
         Configuration = "(H (2 [66] 3))"
      End
      Begin PaneConfiguration = 6
         NumPanes = 2
         Configuration = "(H (4 [50] 3))"
      End
      Begin PaneConfiguration = 7
         NumPanes = 1
         Configuration = "(V (3))"
      End
      Begin PaneConfiguration = 8
         NumPanes = 3
         Configuration = "(H (1[56] 4[18] 2) )"
      End
      Begin PaneConfiguration = 9
         NumPanes = 2
         Configuration = "(H (1 [75] 4))"
      End
      Begin PaneConfiguration = 10
         NumPanes = 2
         Configuration = "(H (1[66] 2) )"
      End
      Begin PaneConfiguration = 11
         NumPanes = 2
         Configuration = "(H (4 [60] 2))"
      End
      Begin PaneConfiguration = 12
         NumPanes = 1
         Configuration = "(H (1) )"
      End
      Begin PaneConfiguration = 13
         NumPanes = 1
         Configuration = "(V (4))"
      End
      Begin PaneConfiguration = 14
         NumPanes = 1
         Configuration = "(V (2))"
      End
      ActivePaneConfig = 0
   End
   Begin DiagramPane = 
      Begin Origin = 
         Top = 0
         Left = 0
      End
      Begin Tables = 
         Begin Table = "User_List"
            Begin Extent = 
               Top = 42
               Left = 558
               Bottom = 241
               Right = 719
            End
            DisplayFlags = 280
            TopColumn = 9
         End
         Begin Table = "Workflow_List"
            Begin Extent = 
               Top = 6
               Left = 237
               Bottom = 210
               Right = 398
            End
            DisplayFlags = 280
            TopColumn = 10
         End
         Begin Table = "Workflow_Receiver"
            Begin Extent = 
               Top = 6
               Left = 38
               Bottom = 251
               Right = 199
            End
            DisplayFlags = 280
            TopColumn = 0
         End
         Begin Table = "Workflow_Step"
            Begin Extent = 
               Top = 110
               Left = 220
               Bottom = 288
               Right = 382
            End
            DisplayFlags = 280
            TopColumn = 0
         End
      End
   End
   Begin SQLPane = 
   End
   Begin DataPane = 
      Begin ParameterDefaults = ""
      End
      Begin ColumnWidths = 18
         Width = 284
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
         Width = 1500
      End
   End
   Begin CriteriaPane = 
      Begin ColumnWidths = 11
         Column = 1440
         Alias = 900
         Table = 1170
         Output' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Workflow_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPane2', @value=N' = 720
         Append = 1400
         NewValue = 1170
         SortType = 1350
         SortOrder = 1410
         GroupBy = 1350
         Filter = 1350
         Or = 1350
         Or = 1350
         Or = 1350
      End
   End
End
' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Workflow_Receiver'
GO
EXEC sys.sp_addextendedproperty @name=N'MS_DiagramPaneCount', @value=2 , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'VIEW',@level1name=N'View_Workflow_Receiver'
GO
USE [master]
GO
ALTER DATABASE [Estate] SET  READ_WRITE 
GO
